//
// Anfy dialogs
//

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include "callback.h"
#include "support.h"
#include "main.h"
#include "misc.h"

// =========================================================
// Message box functions

void on_dlg_ok (GtkWidget *widget, gpointer user_data)
{
  *((int*)user_data) = 1;
  gtk_main_quit ();
}

void on_msgbox_ok (GtkWidget *widget, gpointer user_data)
{
  *((int*)user_data) = 1;
  gtk_widget_destroy (widget->parent->parent->parent);
}

void dlg_destroy (GtkWidget *widget, gpointer data)
{
  gtk_grab_remove (widget);
  gtk_main_quit ();
}

int message_box (char* text, int yesno)
{
  GtkWidget *dlg, *w, *vbox, *hbox;
  int ret = 0;

  dlg = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (dlg), "Anfy");
  gtk_container_border_width (GTK_CONTAINER (dlg), 10);

  gtk_signal_connect (GTK_OBJECT (dlg), "destroy",
		      GTK_SIGNAL_FUNC (dlg_destroy), NULL);

  vbox = gtk_vbox_new (FALSE, 10);
  gtk_container_add (GTK_CONTAINER (dlg), vbox);
  gtk_widget_show (vbox);

  w = gtk_label_new (text);
  gtk_box_pack_start (GTK_BOX (vbox), w, FALSE, FALSE, 2);
  gtk_label_set_justify (GTK_LABEL (w), GTK_JUSTIFY_LEFT);
  gtk_widget_show (w);

  w = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (vbox), w, FALSE, FALSE, 2);
  gtk_widget_show (w);

  hbox = gtk_hbox_new (TRUE, 10);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 2);
  gtk_widget_show (hbox);

  if (yesno == 0)
  {
    w = gtk_button_new_with_label ("Ok");
    gtk_box_pack_start (GTK_BOX (hbox), w, TRUE, TRUE, 0);
    gtk_signal_connect_object (GTK_OBJECT (w), "clicked",
			       (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (dlg));
    GTK_WIDGET_SET_FLAGS (w, GTK_CAN_DEFAULT);
    gtk_widget_grab_default (w);
    gtk_widget_show (w);
  }
  else
  {
    w = gtk_button_new_with_label ("Yes");
    gtk_box_pack_start (GTK_BOX (hbox), w, TRUE, TRUE, 0);
    gtk_signal_connect (GTK_OBJECT (w), "clicked",
			(GtkSignalFunc) on_msgbox_ok, &ret);
    GTK_WIDGET_SET_FLAGS (w, GTK_CAN_DEFAULT);
    gtk_widget_grab_default (w);
    gtk_widget_show (w);

    w = gtk_button_new_with_label ("No");
    gtk_box_pack_start (GTK_BOX (hbox), w, TRUE, TRUE, 0);
    gtk_signal_connect_object (GTK_OBJECT (w), "clicked",
			       (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (dlg));
    gtk_widget_show (w);
  }

  gtk_widget_show(dlg);
  gtk_grab_add(dlg);
  gtk_main ();
  //  gtk_grab_remove(dlg);
  //  gtk_widget_destroy(dlg);

  return ret;
}

void file_browse (char* caption, char** filename)
{
  GtkWidget* dlg;
  int ret = 0;

  dlg = gtk_file_selection_new (caption);
  gtk_widget_show(dlg);
  gtk_grab_add(dlg);
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (dlg)->ok_button),
		      "clicked", (GtkSignalFunc)on_dlg_ok, &ret);
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (dlg)->cancel_button),
			     "clicked", (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (dlg));
  gtk_main ();

  if (ret == 1)
    *filename = g_strdup (gtk_file_selection_get_filename (GTK_FILE_SELECTION (dlg)));
  else
    *filename = NULL;

  gtk_grab_remove(dlg);
  gtk_widget_destroy(dlg);
}

static void info_dlg_link (GtkWidget *widget, gpointer user_data)
{
  if (current_applet == APPLET_ANFY3D)
  {
    StartBrowser(_("http://www.anfyteam.com/panfy3d.html"));
  }
  /*
  else
    if(m_strApplet == _T("STEP1"))
      ShowHelp(TOPIC_INSTRUCTION);
    else
      if(m_strApplet == APPLET_0)
        {
	  strLink.LoadString(IDS_HOMEPAGE);
	  StartBrowser(strLink, m_hWnd);
        }
  */
}

void info_dlg (char* text, char* textlink, char* caption)
{
  GtkWidget *dlg, *hbox, *w, *link;
  GtkStyle *style;
  GdkCursor *cursor;
  const GdkColor LBLUE = {0, 0x0000, 0x0000, 0xffff};

  dlg = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (dlg), caption);
  gtk_window_set_default_size (GTK_WINDOW (dlg), 350, 80);

  hbox = gtk_vbox_new (FALSE, 10);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER (dlg), hbox);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);

  w = gtk_label_new (text);
  gtk_widget_show (w);
  gtk_box_pack_start (GTK_BOX (hbox), w, TRUE, TRUE, 0);

  link = gtk_label_new (textlink);
  style = gtk_style_new ();
  style->fg[GTK_STATE_NORMAL] = LBLUE;
  style->fg[GTK_STATE_INSENSITIVE] = LBLUE;
  gtk_widget_set_style (link, style);
  gtk_widget_set_sensitive (link, FALSE);
  gtk_widget_show (link);
  //  gtk_box_pack_start (GTK_BOX (hbox), link, TRUE, TRUE, 0);

  w = gtk_button_new ();
  gtk_button_set_relief (GTK_BUTTON (w), GTK_RELIEF_NONE);
  gtk_widget_show (w);
  gtk_widget_set_usize (w, -1, 24);
 
  //  hbox = h_box (button_lnk, FALSE, 0, 0);
{
  GtkWidget *alert_box = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (w), alert_box);
  gtk_container_border_width (GTK_CONTAINER (alert_box), 0);
  gtk_widget_show (alert_box);

  gtk_box_pack_start (GTK_BOX (alert_box), link, TRUE, TRUE, 0);
}
  gtk_box_pack_start (GTK_BOX (hbox), w, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (w), "clicked",
		      (GtkSignalFunc)info_dlg_link, NULL);

  w = gtk_button_new_with_label (_("OK"));
  gtk_widget_show (w);
  gtk_box_pack_end (GTK_BOX (hbox), w, FALSE, FALSE, 0);
  gtk_widget_set_usize (w, 75, -2);

  gtk_signal_connect_object (GTK_OBJECT (w), "clicked", 
			     (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (dlg));

  gtk_widget_show(dlg);
  gtk_grab_add(dlg);

  cursor = gdk_cursor_new (GDK_HAND2);
  gdk_window_set_cursor (link->window, cursor);
  gdk_cursor_destroy (cursor);

  gtk_main ();

  gtk_grab_remove(dlg);
  gtk_widget_destroy(dlg);
}

// =========================================================
// Helper functions

gint delete_event (GtkWidget *widget, GdkEvent *event, gpointer data)
{
  if (message_box (_("Do you really want to exit?"), 1) == 1)
    return FALSE;

  return TRUE;
}

void destroy (GtkWidget *widget, gpointer data)
{
  gtk_main_quit();
}

// Creates a basic dialog
GtkWidget* init_dialog (GtkAccelGroup **_accel_group, GtkTooltips **_tooltips, GtkWidget **_vbox)
{
  GtkAccelGroup *file_menu_accels, *options_menu_accels, *help_menu_accels;
  GtkWidget *file, *file_menu, *open_project, *save_project, *save_all, *exit;
  GtkWidget *options, *options_menu, *change_browser, *insert_regcode;
  GtkWidget *help, *help_menu, *applet, *instructions, *tech_faq, *scrolltext_parameters;
  GtkWidget *home_page, *registration_info, *online_registration, *copyright, *about;
  GtkWidget *dlg, *vbox1, *separator;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;
  GtkWidget *menubar;
  guint tmp_key;
  char title[64];

  if (main_dlg == NULL)
  {
    main_dlg = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_signal_connect (GTK_OBJECT (main_dlg), "delete_event",
                        GTK_SIGNAL_FUNC (delete_event), NULL);
    gtk_signal_connect (GTK_OBJECT (main_dlg), "destroy",
                        GTK_SIGNAL_FUNC (destroy), NULL);
    gtk_widget_set_usize (main_dlg, 515, 390);
    gtk_widget_show (main_dlg);
  }
  else
  {
    vbox1 = lookup_widget (main_dlg, "vbox1");
    gtk_widget_destroy (vbox1);
  }
  dlg = main_dlg;

  tooltips = gtk_object_get_data (GTK_OBJECT (dlg), "tooltips");
  if (tooltips == NULL)
    tooltips = gtk_tooltips_new ();
  *_tooltips = tooltips;
  *_accel_group = accel_group = gtk_accel_group_new ();

  strcpy (title, "Anfy");
  if (current_applet != -1)
  {
    strcat (title, " - ");
    strcat (title, applet_info[current_applet].name);
  }
  gtk_window_set_title (GTK_WINDOW (dlg), title);

  *_vbox = vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (dlg), vbox1);

  menubar = gtk_menu_bar_new ();
  gtk_widget_set_name (menubar, "menubar");
  gtk_widget_ref (menubar);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "menubar", menubar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar, FALSE, FALSE, 0);

  file = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (file)->child),
                                   _("_File"));
  gtk_widget_add_accelerator (file, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (file, "file");
  gtk_widget_ref (file);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "file", file,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file);
  gtk_container_add (GTK_CONTAINER (menubar), file);

  file_menu = gtk_menu_new ();
  gtk_widget_set_name (file_menu, "file_menu");
  gtk_widget_ref (file_menu);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "file_menu", file_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (file), file_menu);
  file_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (file_menu));

  open_project = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (open_project)->child),
                                   _("_Open project..."));
  gtk_widget_add_accelerator (open_project, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (open_project, "open_project");
  gtk_widget_ref (open_project);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "open_project", open_project,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (open_project);
  gtk_container_add (GTK_CONTAINER (file_menu), open_project);

  save_project = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (save_project)->child),
                                   _("_Save project..."));
  gtk_widget_add_accelerator (save_project, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (save_project, "save_project");
  gtk_widget_ref (save_project);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "save_project", save_project,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_project);
  gtk_container_add (GTK_CONTAINER (file_menu), save_project);

  separator = gtk_menu_item_new ();
  gtk_widget_show (separator);
  gtk_container_add (GTK_CONTAINER (file_menu), separator);
  gtk_widget_set_sensitive (separator, FALSE);

  save_all = gtk_menu_item_new_with_label (_("Save all files to..."));
  gtk_widget_set_name (save_all, "save_all");
  gtk_widget_ref (save_all);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "save_all", save_all,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_all);
  gtk_container_add (GTK_CONTAINER (file_menu), save_all);

  separator = gtk_menu_item_new ();
  gtk_widget_show (separator);
  gtk_container_add (GTK_CONTAINER (file_menu), separator);
  gtk_widget_set_sensitive (separator, FALSE);

  exit = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (exit)->child),
                                   _("E_xit"));
  gtk_widget_add_accelerator (exit, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (exit, "exit");
  gtk_widget_ref (exit);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "exit", exit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (exit);
  gtk_container_add (GTK_CONTAINER (file_menu), exit);

  options = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (options)->child),
                                   _("_Options"));
  gtk_widget_add_accelerator (options, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (options, "options");
  gtk_widget_ref (options);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "options", options,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (options);
  gtk_container_add (GTK_CONTAINER (menubar), options);

  options_menu = gtk_menu_new ();
  gtk_widget_set_name (options_menu, "options_menu");
  gtk_widget_ref (options_menu);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "options_menu", options_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (options), options_menu);
  options_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (options_menu));

  change_browser = gtk_menu_item_new_with_label (_("Change browser..."));
  gtk_widget_set_name (change_browser, "change_browser");
  gtk_widget_ref (change_browser);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "change_browser", change_browser,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (change_browser);
  gtk_container_add (GTK_CONTAINER (options_menu), change_browser);

  separator = gtk_menu_item_new ();
  gtk_widget_show (separator);
  gtk_container_add (GTK_CONTAINER (options_menu), separator);
  gtk_widget_set_sensitive (separator, FALSE);

  insert_regcode = gtk_menu_item_new_with_label (_("Insert regcode..."));
  gtk_widget_set_name (insert_regcode, "insert_regcode");
  gtk_widget_ref (insert_regcode);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "insert_regcode", insert_regcode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (insert_regcode);
  gtk_container_add (GTK_CONTAINER (options_menu), insert_regcode);

  help = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (help)->child),
                                   _("_Help"));
  gtk_widget_add_accelerator (help, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (help, "help");
  gtk_widget_ref (help);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "help", help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (help);
  gtk_container_add (GTK_CONTAINER (menubar), help);

  help_menu = gtk_menu_new ();
  gtk_widget_set_name (help_menu, "help_menu");
  gtk_widget_ref (help_menu);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "help_menu", help_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (help), help_menu);
  help_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (help_menu));

  if (current_applet != -1)
    sprintf (title, _("Applet %s info"), applet_info[current_applet].name);
  else
    strcpy (title, _("Applet %s info"));

  applet = gtk_menu_item_new_with_label (title);
  gtk_widget_set_name (applet, "applet_info");
  gtk_widget_ref (applet);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "applet_info", applet,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (applet);
  gtk_container_add (GTK_CONTAINER (help_menu), applet);

  separator = gtk_menu_item_new ();
  gtk_widget_show (separator);
  gtk_container_add (GTK_CONTAINER (help_menu), separator);
  gtk_widget_set_sensitive (separator, FALSE);

  instructions = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (instructions)->child),
                                   _("_Instructions"));
  gtk_widget_add_accelerator (instructions, "activate_item", help_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (instructions, "instructions");
  gtk_widget_ref (instructions);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "instructions", instructions,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (instructions);
  gtk_container_add (GTK_CONTAINER (help_menu), instructions);

  tech_faq = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (tech_faq)->child),
                                   _("Tech. _FAQ"));
  gtk_widget_add_accelerator (tech_faq, "activate_item", help_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (tech_faq, "tech_faq");
  gtk_widget_ref (tech_faq);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "tech_faq", tech_faq,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tech_faq);
  gtk_container_add (GTK_CONTAINER (help_menu), tech_faq);

  scrolltext_parameters = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (scrolltext_parameters)->child),
                                   _("_Scrolltext parameters"));
  gtk_widget_add_accelerator (scrolltext_parameters, "activate_item", help_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (scrolltext_parameters, "scrolltext_parameters");
  gtk_widget_ref (scrolltext_parameters);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "scrolltext_parameters", scrolltext_parameters,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolltext_parameters);
  gtk_container_add (GTK_CONTAINER (help_menu), scrolltext_parameters);

  separator = gtk_menu_item_new ();
  gtk_widget_show (separator);
  gtk_container_add (GTK_CONTAINER (help_menu), separator);
  gtk_widget_set_sensitive (separator, FALSE);

  home_page = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (home_page)->child),
                                   _("_Home page"));
  gtk_widget_add_accelerator (home_page, "activate_item", help_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (home_page, "home_page");
  gtk_widget_ref (home_page);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "home_page", home_page,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (home_page);
  gtk_container_add (GTK_CONTAINER (help_menu), home_page);

  registration_info = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (registration_info)->child),
                                   _("_Registration info"));
  gtk_widget_add_accelerator (registration_info, "activate_item", help_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (registration_info, "registration_info");
  gtk_widget_ref (registration_info);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "registration_info", registration_info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (registration_info);
  gtk_container_add (GTK_CONTAINER (help_menu), registration_info);

  online_registration = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (online_registration)->child),
                                   _("_Online registration"));
  gtk_widget_add_accelerator (online_registration, "activate_item", help_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (online_registration, "online_registration");
  gtk_widget_ref (online_registration);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "online_registration", online_registration,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (online_registration);
  gtk_container_add (GTK_CONTAINER (help_menu), online_registration);

  separator = gtk_menu_item_new ();
  gtk_widget_show (separator);
  gtk_container_add (GTK_CONTAINER (help_menu), separator);
  gtk_widget_set_sensitive (separator, FALSE);

  copyright = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (copyright)->child),
                                   _("Cop_yright"));
  gtk_widget_add_accelerator (copyright, "activate_item", help_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (copyright, "copyright");
  gtk_widget_ref (copyright);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "copyright", copyright,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (copyright);
  gtk_container_add (GTK_CONTAINER (help_menu), copyright);

  about = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (about)->child),
                                   _("_About..."));
  gtk_widget_add_accelerator (about, "activate_item", help_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (about, "about");
  gtk_widget_ref (about);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "about", about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about);
  gtk_container_add (GTK_CONTAINER (help_menu), about);

  gtk_signal_connect (GTK_OBJECT (open_project), "activate",
                      GTK_SIGNAL_FUNC (on_open_project_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (save_project), "activate",
                      GTK_SIGNAL_FUNC (on_save_project_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (save_all), "activate",
                      GTK_SIGNAL_FUNC (on_save_all_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (exit), "activate",
                      GTK_SIGNAL_FUNC (on_exit_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (change_browser), "activate",
                      GTK_SIGNAL_FUNC (on_change_browser_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (insert_regcode), "activate",
                      GTK_SIGNAL_FUNC (on_insert_regcode_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (applet), "activate",
                      GTK_SIGNAL_FUNC (on_applet_info_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (instructions), "activate",
                      GTK_SIGNAL_FUNC (on_instructions_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (tech_faq), "activate",
                      GTK_SIGNAL_FUNC (on_tech_faq_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (scrolltext_parameters), "activate",
                      GTK_SIGNAL_FUNC (on_scrolltext_parameters_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (home_page), "activate",
                      GTK_SIGNAL_FUNC (on_home_page_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (registration_info), "activate",
                      GTK_SIGNAL_FUNC (on_registration_info_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (online_registration), "activate",
                      GTK_SIGNAL_FUNC (on_online_registration_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (copyright), "activate",
                      GTK_SIGNAL_FUNC (on_copyright_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (about), "activate",
                      GTK_SIGNAL_FUNC (on_about_activate), NULL);

  if (current_dialog != DLG_STEP1)
    gtk_widget_set_sensitive (save_all, FALSE);
  if (current_dialog == DLG_STEP0)
    gtk_widget_set_sensitive (save_project, FALSE);
  if ((current_dialog == DLG_REGISTRATION) || (current_dialog == DLG_STEP1))
    gtk_widget_set_sensitive (insert_regcode, FALSE);

  return dlg;
}

// Adds the navigation buttons
void finish_dialog (GtkWidget *dlg, GtkWidget *vbox,  GtkAccelGroup *accel_group)
{
  GtkWidget *nav_default, *nav_preview, *nav_previous, *nav_next, *nav_exit;
  guint nav_default_key, nav_previous_key, nav_next_key, nav_exit_key;
  GtkWidget *hbox;

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox, "hbox");
  gtk_widget_ref (hbox);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "hbox", hbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox);
  gtk_box_pack_end (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);

  if ((current_dialog != DLG_STEP0) && (current_dialog != DLG_STEP1))
  {
    nav_default = gtk_button_new_with_label ("");
    nav_default_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (nav_default)->child),
					     _("_Default values"));
    gtk_widget_add_accelerator (nav_default, "clicked", accel_group,
				nav_default_key, GDK_MOD1_MASK, 0);
    gtk_widget_set_name (nav_default, "nav_default");
    gtk_widget_ref (nav_default);
    gtk_object_set_data_full (GTK_OBJECT (dlg), "nav_default", nav_default,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (nav_default);
    gtk_box_pack_start (GTK_BOX (hbox), nav_default, FALSE, FALSE, 0);
    gtk_widget_set_usize (nav_default, 90, -2);
//  gtk_tooltips_set_tip (tooltips, nav_default, _("Restore default value for current applet"), NULL);

    nav_preview = gtk_button_new_with_label (_("Preview..."));
    gtk_widget_set_name (nav_preview, "nav_preview");
    gtk_widget_ref (nav_preview);
    gtk_object_set_data_full (GTK_OBJECT (dlg), "nav_preview", nav_preview,
			      (GtkDestroyNotify) gtk_widget_unref);
    gtk_widget_show (nav_preview);
    gtk_box_pack_start (GTK_BOX (hbox), nav_preview, FALSE, FALSE, 5);
    gtk_widget_set_usize (nav_preview, 90, -2);

    gtk_signal_connect (GTK_OBJECT (nav_default), "clicked",
			GTK_SIGNAL_FUNC (on_applet_default), NULL);
  }

  nav_exit = gtk_button_new_with_label ("");
  nav_exit_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (nav_exit)->child),
                                   _("E_xit"));
  gtk_widget_add_accelerator (nav_exit, "clicked", accel_group,
                              nav_exit_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (nav_exit, "nav_exit");
  gtk_widget_ref (nav_exit);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "nav_exit", nav_exit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (nav_exit);
  gtk_box_pack_end (GTK_BOX (hbox), nav_exit, FALSE, FALSE, 10);
  gtk_widget_set_usize (nav_exit, 90, -2);

  nav_next = gtk_button_new_with_label ("");
  if (current_dialog != DLG_STEP1)
    nav_next_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (nav_next)->child),
					  _("_Next >"));
  else
    nav_next_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (nav_next)->child),
					  _("Publish"));
  gtk_widget_add_accelerator (nav_next, "clicked", accel_group,
                              nav_next_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (nav_next, "nav_next");
  gtk_widget_ref (nav_next);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "nav_next", nav_next,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (nav_next);
  gtk_box_pack_end (GTK_BOX (hbox), nav_next, FALSE, FALSE, 0);
  gtk_widget_set_usize (nav_next, 90, -2);

  nav_previous = gtk_button_new_with_label ("");
  nav_previous_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (nav_previous)->child),
                                   _("< _Previous"));
  gtk_widget_add_accelerator (nav_previous, "clicked", accel_group,
                              nav_previous_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (nav_previous, "nav_previous");
  gtk_widget_ref (nav_previous);
  gtk_object_set_data_full (GTK_OBJECT (dlg), "nav_previous", nav_previous,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (nav_previous);
  gtk_box_pack_end (GTK_BOX (hbox), nav_previous, FALSE, FALSE, 0);
  gtk_widget_set_usize (nav_previous, 90, -2);

  if (current_dialog == DLG_STEP0)
    gtk_widget_set_sensitive (nav_previous, FALSE);

  gtk_signal_connect (GTK_OBJECT (nav_previous), "clicked",
                      GTK_SIGNAL_FUNC (on_previous_clicked), NULL);
  gtk_signal_connect (GTK_OBJECT (nav_next), "clicked",
                      GTK_SIGNAL_FUNC (on_next_clicked), NULL);
  gtk_signal_connect (GTK_OBJECT (nav_exit), "clicked",
                      GTK_SIGNAL_FUNC (on_exit_clicked), NULL);
}

// Fill a combo box with numbers
void fill_combo (GtkWidget* combo, int first, int last)
{
  int i;
  char str[8];
  GList *items = NULL;

  for (i = first; i <= last; i++)
  {
    sprintf (str, "%d", i);
    items = g_list_append (items, g_strdup(str));
  }

  gtk_combo_set_popdown_strings (GTK_COMBO (combo), items);

  while (items)
  {
    g_free (items->data);
    items = g_list_next (items);
  }
  g_list_free (items);
}

// =========================================================

GtkWidget* create_expert ()
{
  GtkWidget *expert;
  GtkWidget *vbox221;
  GtkWidget *vbox224;
  GtkWidget *frame157;
  GtkWidget *hbox342;
  GtkWidget *table148;
  GtkWidget *netscape;
  GtkWidget *memory;
  GtkWidget *task;
  GtkObject *minsync_adj;
  GtkWidget *minsync;
  GtkWidget *label607;
  GtkWidget *label606;
  GtkWidget *label605;
  GtkWidget *vbox226;
  GtkWidget *standard;
  GtkWidget *compatibility;
  GtkWidget *speed;
  GtkWidget *frame158;
  GtkWidget *vbox225;
  GtkWidget *label601;
  GtkWidget *statusbar;
  GtkWidget *label602;
  GtkWidget *nojava;
  GtkWidget *frame159;
  GtkWidget *table147;
  GtkWidget *image;
  GtkWidget *label603;
  GtkWidget *label604;
  GtkWidget *enable_image;
  GtkWidget *browse;
  GtkWidget *xoffset;
  GtkWidget *yoffset;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  expert = init_dialog (&accel_group, &tooltips, &vbox221);

  vbox224 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox224, "vbox224");
  gtk_widget_ref (vbox224);
  gtk_object_set_data_full (GTK_OBJECT (expert), "vbox224", vbox224,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox224);
  gtk_box_pack_start (GTK_BOX (vbox221), vbox224, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox224), 5);

  frame157 = gtk_frame_new (_("Expert mode parameter"));
  gtk_widget_set_name (frame157, "frame157");
  gtk_widget_ref (frame157);
  gtk_object_set_data_full (GTK_OBJECT (expert), "frame157", frame157,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame157);
  gtk_box_pack_start (GTK_BOX (vbox224), frame157, TRUE, TRUE, 0);

  hbox342 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox342, "hbox342");
  gtk_widget_ref (hbox342);
  gtk_object_set_data_full (GTK_OBJECT (expert), "hbox342", hbox342,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox342);
  gtk_container_add (GTK_CONTAINER (frame157), hbox342);
  gtk_container_set_border_width (GTK_CONTAINER (hbox342), 5);

  table148 = gtk_table_new (4, 2, FALSE);
  gtk_widget_set_name (table148, "table148");
  gtk_widget_ref (table148);
  gtk_object_set_data_full (GTK_OBJECT (expert), "table148", table148,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table148);
  gtk_box_pack_start (GTK_BOX (hbox342), table148, TRUE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table148), 2);
  gtk_table_set_col_spacings (GTK_TABLE (table148), 10);

  netscape = gtk_check_button_new_with_label (_("Fix for netscape 3.x"));
  gtk_widget_set_name (netscape, "netscape");
  gtk_widget_ref (netscape);
  gtk_object_set_data_full (GTK_OBJECT (expert), "netscape", netscape,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (netscape);
  gtk_table_attach (GTK_TABLE (table148), netscape, 0, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  if ((current_applet != APPLET_BLOBS) &&
      (current_applet != APPLET_FIRE) &&
      (current_applet != APPLET_PLASMA) &&
      (current_applet != APPLET_ANVOXEL))
    gtk_widget_set_sensitive (lookup_widget (main_dlg, "netscape"), FALSE);

  memory = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (memory, "memory");
  gtk_widget_ref (memory);
  gtk_object_set_data_full (GTK_OBJECT (expert), "memory", memory,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (memory);
  gtk_table_attach (GTK_TABLE (table148), memory, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (memory, 60, -2);
  gtk_tooltips_set_tip (tooltips, memory, _("Deallocation of memory delay"), NULL);

  task = gtk_entry_new_with_max_length (1);
  gtk_widget_set_name (task, "task");
  gtk_widget_ref (task);
  gtk_object_set_data_full (GTK_OBJECT (expert), "task", task,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (task);
  gtk_table_attach (GTK_TABLE (table148), task, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (task, 60, -2);
  gtk_tooltips_set_tip (tooltips, task, _("Applet task priority, for pages with more applets"), NULL);

  minsync_adj = gtk_adjustment_new (10, 0, 999, 1, 10, 10);
  minsync = gtk_spin_button_new (GTK_ADJUSTMENT (minsync_adj), 1, 0);
  gtk_widget_set_name (minsync, "minsync");
  gtk_widget_ref (minsync);
  gtk_object_set_data_full (GTK_OBJECT (expert), "minsync", minsync,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (minsync);
  gtk_table_attach (GTK_TABLE (table148), minsync, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (minsync, 60, -2);
  gtk_tooltips_set_tip (tooltips, minsync, _("Min. milliseconds/frame for sync."), NULL);

  label607 = gtk_label_new (_("Memory delay"));
  gtk_widget_set_name (label607, "label607");
  gtk_widget_ref (label607);
  gtk_object_set_data_full (GTK_OBJECT (expert), "label607", label607,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label607);
  gtk_table_attach (GTK_TABLE (table148), label607, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label607), 0, 0.5);

  label606 = gtk_label_new (_("Task priority"));
  gtk_widget_set_name (label606, "label606");
  gtk_widget_ref (label606);
  gtk_object_set_data_full (GTK_OBJECT (expert), "label606", label606,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label606);
  gtk_table_attach (GTK_TABLE (table148), label606, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label606), 0, 0.5);

  label605 = gtk_label_new (_("MinSYNC"));
  gtk_widget_set_name (label605, "label605");
  gtk_widget_ref (label605);
  gtk_object_set_data_full (GTK_OBJECT (expert), "label605", label605,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label605);
  gtk_table_attach (GTK_TABLE (table148), label605, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label605), 0, 0.5);

  vbox226 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox226, "vbox226");
  gtk_widget_ref (vbox226);
  gtk_object_set_data_full (GTK_OBJECT (expert), "vbox226", vbox226,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox226);
  gtk_box_pack_start (GTK_BOX (hbox342), vbox226, FALSE, TRUE, 0);
  gtk_widget_set_usize (vbox226, 175, -2);

  standard = gtk_button_new_with_label (_("Standard settings"));
  gtk_widget_set_name (standard, "standard");
  gtk_widget_ref (standard);
  gtk_object_set_data_full (GTK_OBJECT (expert), "standard", standard,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (standard);
  gtk_box_pack_start (GTK_BOX (vbox226), standard, TRUE, FALSE, 0);

  compatibility = gtk_button_new_with_label (_("Optimize for compatibility"));
  gtk_widget_set_name (compatibility, "compatibility");
  gtk_widget_ref (compatibility);
  gtk_object_set_data_full (GTK_OBJECT (expert), "compatibility", compatibility,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (compatibility);
  gtk_box_pack_start (GTK_BOX (vbox226), compatibility, TRUE, FALSE, 0);

  speed = gtk_button_new_with_label (_("Optimize for speed"));
  gtk_widget_set_name (speed, "speed");
  gtk_widget_ref (speed);
  gtk_object_set_data_full (GTK_OBJECT (expert), "speed", speed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (speed);
  gtk_box_pack_start (GTK_BOX (vbox226), speed, TRUE, FALSE, 0);

  frame158 = gtk_frame_new (_("Message"));
  gtk_widget_set_name (frame158, "frame158");
  gtk_widget_ref (frame158);
  gtk_object_set_data_full (GTK_OBJECT (expert), "frame158", frame158,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame158);
  gtk_box_pack_start (GTK_BOX (vbox224), frame158, TRUE, TRUE, 0);

  vbox225 = gtk_vbox_new (FALSE, 2);
  gtk_widget_set_name (vbox225, "vbox225");
  gtk_widget_ref (vbox225);
  gtk_object_set_data_full (GTK_OBJECT (expert), "vbox225", vbox225,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox225);
  gtk_container_add (GTK_CONTAINER (frame158), vbox225);
  gtk_container_set_border_width (GTK_CONTAINER (vbox225), 5);

  label601 = gtk_label_new (_("Browser statusbar"));
  gtk_widget_set_name (label601, "label601");
  gtk_widget_ref (label601);
  gtk_object_set_data_full (GTK_OBJECT (expert), "label601", label601,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label601);
  gtk_box_pack_start (GTK_BOX (vbox225), label601, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label601), 0, 0.5);

  statusbar = gtk_entry_new ();
  gtk_widget_set_name (statusbar, "statusbar");
  gtk_widget_ref (statusbar);
  gtk_object_set_data_full (GTK_OBJECT (expert), "statusbar", statusbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar);
  gtk_box_pack_start (GTK_BOX (vbox225), statusbar, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, statusbar, _("Message displayed on statusbar when mouse is over applet"), NULL);

  label602 = gtk_label_new (_("For no Java(tm) browsers"));
  gtk_widget_set_name (label602, "label602");
  gtk_widget_ref (label602);
  gtk_object_set_data_full (GTK_OBJECT (expert), "label602", label602,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label602);
  gtk_box_pack_start (GTK_BOX (vbox225), label602, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label602), 0, 0.5);

  nojava = gtk_entry_new ();
  gtk_widget_set_name (nojava, "nojava");
  gtk_widget_ref (nojava);
  gtk_object_set_data_full (GTK_OBJECT (expert), "nojava", nojava,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (nojava);
  gtk_box_pack_start (GTK_BOX (vbox225), nojava, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, nojava, _("HTML fragment or message to display on browsers that doesn't support Java(tm)"), NULL);

  frame159 = gtk_frame_new (_("Optional foreground image (overlay image)"));
  gtk_widget_set_name (frame159, "frame159");
  gtk_widget_ref (frame159);
  gtk_object_set_data_full (GTK_OBJECT (expert), "frame159", frame159,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame159);
  gtk_box_pack_start (GTK_BOX (vbox224), frame159, TRUE, TRUE, 0);

  table147 = gtk_table_new (2, 4, FALSE);
  gtk_widget_set_name (table147, "table147");
  gtk_widget_ref (table147);
  gtk_object_set_data_full (GTK_OBJECT (expert), "table147", table147,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table147);
  gtk_container_add (GTK_CONTAINER (frame159), table147);
  gtk_container_set_border_width (GTK_CONTAINER (table147), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table147), 2);
  gtk_table_set_col_spacings (GTK_TABLE (table147), 5);

  image = gtk_entry_new ();
  gtk_widget_set_name (image, "image");
  gtk_widget_ref (image);
  gtk_object_set_data_full (GTK_OBJECT (expert), "image", image,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image);
  gtk_table_attach (GTK_TABLE (table147), image, 0, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, image, _("Optional image over applet"), NULL);
  gtk_widget_set_sensitive (image, FALSE);

  label603 = gtk_label_new (_("X offset"));
  gtk_widget_set_name (label603, "label603");
  gtk_widget_ref (label603);
  gtk_object_set_data_full (GTK_OBJECT (expert), "label603", label603,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label603);
  gtk_table_attach (GTK_TABLE (table147), label603, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label604 = gtk_label_new (_("Y offset"));
  gtk_widget_set_name (label604, "label604");
  gtk_widget_ref (label604);
  gtk_object_set_data_full (GTK_OBJECT (expert), "label604", label604,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label604);
  gtk_table_attach (GTK_TABLE (table147), label604, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  enable_image = gtk_check_button_new_with_label (_("Enable over image"));
  gtk_widget_set_name (enable_image, "enable_image");
  gtk_widget_ref (enable_image);
  gtk_object_set_data_full (GTK_OBJECT (expert), "enable_image", enable_image,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (enable_image);
  gtk_table_attach (GTK_TABLE (table147), enable_image, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  browse = gtk_button_new_with_label (_("Browse..."));
  gtk_widget_set_name (browse, "browse");
  gtk_widget_ref (browse);
  gtk_object_set_data_full (GTK_OBJECT (expert), "browse", browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (browse);
  gtk_table_attach (GTK_TABLE (table147), browse, 1, 2, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (browse, 90, -2);
  gtk_widget_set_sensitive (browse, FALSE);

  xoffset = gtk_entry_new ();
  gtk_widget_set_name (xoffset, "xoffset");
  gtk_widget_ref (xoffset);
  gtk_object_set_data_full (GTK_OBJECT (expert), "xoffset", xoffset,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (xoffset);
  gtk_table_attach (GTK_TABLE (table147), xoffset, 3, 4, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (xoffset, 50, -2);
  gtk_tooltips_set_tip (tooltips, xoffset, _("Over image X offset"), NULL);
  gtk_widget_set_sensitive (xoffset, FALSE);

  yoffset = gtk_entry_new ();
  gtk_widget_set_name (yoffset, "yoffset");
  gtk_widget_ref (yoffset);
  gtk_object_set_data_full (GTK_OBJECT (expert), "yoffset", yoffset,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (yoffset);
  gtk_table_attach (GTK_TABLE (table147), yoffset, 3, 4, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (yoffset, 50, -2);
  gtk_tooltips_set_tip (tooltips, yoffset, _("Over image Y offset"), NULL);
  gtk_widget_set_sensitive (yoffset, FALSE);

  finish_dialog (expert, vbox221, accel_group);

  gtk_signal_connect (GTK_OBJECT (standard), "clicked",
                      GTK_SIGNAL_FUNC (on_expert_standard), NULL);
  gtk_signal_connect (GTK_OBJECT (compatibility), "clicked",
                      GTK_SIGNAL_FUNC (on_expert_compatibility), NULL);
  gtk_signal_connect (GTK_OBJECT (speed), "clicked",
                      GTK_SIGNAL_FUNC (on_expert_speed), NULL);
  gtk_signal_connect (GTK_OBJECT (enable_image), "toggled",
                      GTK_SIGNAL_FUNC (on_expert_enable_over), NULL);
  gtk_signal_connect (GTK_OBJECT (browse), "clicked",
                      GTK_SIGNAL_FUNC (OnFindImage), NULL);

  gtk_object_set_data (GTK_OBJECT (expert), "tooltips", tooltips);
  gtk_window_add_accel_group (GTK_WINDOW (expert), accel_group);

  return expert;
}

// =========================================================

GtkWidget* create_registration ()
{
  GtkWidget *registration;
  GtkWidget *vbox227;
  GtkWidget *vbox228;
  GtkWidget *hbox346;
  GtkWidget *vbox230;
  GtkWidget *domain_entry;
  GtkWidget *vbox231;
  GtkWidget *domain_add;
  GtkWidget *domain_remove;
  GtkWidget *label;
  GtkWidget *hbox347;
  GtkWidget *vbox229;
  GtkWidget *regcode_entry;
  GtkWidget *scrolledwindow1;
  GtkWidget *regcode_list;
  GtkWidget *label618;
  GtkWidget *vbox232;
  GtkWidget *regcode_add;
  GtkWidget *regcode_remove;
  GtkWidget *enable_link;
  GtkWidget *link_entry;
  GtkWidget *enable_target;
  GtkWidget *frame162;
  GtkWidget *table149;
  GtkWidget *target_entry;
  GtkWidget *hbox348;
  GtkWidget *mode_combo;
  GtkWidget *mode_entry;
  GList *mode_combo_items = NULL;
  GtkWidget *mode_label;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;
  GtkWidget *domains;

  registration = init_dialog (&accel_group, &tooltips, &vbox227);

  vbox228 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox228, "vbox228");
  gtk_widget_ref (vbox228);
  gtk_object_set_data_full (GTK_OBJECT (registration), "vbox228", vbox228,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox228);
  gtk_box_pack_start (GTK_BOX (vbox227), vbox228, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox228), 5);

  hbox346 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox346, "hbox346");
  gtk_widget_ref (hbox346);
  gtk_object_set_data_full (GTK_OBJECT (registration), "hbox346", hbox346,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox346);
  gtk_box_pack_start (GTK_BOX (vbox228), hbox346, TRUE, TRUE, 0);

  vbox230 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox230, "vbox230");
  gtk_widget_ref (vbox230);
  gtk_object_set_data_full (GTK_OBJECT (registration), "vbox230", vbox230,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox230);
  gtk_box_pack_start (GTK_BOX (hbox346), vbox230, TRUE, TRUE, 0);

  label = gtk_label_new (_("Select domain / new domain"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (registration), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox230), label, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  domains = gtk_option_menu_new ();
  gtk_widget_set_name (domains, "domains");
  gtk_widget_ref (domains);
  gtk_object_set_data_full (GTK_OBJECT (registration), "domains", domains,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (domains);
  gtk_box_pack_start (GTK_BOX (vbox230), domains, FALSE, FALSE, 0);

  domain_entry = gtk_entry_new ();
  gtk_widget_set_name (domain_entry, "domain_entry");
  gtk_widget_ref (domain_entry);
  gtk_object_set_data_full (GTK_OBJECT (registration), "domain_entry", domain_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (domain_entry);
  gtk_box_pack_start (GTK_BOX (vbox230), domain_entry, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, domain_entry, _("Select domain, drop down the list to change domain or write new domain to add "), NULL);

  vbox231 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox231, "vbox231");
  gtk_widget_ref (vbox231);
  gtk_object_set_data_full (GTK_OBJECT (registration), "vbox231", vbox231,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox231);
  gtk_box_pack_start (GTK_BOX (hbox346), vbox231, FALSE, TRUE, 0);
  gtk_widget_set_usize (vbox231, 90, -2);

  domain_add = gtk_button_new_with_label (_("Add"));
  gtk_widget_set_name (domain_add, "domain_add");
  gtk_widget_ref (domain_add);
  gtk_object_set_data_full (GTK_OBJECT (registration), "domain_add", domain_add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (domain_add);
  gtk_box_pack_start (GTK_BOX (vbox231), domain_add, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, domain_add, _("Add new domain"), NULL);

  domain_remove = gtk_button_new_with_label (_("Remove"));
  gtk_widget_set_name (domain_remove, "domain_remove");
  gtk_widget_ref (domain_remove);
  gtk_object_set_data_full (GTK_OBJECT (registration), "domain_remove", domain_remove,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (domain_remove);
  gtk_box_pack_start (GTK_BOX (vbox231), domain_remove, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, domain_remove, _("Remove selected domain"), NULL);

  label = gtk_label_new (_("Write here your registration code (regcode) for selected domain"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (registration), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox228), label, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  hbox347 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox347, "hbox347");
  gtk_widget_ref (hbox347);
  gtk_object_set_data_full (GTK_OBJECT (registration), "hbox347", hbox347,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox347);
  gtk_box_pack_start (GTK_BOX (vbox228), hbox347, TRUE, TRUE, 0);

  vbox229 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox229, "vbox229");
  gtk_widget_ref (vbox229);
  gtk_object_set_data_full (GTK_OBJECT (registration), "vbox229", vbox229,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox229);
  gtk_box_pack_start (GTK_BOX (hbox347), vbox229, TRUE, TRUE, 0);

  regcode_entry = gtk_entry_new ();
  gtk_widget_set_name (regcode_entry, "regcode_entry");
  gtk_widget_ref (regcode_entry);
  gtk_object_set_data_full (GTK_OBJECT (registration), "regcode_entry", regcode_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (regcode_entry);
  gtk_box_pack_start (GTK_BOX (vbox229), regcode_entry, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, regcode_entry, _("New registration code to add"), NULL);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow1, "scrolledwindow1");
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (registration), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox229), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  regcode_list = gtk_clist_new (1);
  gtk_widget_set_name (regcode_list, "regcode_list");
  gtk_widget_ref (regcode_list);
  gtk_object_set_data_full (GTK_OBJECT (registration), "regcode_list", regcode_list,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (regcode_list);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), regcode_list);
  gtk_tooltips_set_tip (tooltips, regcode_list, _("List of registration codes"), NULL);
  gtk_clist_set_column_width (GTK_CLIST (regcode_list), 0, 80);
  gtk_clist_column_titles_hide (GTK_CLIST (regcode_list));

  label618 = gtk_label_new (_("label618"));
  gtk_widget_set_name (label618, "label618");
  gtk_widget_ref (label618);
  gtk_object_set_data_full (GTK_OBJECT (registration), "label618", label618,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label618);
  gtk_clist_set_column_widget (GTK_CLIST (regcode_list), 0, label618);

  vbox232 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox232, "vbox232");
  gtk_widget_ref (vbox232);
  gtk_object_set_data_full (GTK_OBJECT (registration), "vbox232", vbox232,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox232);
  gtk_box_pack_start (GTK_BOX (hbox347), vbox232, FALSE, TRUE, 0);
  gtk_widget_set_usize (vbox232, 90, -2);

  regcode_add = gtk_button_new_with_label (_("Add"));
  gtk_widget_set_name (regcode_add, "regcode_add");
  gtk_widget_ref (regcode_add);
  gtk_object_set_data_full (GTK_OBJECT (registration), "regcode_add", regcode_add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (regcode_add);
  gtk_box_pack_start (GTK_BOX (vbox232), regcode_add, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, regcode_add, _("Add code to list"), NULL);

  regcode_remove = gtk_button_new_with_label (_("Remove"));
  gtk_widget_set_name (regcode_remove, "regcode_remove");
  gtk_widget_ref (regcode_remove);
  gtk_object_set_data_full (GTK_OBJECT (registration), "regcode_remove", regcode_remove,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (regcode_remove);
  gtk_box_pack_start (GTK_BOX (vbox232), regcode_remove, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, regcode_remove, _("Remove code from list"), NULL);

  enable_link = gtk_check_button_new_with_label (_("Enable link (needs regcode to work when applet is online)"));
  gtk_widget_set_name (enable_link, "enable_link");
  gtk_widget_ref (enable_link);
  gtk_object_set_data_full (GTK_OBJECT (registration), "enable_link", enable_link,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (enable_link);
  gtk_box_pack_start (GTK_BOX (vbox228), enable_link, FALSE, FALSE, 0);

  if ((current_applet == APPLET_CUBEMENU) ||
      (current_applet == APPLET_ANFADE) ||
      (current_applet == APPLET_BOOKFLIP) ||
      (current_applet == APPLET_MOSAIC) ||
      (current_applet == APPLET_WHEEL) ||
      (current_applet == APPLET_MORPHMENU) ||
      (current_applet == APPLET_TREEMENU))
    gtk_widget_set_sensitive (enable_link, FALSE);

  if (current_applet == APPLET_ANFYPAINT)
  {
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (enable_link), FALSE);
    gtk_widget_set_sensitive (enable_link, FALSE);
  }

  link_entry = gtk_entry_new ();
  gtk_widget_set_name (link_entry, "link_entry");
  gtk_widget_ref (link_entry);
  gtk_object_set_data_full (GTK_OBJECT (registration), "link_entry", link_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (link_entry);
  gtk_box_pack_start (GTK_BOX (vbox228), link_entry, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, link_entry, _("URL where link the user when applet is clicked"), NULL);
  gtk_widget_set_sensitive (link_entry, FALSE);

  enable_target = gtk_check_button_new_with_label (_(".. in new target frame"));
  gtk_widget_set_name (enable_target, "enable_target");
  gtk_widget_ref (enable_target);
  gtk_object_set_data_full (GTK_OBJECT (registration), "enable_target", enable_target,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (enable_target);
  gtk_box_pack_start (GTK_BOX (vbox228), enable_target, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (enable_target, FALSE);

  frame162 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame162, "frame162");
  gtk_widget_ref (frame162);
  gtk_object_set_data_full (GTK_OBJECT (registration), "frame162", frame162,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame162);
  gtk_box_pack_start (GTK_BOX (vbox228), frame162, TRUE, TRUE, 0);

  table149 = gtk_table_new (2, 2, FALSE);
  gtk_widget_set_name (table149, "table149");
  gtk_widget_ref (table149);
  gtk_object_set_data_full (GTK_OBJECT (registration), "table149", table149,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table149);
  gtk_container_add (GTK_CONTAINER (frame162), table149);
  gtk_container_set_border_width (GTK_CONTAINER (table149), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table149), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table149), 5);

  label = gtk_label_new (_("Target frame"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (registration), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_table_attach (GTK_TABLE (table149), label, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  label = gtk_label_new (_("Mode"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (registration), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_table_attach (GTK_TABLE (table149), label, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  target_entry = gtk_entry_new ();
  gtk_widget_set_name (target_entry, "target_entry");
  gtk_widget_ref (target_entry);
  gtk_object_set_data_full (GTK_OBJECT (registration), "target_entry", target_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (target_entry);
  gtk_table_attach (GTK_TABLE (table149), target_entry, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, target_entry, _("Custom target frame name"), NULL);
  gtk_widget_set_sensitive (target_entry, FALSE);

  hbox348 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox348, "hbox348");
  gtk_widget_ref (hbox348);
  gtk_object_set_data_full (GTK_OBJECT (registration), "hbox348", hbox348,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox348);
  gtk_table_attach (GTK_TABLE (table149), hbox348, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  mode_combo = gtk_combo_new ();
  gtk_widget_set_name (mode_combo, "mode_combo");
  gtk_widget_ref (mode_combo);
  gtk_object_set_data_full (GTK_OBJECT (registration), "mode_combo", mode_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mode_combo);
  gtk_box_pack_start (GTK_BOX (hbox348), mode_combo, FALSE, TRUE, 0);
  gtk_widget_set_usize (mode_combo, 100, -2);
  gtk_widget_set_sensitive (mode_combo, FALSE);
  mode_combo_items = g_list_append (mode_combo_items, "_blank");
  mode_combo_items = g_list_append (mode_combo_items, "_self");
  mode_combo_items = g_list_append (mode_combo_items, "_parent");
  mode_combo_items = g_list_append (mode_combo_items, "_top");
  mode_combo_items = g_list_append (mode_combo_items, _("other target..."));
  gtk_combo_set_popdown_strings (GTK_COMBO (mode_combo), mode_combo_items);
  g_list_free (mode_combo_items);

  mode_entry = GTK_COMBO (mode_combo)->entry;
  gtk_widget_set_name (mode_entry, "mode_entry");
  gtk_widget_ref (mode_entry);
  gtk_object_set_data_full (GTK_OBJECT (registration), "mode_entry", mode_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mode_entry);
  gtk_tooltips_set_tip (tooltips, mode_entry, _("New frame mode, select \"other target\" for custom frame name"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (mode_entry), FALSE);

  mode_label = gtk_label_new (_(""));
  gtk_widget_set_name (mode_label, "mode_label");
  gtk_widget_ref (mode_label);
  gtk_object_set_data_full (GTK_OBJECT (registration), "mode_label", mode_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mode_label);
  gtk_box_pack_start (GTK_BOX (hbox348), mode_label, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (mode_label), 0, 0.5);

  finish_dialog (registration, vbox227, accel_group);


  gtk_signal_connect (GTK_OBJECT (regcode_add), "clicked",
                      GTK_SIGNAL_FUNC (on_add_code), NULL);
  gtk_signal_connect (GTK_OBJECT (regcode_remove), "clicked",
                      GTK_SIGNAL_FUNC (on_remove_code), NULL);
  gtk_signal_connect (GTK_OBJECT (domain_add), "clicked",
                      GTK_SIGNAL_FUNC (on_add_domain), NULL);
  gtk_signal_connect (GTK_OBJECT (domain_remove), "clicked",
                      GTK_SIGNAL_FUNC (on_remove_domain), NULL);
  gtk_signal_connect (GTK_OBJECT (enable_link), "toggled",
                      GTK_SIGNAL_FUNC (on_enable_link), NULL);
  gtk_signal_connect (GTK_OBJECT (enable_target), "toggled",
                      GTK_SIGNAL_FUNC (on_new_frame), NULL);
  gtk_signal_connect (GTK_OBJECT (mode_entry), "changed",
                      GTK_SIGNAL_FUNC (on_change_frame_mode), NULL);

  gtk_object_set_data (GTK_OBJECT (registration), "tooltips", tooltips);
  gtk_window_add_accel_group (GTK_WINDOW (registration), accel_group);

  return registration;
}

// =========================================================

GtkWidget* create_step1 ()
{
  GtkWidget *step1;
  GtkWidget *vbox233;
  GtkWidget *vbox234;
  GtkWidget *label;
  GtkWidget *hbox349;
  GtkWidget *scrolledwindow;
  GtkWidget *code;
  GtkWidget *vbox235;
  GtkWidget *preview;
  GtkWidget *copy_all;
  GtkWidget *clipboard;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;

  step1 = init_dialog (&accel_group, &tooltips, &vbox233);

  vbox234 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox234, "vbox234");
  gtk_widget_ref (vbox234);
  gtk_object_set_data_full (GTK_OBJECT (step1), "vbox234", vbox234,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox234);
  gtk_box_pack_start (GTK_BOX (vbox233), vbox234, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox234), 5);

  label = gtk_label_new (_("HTML code"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (step1), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox234), label, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  hbox349 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox349, "hbox349");
  gtk_widget_ref (hbox349);
  gtk_object_set_data_full (GTK_OBJECT (step1), "hbox349", hbox349,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox349);
  gtk_box_pack_start (GTK_BOX (vbox234), hbox349, TRUE, TRUE, 0);

  scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow, "scrolledwindow");
  gtk_widget_ref (scrolledwindow);
  gtk_object_set_data_full (GTK_OBJECT (step1), "scrolledwindow", scrolledwindow,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow);
  gtk_box_pack_start (GTK_BOX (hbox349), scrolledwindow, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  code = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (code, "code");
  gtk_widget_ref (code);
  gtk_object_set_data_full (GTK_OBJECT (step1), "code", code,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (code);
  gtk_container_add (GTK_CONTAINER (scrolledwindow), code);

  vbox235 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox235, "vbox235");
  gtk_widget_ref (vbox235);
  gtk_object_set_data_full (GTK_OBJECT (step1), "vbox235", vbox235,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox235);
  gtk_box_pack_start (GTK_BOX (hbox349), vbox235, FALSE, TRUE, 0);
  gtk_widget_set_usize (vbox235, 125, -2);

  preview = gtk_button_new_with_label (_("Preview..."));
  gtk_widget_set_name (preview, "preview");
  gtk_widget_ref (preview);
  gtk_object_set_data_full (GTK_OBJECT (step1), "preview", preview,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (preview);
  gtk_box_pack_start (GTK_BOX (vbox235), preview, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, preview, _("Show the applet preview page"), NULL);

  copy_all = gtk_button_new_with_label (_("Copy all files to..."));
  gtk_widget_set_name (copy_all, "copy_all");
  gtk_widget_ref (copy_all);
  gtk_object_set_data_full (GTK_OBJECT (step1), "copy_all", copy_all,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (copy_all);
  gtk_box_pack_start (GTK_BOX (vbox235), copy_all, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, copy_all, _("Save all needed files into destination directory"), NULL);

  clipboard = gtk_button_new_with_label (_("Copy into clipboard"));
  gtk_widget_set_name (clipboard, "clipboard");
  gtk_widget_ref (clipboard);
  gtk_object_set_data_full (GTK_OBJECT (step1), "clipboard", clipboard,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clipboard);
  gtk_box_pack_end (GTK_BOX (vbox235), clipboard, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, clipboard, _("Then you can paste the text"), NULL);

  finish_dialog (step1, vbox233, accel_group);

  gtk_signal_connect (GTK_OBJECT (copy_all), "clicked",
                      GTK_SIGNAL_FUNC (on_save_all_activate), NULL);
  gtk_signal_connect (GTK_OBJECT (clipboard), "clicked",
		      GTK_SIGNAL_FUNC (on_step1_clipboard), code);
  gtk_signal_connect (GTK_OBJECT (preview), "clicked",
		      GTK_SIGNAL_FUNC (on_applet_preview), code);

  gtk_object_set_data (GTK_OBJECT (step1), "tooltips", tooltips);
  gtk_window_add_accel_group (GTK_WINDOW (step1), accel_group);

  return step1;
}

// =========================================================

GtkWidget* create_maindlg ()
{
  GtkWidget *maindlg;
  GtkWidget *vbox1;
  GtkWidget *hbox3;
  GtkWidget *pixmap2;
  GtkWidget *vbox3;
  GtkWidget *label;
  GtkWidget *hbox4;
  GtkWidget *frame;
  GtkWidget *vbox4;
  GSList *vbox4_group = NULL;
  GtkWidget *cat_banner;
  GtkWidget *cat_fractals;
  GtkWidget *cat_image;
  GtkWidget *cat_3d;
  GtkWidget *cat_navigation;
  GtkWidget *cat_other;
  GtkWidget *vbox5;
  GtkWidget *applet_combo;
  GtkWidget *applet_entry;
  GtkWidget *frame2;
  GtkWidget *description;
  GtkWidget *hbox2;
  GtkWidget *pixmap1;
  GtkWidget *vbox2;
  GtkWidget *applet_preview;
  GtkWidget *applet_preview_all;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  maindlg = init_dialog (&accel_group, &tooltips, &vbox1);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox3, "hbox3");
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 5);

  pixmap2 = create_pixmap (maindlg, "logo2.xpm");
  gtk_widget_set_name (pixmap2, "pixmap2");
  gtk_widget_ref (pixmap2);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "pixmap2", pixmap2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap2);
  gtk_box_pack_start (GTK_BOX (hbox3), pixmap2, FALSE, FALSE, 5);
  gtk_pixmap_set_build_insensitive (GTK_PIXMAP (pixmap2), FALSE);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox3, "vbox3");
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (hbox3), vbox3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox3), 5);

  label = gtk_label_new (_("Select the category and the applet you want to configure"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox3), label, FALSE, FALSE, 2);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label), 7.45058e-09, 0.5);

  hbox4 = gtk_hbox_new (TRUE, 0);
  gtk_widget_set_name (hbox4, "hbox4");
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox4, TRUE, TRUE, 0);

  frame = gtk_frame_new (_("Category"));
  gtk_widget_set_name (frame, "frame");
  gtk_widget_ref (frame);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "frame", frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame);
  //  gtk_widget_set_usize (frame, 410, -2);
  gtk_box_pack_start (GTK_BOX (hbox4), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 5);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox4, "vbox4");
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  //  gtk_widget_set_usize (vbox4, 410, -2);
  gtk_container_add (GTK_CONTAINER (frame), vbox4);
  gtk_container_set_border_width (GTK_CONTAINER (vbox4), 5);

  cat_banner = gtk_radio_button_new_with_label (vbox4_group, _("Banner/Slideshow"));
  vbox4_group = gtk_radio_button_group (GTK_RADIO_BUTTON (cat_banner));
  gtk_widget_set_name (cat_banner, "cat_banner");
  gtk_widget_ref (cat_banner);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "cat_banner", cat_banner,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cat_banner);
  gtk_box_pack_start (GTK_BOX (vbox4), cat_banner, TRUE, FALSE, 0);

  cat_fractals = gtk_radio_button_new_with_label (vbox4_group, _("Fractals/Alife"));
  vbox4_group = gtk_radio_button_group (GTK_RADIO_BUTTON (cat_fractals));
  gtk_widget_set_name (cat_fractals, "cat_fractals");
  gtk_widget_ref (cat_fractals);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "cat_fractals", cat_fractals,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cat_fractals);
  gtk_box_pack_start (GTK_BOX (vbox4), cat_fractals, TRUE, FALSE, 0);

  cat_image = gtk_radio_button_new_with_label (vbox4_group, _("Image effects"));
  vbox4_group = gtk_radio_button_group (GTK_RADIO_BUTTON (cat_image));
  gtk_widget_set_name (cat_image, "cat_image");
  gtk_widget_ref (cat_image);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "cat_image", cat_image,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cat_image);
  gtk_box_pack_start (GTK_BOX (vbox4), cat_image, TRUE, FALSE, 0);

  cat_3d = gtk_radio_button_new_with_label (vbox4_group, _("3D Applets"));
  vbox4_group = gtk_radio_button_group (GTK_RADIO_BUTTON (cat_3d));
  gtk_widget_set_name (cat_3d, "cat_3d");
  gtk_widget_ref (cat_3d);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "cat_3d", cat_3d,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cat_3d);
  gtk_box_pack_start (GTK_BOX (vbox4), cat_3d, TRUE, FALSE, 0);

  cat_navigation = gtk_radio_button_new_with_label (vbox4_group, _("Navigation menu"));
  vbox4_group = gtk_radio_button_group (GTK_RADIO_BUTTON (cat_navigation));
  gtk_widget_set_name (cat_navigation, "cat_navigation");
  gtk_widget_ref (cat_navigation);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "cat_navigation", cat_navigation,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cat_navigation);
  gtk_box_pack_start (GTK_BOX (vbox4), cat_navigation, TRUE, FALSE, 0);

  cat_other = gtk_radio_button_new_with_label (vbox4_group, _("Other"));
  vbox4_group = gtk_radio_button_group (GTK_RADIO_BUTTON (cat_other));
  gtk_widget_set_name (cat_other, "cat_other");
  gtk_widget_ref (cat_other);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "cat_other", cat_other,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cat_other);
  gtk_box_pack_start (GTK_BOX (vbox4), cat_other, TRUE, FALSE, 0);

  vbox5 = gtk_vbox_new (FALSE, 10);
  gtk_widget_set_name (vbox5, "vbox5");
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (hbox4), vbox5, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox5), 5);

  applet_combo = gtk_combo_new ();
  gtk_widget_set_name (applet_combo, "applet_combo");
  gtk_widget_ref (applet_combo);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "applet_combo", applet_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (applet_combo);
  gtk_box_pack_start (GTK_BOX (vbox5), applet_combo, FALSE, FALSE, 0);

  applet_entry = GTK_COMBO (applet_combo)->entry;
  gtk_widget_set_name (applet_entry, "applet_entry");
  gtk_widget_ref (applet_entry);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "applet_entry", applet_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (applet_entry);
  gtk_tooltips_set_tip (tooltips, applet_entry, _("List of available applets"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (applet_entry), FALSE);

  frame2 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame2, "frame2");
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_end (GTK_BOX (vbox5), frame2, FALSE, FALSE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame2), GTK_SHADOW_IN);

  description = gtk_label_new ("");
  gtk_widget_set_name (description, "description");
  gtk_widget_ref (description);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "description", description,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (description);
  gtk_container_add (GTK_CONTAINER (frame2), description);
  gtk_widget_set_usize (description, -2, 150);
  gtk_label_set_justify (GTK_LABEL (description), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (description), 0, 0);
  gtk_label_set_line_wrap (GTK_LABEL (description), TRUE); 

  hbox2 = gtk_hbox_new (FALSE, 70);
  gtk_widget_set_name (hbox2, "hbox2");
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 5);

  pixmap1 = create_pixmap (maindlg, "logo1.xpm");
  gtk_widget_set_name (pixmap1, "pixmap1");
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox2), pixmap1, FALSE, TRUE, 0);
  gtk_pixmap_set_build_insensitive (GTK_PIXMAP (pixmap1), FALSE);

  vbox2 = gtk_vbox_new (FALSE, 10);
  gtk_widget_set_name (vbox2, "vbox2");
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_box_pack_end (GTK_BOX (hbox2), vbox2, FALSE, TRUE, 10);
  gtk_widget_set_usize (vbox2, 110, -2);

  applet_preview = gtk_button_new_with_label (_("Applet Preview..."));
  gtk_widget_set_name (applet_preview, "applet_preview");
  gtk_widget_ref (applet_preview);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "applet_preview", applet_preview,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (applet_preview);
  gtk_box_pack_start (GTK_BOX (vbox2), applet_preview, FALSE, FALSE, 0);
  gtk_widget_set_usize (applet_preview, -2, 30);
  gtk_tooltips_set_tip (tooltips, applet_preview, _("Show the applet preview page"), NULL);

  applet_preview_all = gtk_button_new_with_label (_("Preview All..."));
  gtk_widget_set_name (applet_preview_all, "applet_preview_all");
  gtk_widget_ref (applet_preview_all);
  gtk_object_set_data_full (GTK_OBJECT (maindlg), "applet_preview_all", applet_preview_all,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (applet_preview_all);
  gtk_box_pack_start (GTK_BOX (vbox2), applet_preview_all, FALSE, FALSE, 0);
  gtk_widget_set_usize (applet_preview_all, -2, 30);
  gtk_tooltips_set_tip (tooltips, applet_preview_all, _("Show index of preview pages"), NULL);

  finish_dialog (maindlg, vbox1, accel_group);

  gtk_signal_connect (GTK_OBJECT (cat_banner), "clicked",
                      GTK_SIGNAL_FUNC (on_step0_category_changed), (void*)1);
  gtk_signal_connect (GTK_OBJECT (cat_fractals), "clicked",
                      GTK_SIGNAL_FUNC (on_step0_category_changed), (void*)2);
  gtk_signal_connect (GTK_OBJECT (cat_image), "clicked",
                      GTK_SIGNAL_FUNC (on_step0_category_changed), (void*)3);
  gtk_signal_connect (GTK_OBJECT (cat_3d), "clicked",
                      GTK_SIGNAL_FUNC (on_step0_category_changed), (void*)4);
  gtk_signal_connect (GTK_OBJECT (cat_navigation), "clicked",
                      GTK_SIGNAL_FUNC (on_step0_category_changed), (void*)5);
  gtk_signal_connect (GTK_OBJECT (cat_other), "clicked",
                      GTK_SIGNAL_FUNC (on_step0_category_changed), (void*)6);
  gtk_signal_connect (GTK_OBJECT (applet_entry), "changed",
                      GTK_SIGNAL_FUNC (on_step0_combo_applet_changed), NULL);
  gtk_signal_connect (GTK_OBJECT (applet_preview), "clicked",
                      GTK_SIGNAL_FUNC (on_applet_preview), NULL);
  gtk_signal_connect (GTK_OBJECT (applet_preview_all), "clicked",
                      GTK_SIGNAL_FUNC (on_step0_preview_all), NULL);

  gtk_object_set_data (GTK_OBJECT (maindlg), "tooltips", tooltips);
  gtk_window_add_accel_group (GTK_WINDOW (maindlg), accel_group);

  return maindlg;
}
