//
// Category Banner/Slideshow
//
// BOOKFLIP, CFADE, MOSAIC
//

#include <gtk/gtk.h>
#include "callback.h"
#include "support.h"
#include "dialogs.h"
#include "main.h"

GtkWidget* create_bookflip ()
{
  GtkWidget *bookflip;
  GtkWidget *vbox13;
  GtkWidget *hbox12;
  GtkWidget *frame;
  GtkWidget *vbox14;
  GtkWidget *hbox13;
  GtkWidget *scrolledwindow2;
  GtkWidget *image_list;
  GtkWidget *vbox15;
  GtkWidget *add;
  GtkWidget *up;
  GtkWidget *down;
  GtkWidget *remove;
  GtkWidget *label;
  GtkWidget *image_link;
  GtkWidget *image_status;
  GtkWidget *label6;
  GtkWidget *flip_combo;
  GtkWidget *flip_entry;
  GtkWidget *flip_mode_combo;
  GtkWidget *flip_mode_entry;
  GList* flip_mode_list = NULL;
  GtkWidget *vbox16;
  GtkWidget *table1;
  GtkWidget *height;
  GtkWidget *width;
  GtkWidget *resolution_combo;
  GtkWidget *resolution_entry;
  GtkWidget *hbox14;
  GtkWidget *label9;
  GtkWidget *frame_speed;
  GtkWidget *hbox15;
  GtkWidget *label10;
  GtkWidget *pause;
  GtkWidget *hbox16;
  GtkWidget *label11;
  GtkWidget *extra_height;
  GtkWidget *hbox17;
  GtkWidget *label12;
  GtkWidget *hbox18;
  GtkWidget *label13;
  GtkWidget *shading_combo;
  GtkWidget *shading_entry;
  GtkWidget *hbox19;
  GtkWidget *back_color;
  GtkWidget *label619;
  GtkWidget *color_pixmap;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  bookflip = init_dialog (&accel_group, &tooltips, &vbox13);

  hbox12 = gtk_hbox_new (FALSE, 10);
  gtk_widget_set_name (hbox12, "hbox12");
  gtk_widget_ref (hbox12);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "hbox12", hbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox12);
  gtk_box_pack_start (GTK_BOX (vbox13), hbox12, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox12), 5);

  frame = gtk_frame_new (_("Images"));
  gtk_widget_set_name (frame, "frame");
  gtk_widget_ref (frame);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "frame", frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox12), frame, TRUE, TRUE, 0);

  vbox14 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox14, "vbox14");
  gtk_widget_ref (vbox14);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "vbox14", vbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox14);
  gtk_container_add (GTK_CONTAINER (frame), vbox14);
  gtk_container_set_border_width (GTK_CONTAINER (vbox14), 5);

  hbox13 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox13, "hbox13");
  gtk_widget_ref (hbox13);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "hbox13", hbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox13);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox13, TRUE, TRUE, 0);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow2, "scrolledwindow2");
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (hbox13), scrolledwindow2, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  image_list = gtk_clist_new (1);
  gtk_widget_set_name (image_list, "image_list");
  gtk_widget_ref (image_list);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "image_list", image_list,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_list);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), image_list);
  gtk_tooltips_set_tip (tooltips, image_list, _("Images: you can choose same image more than one time"), NULL);
  gtk_clist_set_column_width (GTK_CLIST (image_list), 0, 80);
  gtk_clist_column_titles_hide (GTK_CLIST (image_list));

  label619 = gtk_label_new (_("label619"));
  gtk_widget_set_name (label619, "label619");
  gtk_widget_ref (label619);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "label619", label619,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label619);
  gtk_clist_set_column_widget (GTK_CLIST (image_list), 0, label619);

  vbox15 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox15, "vbox15");
  gtk_widget_ref (vbox15);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "vbox15", vbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox15);
  gtk_box_pack_start (GTK_BOX (hbox13), vbox15, FALSE, TRUE, 0);
  gtk_widget_set_usize (vbox15, 70, -2);

  add = gtk_button_new_with_label (_("Add..."));
  gtk_widget_set_name (add, "add");
  gtk_widget_ref (add);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "add", add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add);
  gtk_box_pack_start (GTK_BOX (vbox15), add, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, add, _("Select images to add"), NULL);

  up = gtk_button_new_with_label (_("Move up"));
  gtk_widget_set_name (up, "up");
  gtk_widget_ref (up);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "up", up,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (up);
  gtk_box_pack_start (GTK_BOX (vbox15), up, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, up, _("Move up the selected image"), NULL);

  down = gtk_button_new_with_label (_("Move down"));
  gtk_widget_set_name (down, "down");
  gtk_widget_ref (down);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "down", down,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (down);
  gtk_box_pack_start (GTK_BOX (vbox15), down, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, down, _("Move down the selected image"), NULL);

  remove = gtk_button_new_with_label (_("Remove"));
  gtk_widget_set_name (remove, "remove");
  gtk_widget_ref (remove);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "remove", remove,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (remove);
  gtk_box_pack_start (GTK_BOX (vbox15), remove, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, remove, _("Remove image from list"), NULL);

  label = gtk_label_new (_("Current selected image link (http:// if not same site)"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox14), label, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  image_link = gtk_entry_new ();
  gtk_widget_set_name (image_link, "image_link");
  gtk_widget_ref (image_link);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "image_link", image_link,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_link);
  gtk_box_pack_start (GTK_BOX (vbox14), image_link, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, image_link, _("Link associated to selected image (only when registered)"), NULL);

  label = gtk_label_new (_("Status message for selected image"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox14), label, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  image_status = gtk_entry_new ();
  gtk_widget_set_name (image_status, "image_status");
  gtk_widget_ref (image_status);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "image_status", image_status,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_status);
  gtk_box_pack_start (GTK_BOX (vbox14), image_status, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, image_status, _("Status message for selected image"), NULL);

  label6 = gtk_label_new (_("Flip mode for selected image"));
  gtk_widget_set_name (label6, "label6");
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_box_pack_start (GTK_BOX (vbox14), label6, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label6), 0, 0.5);

  flip_mode_combo = gtk_combo_new ();
  gtk_widget_set_name (flip_mode_combo, "flip_mode_combo");
  gtk_widget_ref (flip_mode_combo);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "flip_mode_combo", flip_mode_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (flip_mode_combo);
  gtk_box_pack_start (GTK_BOX (vbox14), flip_mode_combo, FALSE, FALSE, 0);

  flip_mode_list = g_list_append (flip_mode_list, "IN -> up-right");
  flip_mode_list = g_list_append (flip_mode_list, "IN -> down-right");
  flip_mode_list = g_list_append (flip_mode_list, "IN -> down-left");
  flip_mode_list = g_list_append (flip_mode_list, "IN -> up-left");
  flip_mode_list = g_list_append (flip_mode_list, "OUT -> down-left");
  flip_mode_list = g_list_append (flip_mode_list, "OUT -> up-left");
  flip_mode_list = g_list_append (flip_mode_list, "OUT -> up-right");
  flip_mode_list = g_list_append (flip_mode_list, "OUT -> down-righ");
  gtk_combo_set_popdown_strings (GTK_COMBO (flip_mode_combo), flip_mode_list);

  flip_mode_entry = GTK_COMBO (flip_mode_combo)->entry;
  gtk_widget_set_name (flip_mode_entry, "flip_mode_entry");
  gtk_widget_ref (flip_mode_entry);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "flip_mode_entry", flip_mode_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (flip_mode_entry);
  gtk_tooltips_set_tip (tooltips, flip_mode_entry, _("Flip effect"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (flip_mode_entry), FALSE);

  vbox16 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox16, "vbox16");
  gtk_widget_ref (vbox16);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "vbox16", vbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox16);
  gtk_box_pack_start (GTK_BOX (hbox12), vbox16, FALSE, FALSE, 0);

  frame = gtk_frame_new (_("Size"));
  gtk_widget_set_name (frame, "frame");
  gtk_widget_ref (frame);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "frame", frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox16), frame, FALSE, TRUE, 0);

  table1 = gtk_table_new (3, 2, TRUE);
  gtk_widget_set_name (table1, "table1");
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (frame), table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table1), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 5);

  height = gtk_entry_new ();
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table1), height, 1, 2, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (height), FALSE);

  width = gtk_entry_new ();
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table1), width, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (width), FALSE);

  label = gtk_label_new (_("Width"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_table_attach (GTK_TABLE (table1), label, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  label = gtk_label_new (_("Height"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_table_attach (GTK_TABLE (table1), label, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  label = gtk_label_new (_("Resolution"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_table_attach (GTK_TABLE (table1), label, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  resolution_combo = gtk_combo_new ();
  gtk_widget_set_name (resolution_combo, "resolution_combo");
  gtk_widget_ref (resolution_combo);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "resolution_combo", resolution_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_combo);
  gtk_table_attach (GTK_TABLE (table1), resolution_combo, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND), 0, 0);
  gtk_widget_set_usize (resolution_combo, 50, -2);
  fill_combo (resolution_combo, 1, 8);

  resolution_entry = GTK_COMBO (resolution_combo)->entry;
  gtk_widget_set_name (resolution_entry, "resolution_entry");
  gtk_widget_ref (resolution_entry);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "resolution_entry", resolution_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_entry);
  gtk_widget_set_usize (resolution_entry, 75, -2);
  gtk_tooltips_set_tip (tooltips, resolution_entry, _("Resolution of applet/image"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (resolution_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (resolution_entry), _("1"));

  hbox14 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox14, "hbox14");
  gtk_widget_ref (hbox14);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "hbox14", hbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox14);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox14, FALSE, TRUE, 0);

  label9 = gtk_label_new (_("Frame speed"));
  gtk_widget_set_name (label9, "label9");
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_box_pack_start (GTK_BOX (hbox14), label9, FALSE, FALSE, 0);

  frame_speed = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (frame_speed, "frame_speed");
  gtk_widget_ref (frame_speed);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "frame_speed", frame_speed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_speed);
  gtk_box_pack_end (GTK_BOX (hbox14), frame_speed, FALSE, TRUE, 0);
  gtk_widget_set_usize (frame_speed, 50, -2);
  gtk_tooltips_set_tip (tooltips, frame_speed, _("Speed of fade between images (1 .. 255)"), NULL);

  hbox15 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox15, "hbox15");
  gtk_widget_ref (hbox15);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "hbox15", hbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox15);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox15, FALSE, TRUE, 0);

  label10 = gtk_label_new (_("Pause (ms)"));
  gtk_widget_set_name (label10, "label10");
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_box_pack_start (GTK_BOX (hbox15), label10, FALSE, FALSE, 0);

  pause = gtk_entry_new_with_max_length (6);
  gtk_widget_set_name (pause, "pause");
  gtk_widget_ref (pause);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "pause", pause,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pause);
  gtk_box_pack_end (GTK_BOX (hbox15), pause, FALSE, TRUE, 0);
  gtk_widget_set_usize (pause, 50, -2);
  gtk_tooltips_set_tip (tooltips, pause, _("\"Hold\" time for images between fades"), NULL);

  hbox16 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox16, "hbox16");
  gtk_widget_ref (hbox16);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "hbox16", hbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox16);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox16, FALSE, TRUE, 0);

  label11 = gtk_label_new (_("Extra height"));
  gtk_widget_set_name (label11, "label11");
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_box_pack_start (GTK_BOX (hbox16), label11, FALSE, FALSE, 0);

  extra_height = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (extra_height, "extra_height");
  gtk_widget_ref (extra_height);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "extra_height", extra_height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (extra_height);
  gtk_box_pack_end (GTK_BOX (hbox16), extra_height, FALSE, TRUE, 0);
  gtk_widget_set_usize (extra_height, 50, -2);
  gtk_tooltips_set_tip (tooltips, extra_height, _("Extra height"), NULL);

  hbox17 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox17, "hbox17");
  gtk_widget_ref (hbox17);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "hbox17", hbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox17);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox17, FALSE, TRUE, 0);

  label12 = gtk_label_new (_("Flip curve"));
  gtk_widget_set_name (label12, "label12");
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_box_pack_start (GTK_BOX (hbox17), label12, FALSE, FALSE, 0);

  flip_combo = gtk_combo_new ();
  gtk_widget_set_name (flip_combo, "flip_combo");
  gtk_widget_ref (flip_combo);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "flip_combo", flip_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (flip_combo);
  gtk_box_pack_end (GTK_BOX (hbox17), flip_combo, FALSE, TRUE, 0);
  gtk_widget_set_usize (flip_combo, 50, -2);
  fill_combo (flip_combo, 1, 10);

  flip_entry = GTK_COMBO (flip_combo)->entry;
  gtk_widget_set_name (flip_entry, "flip_entry");
  gtk_widget_ref (flip_entry);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "flip_entry", flip_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (flip_entry);
  gtk_tooltips_set_tip (tooltips, flip_entry, _("Flip curve (1 .. 10)"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (flip_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (flip_entry), _("2"));

  hbox18 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox18, "hbox18");
  gtk_widget_ref (hbox18);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "hbox18", hbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox18);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox18, FALSE, TRUE, 0);

  label13 = gtk_label_new (_("Shading"));
  gtk_widget_set_name (label13, "label13");
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_box_pack_start (GTK_BOX (hbox18), label13, FALSE, FALSE, 0);

  shading_combo = gtk_combo_new ();
  gtk_widget_set_name (shading_combo, "shading_combo");
  gtk_widget_ref (shading_combo);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "shading_combo", shading_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (shading_combo);
  gtk_box_pack_end (GTK_BOX (hbox18), shading_combo, FALSE, TRUE, 0);
  gtk_widget_set_usize (shading_combo, 50, -2);
  fill_combo (shading_combo, 0, 4);

  shading_entry = GTK_COMBO (shading_combo)->entry;
  gtk_widget_set_name (shading_entry, "shading_entry");
  gtk_widget_ref (shading_entry);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "shading_entry", shading_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (shading_entry);
  gtk_tooltips_set_tip (tooltips, shading_entry, _("Shading (0 .. 4)"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (shading_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (shading_entry), _("0"));

  hbox19 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox19, "hbox19");
  gtk_widget_ref (hbox19);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "hbox19", hbox19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox19);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox19, FALSE, TRUE, 0);

  back_color = gtk_button_new_with_label (_("Back. Color..."));
  gtk_widget_set_name (back_color, "back_color");
  gtk_widget_ref (back_color);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "back_color", back_color,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_color);
  gtk_box_pack_start (GTK_BOX (hbox19), back_color, FALSE, FALSE, 0);

  color_pixmap = set_color_pixmap ((GtkWidget*)NULL, 0, 0, 0);
  gtk_widget_set_name (color_pixmap, "color_pixmap");
  gtk_widget_ref (color_pixmap);
  gtk_object_set_data_full (GTK_OBJECT (bookflip), "color_pixmap", color_pixmap,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (color_pixmap);
  gtk_box_pack_end (GTK_BOX (hbox19), color_pixmap, FALSE, FALSE, 0);

  finish_dialog (bookflip, vbox13, accel_group);

  gtk_signal_connect (GTK_OBJECT (resolution_entry), "changed",
                      GTK_SIGNAL_FUNC (on_resolution_combo_changed), NULL);
  gtk_signal_connect (GTK_OBJECT (add), "clicked",
                      GTK_SIGNAL_FUNC (on_image_list_add), NULL);
  gtk_signal_connect (GTK_OBJECT (remove), "clicked",
                      GTK_SIGNAL_FUNC (on_image_list_remove), NULL);
  gtk_signal_connect (GTK_OBJECT (up), "clicked",
                      GTK_SIGNAL_FUNC (on_image_list_up), NULL);
  gtk_signal_connect (GTK_OBJECT (down), "clicked",
                      GTK_SIGNAL_FUNC (on_image_list_down), NULL);
  gtk_signal_connect (GTK_OBJECT (image_list), "select_row",
                      GTK_SIGNAL_FUNC (on_image_list_select), NULL);
  gtk_signal_connect (GTK_OBJECT (image_link), "focus_out_event",
                      GTK_SIGNAL_FUNC (on_edit_focus_out), NULL);
  gtk_signal_connect (GTK_OBJECT (image_status), "focus_out_event",
                      GTK_SIGNAL_FUNC (on_edit_focus_out), NULL);
  gtk_signal_connect (GTK_OBJECT (flip_mode_entry), "changed",
                      GTK_SIGNAL_FUNC (on_combo_changed), NULL);
  gtk_signal_connect (GTK_OBJECT (back_color), "clicked",
                      GTK_SIGNAL_FUNC (on_back_color), NULL);

  gtk_widget_set_sensitive (up, FALSE);
  gtk_widget_set_sensitive (down, FALSE);
  gtk_widget_set_sensitive (remove, FALSE);
  gtk_widget_set_sensitive (image_link, FALSE);
  gtk_widget_set_sensitive (image_status, FALSE);
  gtk_widget_set_sensitive (flip_mode_combo, FALSE);
  gtk_widget_set_sensitive (width, FALSE);
  gtk_widget_set_sensitive (height, FALSE);

  gtk_object_set_data (GTK_OBJECT (bookflip), "tooltips", tooltips);
  gtk_window_add_accel_group (GTK_WINDOW (bookflip), accel_group);

  return bookflip;
}

GtkWidget* create_cfade ()
{
  GtkWidget *cfade;
  GtkWidget *vbox17;
  GtkWidget *hbox20;
  GtkWidget *frame;
  GtkWidget *vbox18;
  GtkWidget *hbox21;
  GtkWidget *scrolledwindow2;
  GtkWidget *image_list;
  GtkWidget *label619;
  GtkWidget *vbox19;
  GtkWidget *add;
  GtkWidget *up;
  GtkWidget *down;
  GtkWidget *remove;
  GtkWidget *label;
  GtkWidget *image_link;
  GtkWidget *image_status;
  GtkWidget *vbox20;
  GtkWidget *table2;
  GtkWidget *height;
  GtkWidget *width;
  GtkWidget *label20;
  GtkWidget *label21;
  GtkWidget *resolution_combo;
  GtkWidget *resolution_entry;
  GtkWidget *progressive;
  GtkWidget *hbox23;
  GtkWidget *frame_speed;
  GtkWidget *hbox24;
  GtkWidget *pause;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;

  cfade = init_dialog (&accel_group, &tooltips, &vbox17);

  hbox20 = gtk_hbox_new (FALSE, 10);
  gtk_widget_set_name (hbox20, "hbox20");
  gtk_widget_ref (hbox20);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "hbox20", hbox20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox20);
  gtk_box_pack_start (GTK_BOX (vbox17), hbox20, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox20), 5);

  frame = gtk_frame_new (_("Images"));
  gtk_widget_set_name (frame, "frame");
  gtk_widget_ref (frame);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "frame", frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox20), frame, TRUE, TRUE, 0);

  vbox18 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox18, "vbox18");
  gtk_widget_ref (vbox18);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "vbox18", vbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox18);
  gtk_container_add (GTK_CONTAINER (frame), vbox18);
  gtk_container_set_border_width (GTK_CONTAINER (vbox18), 5);

  hbox21 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox21, "hbox21");
  gtk_widget_ref (hbox21);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "hbox21", hbox21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox21);
  gtk_box_pack_start (GTK_BOX (vbox18), hbox21, TRUE, TRUE, 0);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow2, "scrolledwindow2");
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (hbox21), scrolledwindow2, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  image_list = gtk_clist_new (1);
  gtk_widget_set_name (image_list, "image_list");
  gtk_widget_ref (image_list);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "image_list", image_list,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_list);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), image_list);
  gtk_tooltips_set_tip (tooltips, image_list, _("Images: you can choose same image more than one time"), NULL);
  gtk_clist_set_column_width (GTK_CLIST (image_list), 0, 80);
  gtk_clist_column_titles_hide (GTK_CLIST (image_list));

  label619 = gtk_label_new (_("label619"));
  gtk_widget_set_name (label619, "label619");
  gtk_widget_ref (label619);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "label619", label619,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label619);
  gtk_clist_set_column_widget (GTK_CLIST (image_list), 0, label619);

  vbox19 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox19, "vbox19");
  gtk_widget_ref (vbox19);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "vbox19", vbox19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox19);
  gtk_box_pack_start (GTK_BOX (hbox21), vbox19, FALSE, TRUE, 0);
  gtk_widget_set_usize (vbox19, 70, -2);

  add = gtk_button_new_with_label (_("Add..."));
  gtk_widget_set_name (add, "add");
  gtk_widget_ref (add);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "add", add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add);
  gtk_box_pack_start (GTK_BOX (vbox19), add, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, add, _("Select images to add"), NULL);

  up = gtk_button_new_with_label (_("Move up"));
  gtk_widget_set_name (up, "up");
  gtk_widget_ref (up);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "up", up,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (up);
  gtk_box_pack_start (GTK_BOX (vbox19), up, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, up, _("Move up the selected image"), NULL);

  down = gtk_button_new_with_label (_("Move down"));
  gtk_widget_set_name (down, "down");
  gtk_widget_ref (down);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "down", down,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (down);
  gtk_box_pack_start (GTK_BOX (vbox19), down, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, down, _("Move down the selected image"), NULL);

  remove = gtk_button_new_with_label (_("Remove"));
  gtk_widget_set_name (remove, "remove");
  gtk_widget_ref (remove);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "remove", remove,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (remove);
  gtk_box_pack_start (GTK_BOX (vbox19), remove, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, remove, _("Remove image from list"), NULL);

  label = gtk_label_new (_("Current selected image link (http:// if not same site)"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox18), label, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  image_link = gtk_entry_new ();
  gtk_widget_set_name (image_link, "image_link");
  gtk_widget_ref (image_link);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "image_link", image_link,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_link);
  gtk_box_pack_start (GTK_BOX (vbox18), image_link, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, image_link, _("Link associated to selected image (only when registered)"), NULL);

  label = gtk_label_new (_("Status message for selected image"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox18), label, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  image_status = gtk_entry_new ();
  gtk_widget_set_name (image_status, "image_status");
  gtk_widget_ref (image_status);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "image_status", image_status,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_status);
  gtk_box_pack_start (GTK_BOX (vbox18), image_status, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, image_status, _("Status message for selected image"), NULL);

  vbox20 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox20, "vbox20");
  gtk_widget_ref (vbox20);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "vbox20", vbox20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox20);
  gtk_box_pack_start (GTK_BOX (hbox20), vbox20, FALSE, TRUE, 0);

  frame = gtk_frame_new (_("Size"));
  gtk_widget_set_name (frame, "frame");
  gtk_widget_ref (frame);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "frame", frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox20), frame, FALSE, TRUE, 0);

  table2 = gtk_table_new (3, 2, TRUE);
  gtk_widget_set_name (table2, "table2");
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (frame), table2);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table2), 5);

  height = gtk_entry_new ();
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table2), height, 1, 2, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (height), FALSE);

  width = gtk_entry_new ();
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table2), width, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (width), FALSE);

  label20 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label20, "label20");
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label20);
  gtk_table_attach (GTK_TABLE (table2), label20, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label20), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label20), 0, 0.5);

  label21 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label21, "label21");
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_table_attach (GTK_TABLE (table2), label21, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label21), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label21), 0, 0.5);

  label = gtk_label_new (_("Resolution"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_table_attach (GTK_TABLE (table2), label, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  resolution_combo = gtk_combo_new ();
  gtk_widget_set_name (resolution_combo, "resolution_combo");
  gtk_widget_ref (resolution_combo);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "resolution_combo", resolution_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_combo);
  gtk_table_attach (GTK_TABLE (table2), resolution_combo, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND), 0, 0);
  gtk_widget_set_usize (resolution_combo, 50, -2);
  fill_combo (resolution_combo, 1, 8);

  resolution_entry = GTK_COMBO (resolution_combo)->entry;
  gtk_widget_set_name (resolution_entry, "resolution_entry");
  gtk_widget_ref (resolution_entry);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "resolution_entry", resolution_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_entry);
  gtk_widget_set_usize (resolution_entry, 75, -2);
  gtk_tooltips_set_tip (tooltips, resolution_entry, _("Resolution of applet/image"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (resolution_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (resolution_entry), _("1"));

  progressive = gtk_check_button_new_with_label (_("Progressive"));
  gtk_widget_set_name (progressive, "progressive");
  gtk_widget_ref (progressive);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "progressive", progressive,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (progressive);
  gtk_box_pack_start (GTK_BOX (vbox20), progressive, FALSE, FALSE, 0);

  hbox23 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox23, "hbox23");
  gtk_widget_ref (hbox23);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "hbox23", hbox23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox23);
  gtk_box_pack_start (GTK_BOX (vbox20), hbox23, FALSE, TRUE, 0);

  label = gtk_label_new (_("Frame speed"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox23), label, FALSE, FALSE, 0);

  frame_speed = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (frame_speed, "frame_speed");
  gtk_widget_ref (frame_speed);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "frame_speed", frame_speed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_speed);
  gtk_box_pack_end (GTK_BOX (hbox23), frame_speed, FALSE, TRUE, 0);
  gtk_widget_set_usize (frame_speed, 50, -2);
  gtk_tooltips_set_tip (tooltips, frame_speed, _("Speed of fade between images (1 .. 255)"), NULL);

  hbox24 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox24, "hbox24");
  gtk_widget_ref (hbox24);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "hbox24", hbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox24);
  gtk_box_pack_start (GTK_BOX (vbox20), hbox24, FALSE, TRUE, 0);

  label = gtk_label_new (_("Pause (ms)"));
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox24), label, FALSE, FALSE, 0);

  pause = gtk_entry_new_with_max_length (6);
  gtk_widget_set_name (pause, "pause");
  gtk_widget_ref (pause);
  gtk_object_set_data_full (GTK_OBJECT (cfade), "pause", pause,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pause);
  gtk_box_pack_end (GTK_BOX (hbox24), pause, FALSE, TRUE, 0);
  gtk_widget_set_usize (pause, 50, -2);
  gtk_tooltips_set_tip (tooltips, pause, _("\"Hold\" time for images between fades"), NULL);

  finish_dialog (cfade, vbox17, accel_group);

  gtk_signal_connect (GTK_OBJECT (resolution_entry), "changed",
                      GTK_SIGNAL_FUNC (on_resolution_combo_changed), NULL);
  gtk_signal_connect (GTK_OBJECT (add), "clicked",
                      GTK_SIGNAL_FUNC (on_image_list_add), NULL);
  gtk_signal_connect (GTK_OBJECT (remove), "clicked",
                      GTK_SIGNAL_FUNC (on_image_list_remove), NULL);
  gtk_signal_connect (GTK_OBJECT (up), "clicked",
                      GTK_SIGNAL_FUNC (on_image_list_up), NULL);
  gtk_signal_connect (GTK_OBJECT (down), "clicked",
                      GTK_SIGNAL_FUNC (on_image_list_down), NULL);
  gtk_signal_connect (GTK_OBJECT (image_list), "select_row",
                      GTK_SIGNAL_FUNC (on_image_list_select), NULL);
  gtk_signal_connect (GTK_OBJECT (image_link), "focus_out_event",
                      GTK_SIGNAL_FUNC (on_edit_focus_out), NULL);
  gtk_signal_connect (GTK_OBJECT (image_status), "focus_out_event",
                      GTK_SIGNAL_FUNC (on_edit_focus_out), NULL);

  gtk_widget_set_sensitive (up, FALSE);
  gtk_widget_set_sensitive (down, FALSE);
  gtk_widget_set_sensitive (remove, FALSE);
  gtk_widget_set_sensitive (image_link, FALSE);
  gtk_widget_set_sensitive (image_status, FALSE);
  gtk_widget_set_sensitive (width, FALSE);
  gtk_widget_set_sensitive (height, FALSE);

  gtk_object_set_data (GTK_OBJECT (cfade), "tooltips", tooltips);
  gtk_window_add_accel_group (GTK_WINDOW (cfade), accel_group);

  return cfade;
}

GtkWidget* create_mosaic ()
{
  GtkWidget *mosaic;
  GtkWidget *vbox21;
  GtkWidget *hbox29;
  GtkWidget *frame10;
  GtkWidget *vbox22;
  GtkWidget *hbox30;
  GtkWidget *scrolledwindow4;
  GtkWidget *image_list;
  GtkWidget *label622;
  GtkWidget *vbox23;
  GtkWidget *add;
  GtkWidget *up;
  GtkWidget *down;
  GtkWidget *remove;
  GtkWidget *label26;
  GtkWidget *image_link;
  GtkWidget *label27;
  GtkWidget *image_status;
  GtkWidget *vbox24;
  GtkWidget *frame12;
  GtkWidget *table3;
  GtkWidget *label29;
  GtkWidget *label30;
  GtkWidget *label31;
  GtkWidget *resolution_combo;
  GtkWidget *resolution_entry;
  GtkWidget *height;
  GtkWidget *width;
  GtkWidget *frame13;
  GtkWidget *table4;
  GtkWidget *tile_steps;
  GtkWidget *tile_height;
  GtkWidget *tile_width;
  GtkWidget *label36;
  GtkWidget *label37;
  GtkWidget *label38;
  GtkWidget *hbox38;
  GtkWidget *vbox27;
  GtkWidget *hbox39;
  GtkWidget *back_image_check;
  GtkWidget *back_image_browse;
  GtkWidget *back_image;
  GtkWidget *vbox26;
  GtkWidget *hbox32;
  GtkWidget *label33;
  GtkWidget *pause;
  GtkWidget *hbox36;
  GtkWidget *back_color;
  GtkWidget *color_pixmap;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;

  mosaic = init_dialog (&accel_group, &tooltips, &vbox21);

  hbox29 = gtk_hbox_new (FALSE, 10);
  gtk_widget_set_name (hbox29, "hbox29");
  gtk_widget_ref (hbox29);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "hbox29", hbox29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox29);
  gtk_box_pack_start (GTK_BOX (vbox21), hbox29, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox29), 5);

  frame10 = gtk_frame_new (_("Images"));
  gtk_widget_set_name (frame10, "frame10");
  gtk_widget_ref (frame10);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "frame10", frame10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame10);
  gtk_box_pack_start (GTK_BOX (hbox29), frame10, TRUE, TRUE, 0);

  vbox22 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox22, "vbox22");
  gtk_widget_ref (vbox22);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "vbox22", vbox22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox22);
  gtk_container_add (GTK_CONTAINER (frame10), vbox22);
  gtk_container_set_border_width (GTK_CONTAINER (vbox22), 5);

  hbox30 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox30, "hbox30");
  gtk_widget_ref (hbox30);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "hbox30", hbox30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox30);
  gtk_box_pack_start (GTK_BOX (vbox22), hbox30, TRUE, TRUE, 0);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow4, "scrolledwindow4");
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (hbox30), scrolledwindow4, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  image_list = gtk_clist_new (1);
  gtk_widget_set_name (image_list, "image_list");
  gtk_widget_ref (image_list);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "image_list", image_list,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_list);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), image_list);
  gtk_tooltips_set_tip (tooltips, image_list, _("Images: you can choose same image more than one time"), NULL);
  gtk_clist_set_column_width (GTK_CLIST (image_list), 0, 80);
  gtk_clist_column_titles_hide (GTK_CLIST (image_list));

  label622 = gtk_label_new (_("label619"));
  gtk_widget_set_name (label622, "label622");
  gtk_widget_ref (label622);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "label622", label622,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label622);
  gtk_clist_set_column_widget (GTK_CLIST (image_list), 0, label622);

  vbox23 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox23, "vbox23");
  gtk_widget_ref (vbox23);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "vbox23", vbox23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox23);
  gtk_box_pack_start (GTK_BOX (hbox30), vbox23, FALSE, TRUE, 0);
  gtk_widget_set_usize (vbox23, 70, -2);

  add = gtk_button_new_with_label (_("Add..."));
  gtk_widget_set_name (add, "add");
  gtk_widget_ref (add);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "add", add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add);
  gtk_box_pack_start (GTK_BOX (vbox23), add, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, add, _("Select images to add"), NULL);

  up = gtk_button_new_with_label (_("Move up"));
  gtk_widget_set_name (up, "up");
  gtk_widget_ref (up);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "up", up,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (up);
  gtk_box_pack_start (GTK_BOX (vbox23), up, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, up, _("Move up the selected image"), NULL);

  down = gtk_button_new_with_label (_("Move down"));
  gtk_widget_set_name (down, "down");
  gtk_widget_ref (down);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "down", down,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (down);
  gtk_box_pack_start (GTK_BOX (vbox23), down, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, down, _("Move down the selected image"), NULL);

  remove = gtk_button_new_with_label (_("Remove"));
  gtk_widget_set_name (remove, "remove");
  gtk_widget_ref (remove);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "remove", remove,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (remove);
  gtk_box_pack_start (GTK_BOX (vbox23), remove, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, remove, _("Remove image from list"), NULL);

  label26 = gtk_label_new (_("Current selected image link (http:// if not same site)"));
  gtk_widget_set_name (label26, "label26");
  gtk_widget_ref (label26);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "label26", label26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label26);
  gtk_box_pack_start (GTK_BOX (vbox22), label26, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label26), 0, 0.5);

  image_link = gtk_entry_new ();
  gtk_widget_set_name (image_link, "image_link");
  gtk_widget_ref (image_link);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "image_link", image_link,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_link);
  gtk_box_pack_start (GTK_BOX (vbox22), image_link, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, image_link, _("Link associated to selected image (only when registered)"), NULL);

  label27 = gtk_label_new (_("Status message for selected image"));
  gtk_widget_set_name (label27, "label27");
  gtk_widget_ref (label27);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "label27", label27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label27);
  gtk_box_pack_start (GTK_BOX (vbox22), label27, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label27), 0, 0.5);

  image_status = gtk_entry_new ();
  gtk_widget_set_name (image_status, "image_status");
  gtk_widget_ref (image_status);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "image_status", image_status,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_status);
  gtk_box_pack_start (GTK_BOX (vbox22), image_status, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, image_status, _("Status message for selected image"), NULL);

  vbox24 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox24, "vbox24");
  gtk_widget_ref (vbox24);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "vbox24", vbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox24);
  gtk_box_pack_start (GTK_BOX (hbox29), vbox24, FALSE, TRUE, 0);

  frame12 = gtk_frame_new (_("Size"));
  gtk_widget_set_name (frame12, "frame12");
  gtk_widget_ref (frame12);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "frame12", frame12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame12);
  gtk_box_pack_start (GTK_BOX (vbox24), frame12, TRUE, TRUE, 0);

  table3 = gtk_table_new (3, 2, TRUE);
  gtk_widget_set_name (table3, "table3");
  gtk_widget_ref (table3);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "table3", table3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table3);
  gtk_container_add (GTK_CONTAINER (frame12), table3);
  gtk_container_set_border_width (GTK_CONTAINER (table3), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table3), 5);

  label29 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label29, "label29");
  gtk_widget_ref (label29);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "label29", label29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label29);
  gtk_table_attach (GTK_TABLE (table3), label29, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label29), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label29), 0, 0.5);

  label30 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label30, "label30");
  gtk_widget_ref (label30);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "label30", label30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label30);
  gtk_table_attach (GTK_TABLE (table3), label30, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label30), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label30), 0, 0.5);

  label31 = gtk_label_new (_("Resolution"));
  gtk_widget_set_name (label31, "label31");
  gtk_widget_ref (label31);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "label31", label31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label31);
  gtk_table_attach (GTK_TABLE (table3), label31, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label31), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label31), 0, 0.5);

  resolution_combo = gtk_combo_new ();
  gtk_widget_set_name (resolution_combo, "resolution_combo");
  gtk_widget_ref (resolution_combo);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "resolution_combo", resolution_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_combo);
  gtk_table_attach (GTK_TABLE (table3), resolution_combo, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND), 0, 0);
  gtk_widget_set_usize (resolution_combo, 50, -2);
  fill_combo (resolution_combo, 1, 8);

  resolution_entry = GTK_COMBO (resolution_combo)->entry;
  gtk_widget_set_name (resolution_entry, "resolution_entry");
  gtk_widget_ref (resolution_entry);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "resolution_entry", resolution_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_entry);
  gtk_tooltips_set_tip (tooltips, resolution_entry, _("Resolution of applet/image"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (resolution_entry), FALSE);

  height = gtk_entry_new ();
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table3), height, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (height), FALSE);

  width = gtk_entry_new ();
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table3), width, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (width), FALSE);

  frame13 = gtk_frame_new (_("Tiles"));
  gtk_widget_set_name (frame13, "frame13");
  gtk_widget_ref (frame13);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "frame13", frame13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame13);
  gtk_box_pack_start (GTK_BOX (vbox24), frame13, TRUE, TRUE, 0);

  table4 = gtk_table_new (3, 2, TRUE);
  gtk_widget_set_name (table4, "table4");
  gtk_widget_ref (table4);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "table4", table4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table4);
  gtk_container_add (GTK_CONTAINER (frame13), table4);
  gtk_container_set_border_width (GTK_CONTAINER (table4), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table4), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table4), 5);

  tile_steps = gtk_entry_new_with_max_length (2);
  gtk_widget_set_name (tile_steps, "tile_steps");
  gtk_widget_ref (tile_steps);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "tile_steps", tile_steps,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tile_steps);
  gtk_table_attach (GTK_TABLE (table4), tile_steps, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (tile_steps, 50, -2);
  gtk_tooltips_set_tip (tooltips, tile_steps, _("Rotation speed of tiles (8 .. 32)"), NULL);

  tile_height = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (tile_height, "tile_height");
  gtk_widget_ref (tile_height);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "tile_height", tile_height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tile_height);
  gtk_table_attach (GTK_TABLE (table4), tile_height, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (tile_height, 50, -2);
  gtk_tooltips_set_tip (tooltips, tile_height, _("Tiles height (change applet vertical size)"), NULL);

  tile_width = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (tile_width, "tile_width");
  gtk_widget_ref (tile_width);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "tile_width", tile_width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tile_width);
  gtk_table_attach (GTK_TABLE (table4), tile_width, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (tile_width, 50, -2);
  gtk_tooltips_set_tip (tooltips, tile_width, _("Tiles width (change applet horizontal size)"), NULL);

  label36 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label36, "label36");
  gtk_widget_ref (label36);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "label36", label36,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label36);
  gtk_table_attach (GTK_TABLE (table4), label36, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label36), 0, 0.5);

  label37 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label37, "label37");
  gtk_widget_ref (label37);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "label37", label37,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label37);
  gtk_table_attach (GTK_TABLE (table4), label37, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label37), 0, 0.5);

  label38 = gtk_label_new (_("Steps"));
  gtk_widget_set_name (label38, "label38");
  gtk_widget_ref (label38);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "label38", label38,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label38);
  gtk_table_attach (GTK_TABLE (table4), label38, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label38), 0, 0.5);

  hbox38 = gtk_hbox_new (FALSE, 10);
  gtk_widget_set_name (hbox38, "hbox38");
  gtk_widget_ref (hbox38);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "hbox38", hbox38,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox38);
  gtk_box_pack_start (GTK_BOX (vbox21), hbox38, FALSE, TRUE, 0);

  vbox27 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox27, "vbox27");
  gtk_widget_ref (vbox27);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "vbox27", vbox27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox27);
  gtk_box_pack_start (GTK_BOX (hbox38), vbox27, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox27), 5);

  hbox39 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox39, "hbox39");
  gtk_widget_ref (hbox39);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "hbox39", hbox39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox39);
  gtk_box_pack_start (GTK_BOX (vbox27), hbox39, TRUE, TRUE, 0);

  back_image_check = gtk_check_button_new_with_label (_("Background image"));
  gtk_widget_set_name (back_image_check, "back_image_check");
  gtk_widget_ref (back_image_check);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "back_image_check", back_image_check,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_image_check);
  gtk_box_pack_start (GTK_BOX (hbox39), back_image_check, FALSE, FALSE, 0);

  back_image_browse = gtk_button_new_with_label (_("Browse..."));
  gtk_widget_set_name (back_image_browse, "back_image_browse");
  gtk_widget_ref (back_image_browse);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "back_image_browse", back_image_browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_image_browse);
  gtk_box_pack_end (GTK_BOX (hbox39), back_image_browse, FALSE, FALSE, 0);
  gtk_widget_set_usize (back_image_browse, 90, -2);
  gtk_tooltips_set_tip (tooltips, back_image_browse, _("Browse for background image"), NULL);

  back_image = gtk_entry_new ();
  gtk_widget_set_name (back_image, "back_image");
  gtk_widget_ref (back_image);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "back_image", back_image,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_image);
  gtk_box_pack_start (GTK_BOX (vbox27), back_image, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, back_image, _("Background image path"), NULL);

  vbox26 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox26, "vbox26");
  gtk_widget_ref (vbox26);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "vbox26", vbox26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox26);
  gtk_box_pack_start (GTK_BOX (hbox38), vbox26, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox26), 5);

  hbox32 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox32, "hbox32");
  gtk_widget_ref (hbox32);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "hbox32", hbox32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox32);
  gtk_box_pack_start (GTK_BOX (vbox26), hbox32, FALSE, FALSE, 0);

  label33 = gtk_label_new (_("Pause (ms)"));
  gtk_widget_set_name (label33, "label33");
  gtk_widget_ref (label33);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "label33", label33,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label33);
  gtk_box_pack_start (GTK_BOX (hbox32), label33, FALSE, FALSE, 0);

  pause = gtk_entry_new_with_max_length (6);
  gtk_widget_set_name (pause, "pause");
  gtk_widget_ref (pause);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "pause", pause,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pause);
  gtk_box_pack_end (GTK_BOX (hbox32), pause, FALSE, FALSE, 0);
  gtk_widget_set_usize (pause, 50, -2);
  gtk_tooltips_set_tip (tooltips, pause, _("\"Hold\" time for images between fades"), NULL);

  hbox36 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox36, "hbox36");
  gtk_widget_ref (hbox36);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "hbox36", hbox36,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox36);
  gtk_box_pack_start (GTK_BOX (vbox26), hbox36, TRUE, TRUE, 0);

  back_color = gtk_button_new_with_label (_("Back. Color..."));
  gtk_widget_set_name (back_color, "back_color");
  gtk_widget_ref (back_color);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "back_color", back_color,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_color);
  gtk_box_pack_start (GTK_BOX (hbox36), back_color, FALSE, FALSE, 0);

  color_pixmap = set_color_pixmap ((GtkWidget*)NULL, 0, 0, 0);
  gtk_widget_set_name (color_pixmap, "color_pixmap");
  gtk_widget_ref (color_pixmap);
  gtk_object_set_data_full (GTK_OBJECT (mosaic), "color_pixmap", color_pixmap,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (color_pixmap);
  gtk_box_pack_end (GTK_BOX (hbox36), color_pixmap, FALSE, FALSE, 0);

  finish_dialog (mosaic, vbox21, accel_group);

  gtk_signal_connect (GTK_OBJECT (resolution_entry), "changed",
                      GTK_SIGNAL_FUNC (on_resolution_combo_changed), NULL);
  gtk_signal_connect (GTK_OBJECT (add), "clicked",
                      GTK_SIGNAL_FUNC (on_image_list_add), NULL);
  gtk_signal_connect (GTK_OBJECT (remove), "clicked",
                      GTK_SIGNAL_FUNC (on_image_list_remove), NULL);
  gtk_signal_connect (GTK_OBJECT (up), "clicked",
                      GTK_SIGNAL_FUNC (on_image_list_up), NULL);
  gtk_signal_connect (GTK_OBJECT (down), "clicked",
                      GTK_SIGNAL_FUNC (on_image_list_down), NULL);
  gtk_signal_connect (GTK_OBJECT (image_list), "select_row",
                      GTK_SIGNAL_FUNC (on_image_list_select), NULL);
  gtk_signal_connect (GTK_OBJECT (image_link), "focus_out_event",
                      GTK_SIGNAL_FUNC (on_edit_focus_out), NULL);
  gtk_signal_connect (GTK_OBJECT (image_status), "focus_out_event",
                      GTK_SIGNAL_FUNC (on_edit_focus_out), NULL);
  gtk_signal_connect (GTK_OBJECT (back_color), "clicked",
                      GTK_SIGNAL_FUNC (on_back_color), NULL);
  gtk_signal_connect (GTK_OBJECT (back_image_browse), "clicked",
                      GTK_SIGNAL_FUNC (on_back_image_browse), NULL);
  gtk_signal_connect (GTK_OBJECT (back_image_check), "toggled",
                      GTK_SIGNAL_FUNC (on_back_image_toggle), NULL);

  gtk_widget_set_sensitive (up, FALSE);
  gtk_widget_set_sensitive (down, FALSE);
  gtk_widget_set_sensitive (remove, FALSE);
  gtk_widget_set_sensitive (image_link, FALSE);
  gtk_widget_set_sensitive (image_status, FALSE);
  gtk_widget_set_sensitive (width, FALSE);
  gtk_widget_set_sensitive (height, FALSE);

  gtk_object_set_data (GTK_OBJECT (mosaic), "tooltips", tooltips);
  gtk_window_add_accel_group (GTK_WINDOW (mosaic), accel_group);

  return mosaic;
}

