

typedef enum
{
  APPLET_ANBLUR,
  APPLET_ANFYBUMP,
  APPLET_ANFADE,
  APPLET_ANFLAG,
  APPLET_ANFRACT,
  APPLET_ANLAKE,
  APPLET_ANLENS,
  APPLET_BLOBS,
  APPLET_CUBEMENU,
  APPLET_DEFORM,
  APPLET_FIRE,
  APPLET_FLAGLOAD,
  APPLET_FLOZOIDS,
  APPLET_FLUID,
  APPLET_HUEROT,
  APPLET_MANDEL,
  APPLET_LIFE2D,
  APPLET_ROTATE,
  APPLET_PLASMA,
  APPLET_ANTUNNEL,
  APPLET_TMAPCUBE,
  APPLET_ANVOXEL,
  APPLET_TUNNEL3D,
  APPLET_ANWATER,
  APPLET_WARP,
  APPLET_WORMHOLE,
  APPLET_GALAXY,
  APPLET_BOOKFLIP,
  APPLET_MOSAIC,
  APPLET_ANFY3D,
  APPLET_WHEEL,
  APPLET_MORPHMENU,
  APPLET_WOBBLER,
  APPLET_TSCROLLER,
  APPLET_TREEMENU,
  APPLET_ANFYCAM,
  APPLET_ANFYPAINT,
  APPLET_SOLIDSCROLLER,
  APPLET_ANFYSNOW,
  APPLET_FIREWORKS,
  NUMAPPLETS
} APPLET_ENUM;


typedef enum {
  DLG_STEP0,
  DLG_ANBLUR,
  DLG_BLOBS,
  DLG_TEXTSTYLE,
  DLG_STEP1,
  DLG_EXPERTMODE,
  DLG_ANFYBUMP,
  DLG_ANFADE,
  DLG_BOOKFLIP,
  DLG_BROWSER,
  DLG_CUBEMENU,
  DLG_DEFORM,
  DLG_FIRE,
  DLG_ANFLAG,
  DLG_FLAGLOAD,
  DLG_FLOZOIDS,
  DLG_FLUID,
  DLG_HUEROT,
  DLG_ANFRACT,
  DLG_ANLAKE,
  DLG_ANLENS,
  DLG_LIFE2D,
  DLG_MANDEL,
  DLG_PLASMA,
  DLG_REGISTRATION,
  DLG_ROTATE,
  DLG_TMAPCUBE,
  DLG_TUNNEL,
  DLG_TUNNEL3D,
  DLG_VOXEL,
  DLG_WARP,
  DLG_ANWATER,
  DLG_WORMHOLE,
  DLG_1,
  DLG_GALAXY,
  DLG_MOSAIC,
  DLG_ANFY3D,
  DLG_ANFY3D_0,
  DLG_INFO2,
  DLG_INFO1,
  DLG_INFO3,
  DLG_WHEEL,
  DLG_MORPHMENU,
  DLG_WOBBLER,
  DLG_CONF_MENU,
  DLG_TSCROLLER,
  DLG_MM_GALAXY,
  DLG_MM_BLOBS,
  DLG_TREEMENU,
  DLG_ANFYCAM,
  DLG_ANFYPAINT,
  DLG_SOLIDSCROLLER,
  DLG_ANFYFONT,
  DLG_ANSNOW,
  DLG_ANFYSNOW,
  DLG_FIREWORKS,
  DLG_CONF_MENU_2
} ANFY_DIALOGS;

typedef struct
{
  char* image;
  char* link;
  char* status;
  char* flip;
} IMAGE_INFO;

void free_image_info (IMAGE_INFO* info);
GtkWidget* set_color_pixmap (GtkWidget* pixwidget, int r, int g, int b);
GtkWidget* valid_widget (GtkWidget *widget, const gchar *widget_name);

typedef struct
{
  char* name;
  char* description;
} INFO;

typedef struct
{
  const char* description;
  const char* code;
} CHAR_SET;

extern CHAR_SET map_char_set[];

typedef struct _ITEM_DATA
{
  char strURL[256];
  gboolean bNewFrame;
  char strNewFrameName[128];
  gboolean bBack;
  int iIconIndex;
  gboolean bDisableDropAfter;
} ITEM_DATA;

extern GList* icon_list;
extern GList* image_info;
extern GtkWidget* main_dlg;
extern INFO applet_info[NUMAPPLETS];
extern int current_dialog;
extern int current_applet;
void change_dialog ();

extern int dlg_showfloat;
extern int dlg_showtextstyle;
extern int dlg_oldres;
extern int dlg_oldextrah;
extern int dlg_backcolor_red;
extern int dlg_backcolor_green;
extern int dlg_backcolor_blue;
extern int dlg_f1color_red;
extern int dlg_f1color_green;
extern int dlg_f1color_blue;
extern int dlg_f2color_red;
extern int dlg_f2color_green;
extern int dlg_f2color_blue;
extern int dlg_forcolor_red;
extern int dlg_forcolor_green;
extern int dlg_forcolor_blue;
extern guint32 dlg_ul_backcolor;
extern guint32 dlg_ul_pencolor;
extern guint32 dlg_ul_wheelcolor;
extern guint32 dlg_ul_textcolor;
extern guint32 dlg_ul_selectcolor;
extern guint32 dlg_ul_seedcolor;
extern int dlg_firecolor_red;
extern int dlg_firecolor_green;
extern int dlg_firecolor_blue;
extern guint32 dlg_ul_firecolor;
extern guint32 dlg_ul_selbackcolor;
extern guint32 dlg_ul_scrollcolor;
extern guint32 dlg_ul_filtercolor;
extern int dlg_plugin;
extern int dlg_textcolor_red;
extern int dlg_textcolor_green;
extern int dlg_textcolor_blue;
extern int dlg_textscolor_red;
extern int dlg_textscolor_green;
extern int dlg_textscolor_blue;

extern char g_strAppPath[256];
extern char g_strAppletDir[256];
extern char g_strHelpDir[256];

int message_box (char* text, int yesno);

#define STR_PARAMCREDITS  "<param name=\"credits\" value=\"Applet by Fabio Ciucci (www.anfyteam.com)\">\r\n"
#define STR_PARAMCREDITS2 "<param name=\"credits\" value=\"Applet by Andrea Fasce (www.anfyteam.com)\">\r\n"
#define STR_PARAMCREDITS1 "<param name=\"credits\" value=\"Applet by Anfy Team (www.anfyteam.com)\">\r\n"

char* PathFromFile(char* szFilePath, char* szPath);
char* FileFromPath(char* szFilePath, char* szFile);
int MyCopyFile(char* szDirOri, char* szDirDest, char* szFileName);
int GetFormatAndSize(char* strPathFileName, char* szImgFormat, unsigned int* uiWidth, unsigned int* uiHeight);
void GetAppletPath (int applet, char* dir);

