#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "main.h"
#include "custom.h"
#include "support.h"
#include "callback.h"
#include "misc.h"

#define GetRValue(rgb)  ((guint8)(rgb))
#define GetGValue(rgb)  ((guint8)(((guint16)(rgb)) >> 8))
#define GetBValue(rgb)  ((guint8)((rgb)>>16))  
#define _ttoi(s) strtol(s, NULL, 10)
#define MAX_SCROLLTEXT_SIZE         32767
int GeneratePreviewFile (const int applet, int bForPublish);

// =========================================================

char* GenerateHtmlAppletTag (int applet);

#define READ_INT(n, i) { \
    GetSavedVar(ini_section, n, strtmp); \
    i = strtol(strtmp, NULL, 10); }

#define READ_UL(n, i) { \
    GetSavedVar(ini_section, n, strtmp); \
    i = strtoul(strtmp, NULL, 16); }

#define READ_ENTRY(n, w) { \
    GetSavedVar(ini_section, n, strtmp); \
    gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, w)), strtmp); }

#define READ_ENTRY_INT(n, w, i) { \
    GetSavedVar(ini_section, n, strtmp); \
    gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, w)), strtmp); \
    i = strtol(strtmp, NULL, 10); }

#define READ_CHECK(n, w) { \
    widget = lookup_widget (main_dlg, w); \
    GetSavedVar (ini_section, n, strtmp); \
    if (strcmp (strtmp, INI_NO) == 0) \
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE); \
    else \
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE); }

// =========================================================

GdkPixmap *folder0_pixmap, *folder1_pixmap, *item_pixmap;
GdkBitmap *folder0_mask, *folder1_mask, *item_mask;
#define PACKAGE_DATA_DIR "/usr/local/share/anfy"

void create_tree_pixmaps ()
{
   GtkStyle *style;
   style = gtk_widget_get_style (main_dlg);

   if (folder0_pixmap == NULL)
   {
     folder0_pixmap = gdk_pixmap_create_from_xpm (main_dlg->window, &folder0_mask,
						  &style->bg[GTK_STATE_NORMAL],
						  PACKAGE_DATA_DIR "/pixmaps/folder0.xpm");
   }

   if (folder1_pixmap == NULL)
   {
     folder1_pixmap = gdk_pixmap_create_from_xpm (main_dlg->window, &folder1_mask,
						  &style->bg[GTK_STATE_NORMAL],
						  PACKAGE_DATA_DIR "/pixmaps/folder1.xpm");
   }

   if (item_pixmap == NULL)
   {
     item_pixmap = gdk_pixmap_create_from_xpm (main_dlg->window, &item_mask,
					       &style->bg[GTK_STATE_NORMAL],
					       PACKAGE_DATA_DIR "/pixmaps/tree_ite.xpm");
   }
}

void RestoreTreeCtrl (char* strINISection, GtkCTree* ptc, GtkCTreeNode* item, char x, char y, char* pcLink, char cParent)
{
  char strCaption[256], strLabel[256], strItem[256], *row[2] = { NULL, NULL };
  GtkCTreeNode* newItem;
  ITEM_DATA* pItemData;
  gboolean bBack=FALSE;

  create_tree_pixmaps ();

  sprintf (strCaption, "%s%c%c", INI_MENU_TEXT_, x, y);
  GetSavedVar(strINISection, strCaption, strItem );
  if (strlen (strItem) == 0)
    return;

  strcpy (strLabel, strItem);
  row[0] = strLabel;
  newItem = gtk_ctree_insert_node (ptc, item, NULL, row, 5, item_pixmap, item_mask,
				   item_pixmap, item_mask, TRUE, FALSE);

  sprintf (strCaption, "%s%c%c", INI_MENU_URL_, x, y);
  GetSavedVar(strINISection, strCaption, strItem );

  pItemData = malloc (sizeof (ITEM_DATA));
  if (pItemData != NULL)
  {
    strcpy (pItemData->strURL, strItem);

    sprintf (strCaption, "%s%c%c",INI_MENU_TARGET_, x, y);
    GetSavedVar(strINISection, strCaption, strItem );
    if (strlen (strItem) != 0)
      pItemData->bNewFrame =TRUE;
    else
      pItemData->bNewFrame =FALSE;
    strcpy (pItemData->strNewFrameName, strItem);
    pItemData->bBack = bBack;
    pItemData->bDisableDropAfter=FALSE;
    gtk_ctree_node_set_row_data (ptc, newItem, pItemData);
  }

  sprintf (strCaption, "%s%c%c", INI_MENU_LINK_, x, y);
  GetSavedVar(strINISection, strCaption, strItem );
  
  if (strlen (strItem) != 0)
  {
    //e' un link all'indietro
    if (strItem[0] == cParent)
    {
      if( pItemData != NULL )
	{
	  pItemData->bBack = TRUE;
	  gtk_ctree_node_set_row_data (ptc, newItem, pItemData);
	}
    }
    else
    {
      gtk_ctree_set_node_info (ptc, newItem, strLabel, 5,
			       folder0_pixmap, folder0_mask,
			       folder1_pixmap, folder1_mask,
			       FALSE, FALSE);

      *pcLink = strItem[0];
      RestoreTreeCtrl(strINISection, ptc, newItem, *pcLink, '0', pcLink, x);

      sprintf (strCaption, "%s%c%c",INI_MENU_STATE, x, y);
      GetSavedVar(strINISection, strCaption, strItem );
      if (strcmp (strItem, "1") == 0)
	gtk_ctree_expand (ptc, newItem);
    }
  }

  RestoreTreeCtrl(strINISection, ptc, item, x, GetMenuLinkNext(applet_info[current_applet].name, y), pcLink, cParent);
}

void RestoreTreeMenu(char* strINISection, GtkCTree* ptc, GtkCTreeNode* item, guint32* pidMenu, guint32 idLevel)
{
  char strCaption[256], strItem[256], *row[2] = { NULL, NULL };
  GtkCTreeNode* newItem;
  ITEM_DATA* pItemData;
  guint32 idMenuSave;

  create_tree_pixmaps ();

  sprintf (strCaption, "%s%d",INI_MENU_LEVEL_, *pidMenu);
  GetSavedVar(strINISection, strCaption, strItem);
  if( idLevel != (guint32)_ttoi(strItem) )
    {
      --(*pidMenu);
      return;
    }

  sprintf (strCaption, "%s%d", INI_MENU_TEXT_, *pidMenu);
  GetSavedVar(strINISection, strCaption, strItem );
  if (strlen (strItem) == 0)
    {
      --(*pidMenu);
      return;
    }

  row[0] = strItem;
  newItem =gtk_ctree_insert_node (ptc, item, NULL, row, 5, folder0_pixmap, folder0_mask,
				  folder1_pixmap, folder1_mask, FALSE, FALSE);

  pItemData = malloc (sizeof (ITEM_DATA));
  if (pItemData != NULL)
  {
    sprintf (strCaption, "%s%d", INI_MENU_ICON_, *pidMenu);
    GetSavedVar(strINISection, strCaption, strItem );
		
    if (strlen (strItem) == 0)
      pItemData->iIconIndex = -1;
    else
      pItemData->iIconIndex = _ttoi(strItem);

    sprintf (strCaption, "%s%d", INI_MENU_URL_, *pidMenu);
    GetSavedVar(strINISection, strCaption, strItem );
    strcpy (pItemData->strURL, strItem);

    pItemData->bBack=FALSE;
    pItemData->bNewFrame=FALSE;
    if( idLevel==0 )
      pItemData->bDisableDropAfter=TRUE;
    else
      pItemData->bDisableDropAfter=FALSE;

    strcpy (pItemData->strNewFrameName, "");
    gtk_ctree_node_set_row_data (ptc, newItem, pItemData);
  }

  idMenuSave=*pidMenu;

  sprintf (strCaption, "%s%d", INI_MENU_LINK_, *pidMenu);
  GetSavedVar(strINISection, strCaption, strItem );
  if (strlen (strItem) != 0)
    {
      /*
	ptc->SetItemImage( newItem, TV_IMG_FOLDER_CLOSE, TV_IMG_FOLDER_CLOSE);
      */
      *pidMenu=(guint32)_ttoi(strItem);
      RestoreTreeMenu(strINISection, ptc, newItem, pidMenu , idLevel+1);
    }

  sprintf (strCaption, "%s%d", INI_MENU_STATE, idMenuSave);
  GetSavedVar(strINISection, strCaption, strItem );
  if (strcmp (strItem, "1") == 0)
    {
      gtk_ctree_expand (ptc, newItem);
    }

  ++(*pidMenu);
  RestoreTreeMenu(strINISection, ptc, item, pidMenu, idLevel );
}

// =========================================================

void restore_dialog_data (int usedefault)
{
  char strtmp[1024], ini_section[64], section[64], tmp[8], *row[2] = { NULL, NULL };
  GtkWidget* widget;
  IMAGE_INFO* info;
  int index;

  if (current_applet != -1)
  {
    strcpy (ini_section, applet_info[current_applet].name);
    if (usedefault)
      strcat (ini_section, INI_SECTION_DEFAULT);
  }

  /*
	CComboBox* pcbo;
	CString strIndex;
	CString strImage;
	CString strIniValue;

	m_bRestoreData=TRUE;
  */

  switch (current_dialog)
  {
  case DLG_STEP0:
    GetSavedVar(INI_APP_SECTION, INI_LAST_APPLET_CATEGORY, strtmp);

    if (strcmp (strtmp, "1") == 0)
      widget = lookup_widget (main_dlg, "cat_banner");
    else if (strcmp (strtmp, "2") == 0)
      widget = lookup_widget (main_dlg, "cat_fractals");
    else if (strcmp (strtmp, "3") == 0)
      widget = lookup_widget (main_dlg, "cat_image");
    else if (strcmp (strtmp, "4") == 0)
      widget = lookup_widget (main_dlg, "cat_3d");
    else if (strcmp (strtmp, "5") == 0)
      widget = lookup_widget (main_dlg, "cat_navigation");
    else
      widget = lookup_widget (main_dlg, "cat_other");
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);

    GetSavedVar(INI_APP_SECTION, INI_LAST_APPLET_CONFIGURED, strtmp);
    widget = lookup_widget (main_dlg, "applet_entry");
    gtk_entry_set_text (GTK_ENTRY (widget), strtmp);
    break;

  case DLG_TEXTSTYLE:
    READ_ENTRY (INI_TEXTMODE, "text_type_entry");
    /*
      OnSelchangeTexttype();
    */
    {
      char pszScrollText[MAX_SCROLLTEXT_SIZE];

      widget = lookup_widget (main_dlg, "text");

      if (ReadWriteFileScrollText(current_applet, pszScrollText, 0))
      {
	gtk_text_insert (GTK_TEXT (widget), NULL, NULL, NULL,
			 pszScrollText, strlen(pszScrollText));
	gtk_adjustment_set_value (GTK_TEXT(widget)->vadj, 0);
      }
      else
	gtk_text_insert (GTK_TEXT (widget), NULL, NULL, NULL, "", 0);
    }

    READ_ENTRY (INI_TEXTVSPACE, "v_spac");
    READ_ENTRY (INI_TEXTSPEED, "speed");
    READ_ENTRY (INI_TEXTOFFSET, "y_offset");
    READ_ENTRY (INI_TEXTSINANGLE, "sine_angle");
    READ_ENTRY (INI_TEXTSINEAMPL, "sine_amplitude");
    READ_ENTRY (INI_TEXTSINSPEED, "sine_speed");
    READ_ENTRY (INI_TEXTJUMPAMP, "jump_amplitude");
    READ_ENTRY (INI_TEXTJUMPSPEED, "jump_speed");

    READ_CHECK (INI_TEXTSHADOW, "shadow");
    /*
      OnChkShadow();
    */
    READ_INT (INI_TEXT_COLORRED, dlg_textcolor_red);
    READ_INT (INI_TEXT_COLORGREEN, dlg_textcolor_green);
    READ_INT (INI_TEXT_COLORBLU, dlg_textcolor_blue);

    //    READ_CHECK (INI_STANDARD_FONT, "standard");
    /*
      OnChkStdFont();
    */
    READ_ENTRY (INI_TEXT_FONT, "font_entry");
    READ_ENTRY (INI_TEXT_SIZE, "size_entry");
    READ_ENTRY (INI_TEXT_SIZE_MIN, "min_entry");
    READ_ENTRY (INI_TEXT_SIZE_MAX, "max_entry");

    READ_CHECK (INI_TEXT_ITALIC, "italic");
    READ_CHECK (INI_TEXT_BOLD, "bold");

    READ_INT (INI_TEXTS_COLORRED, dlg_textscolor_red);
    READ_INT (INI_TEXTS_COLORGREEN, dlg_textscolor_green);
    READ_INT (INI_TEXTS_COLORBLU, dlg_textscolor_blue);

    /*
      UpdatePreviewScrollText();
    */
    break;

  case DLG_STEP1:
  {
    char* tag;

    tag = GenerateHtmlAppletTag(current_applet);
    gtk_text_insert (GTK_TEXT (lookup_widget (main_dlg, "code")),
		     NULL, NULL, NULL, tag, strlen(tag));
    g_free(tag);

    GeneratePreviewFile(current_applet, 0);

  } break;

  case DLG_EXPERTMODE:
    READ_ENTRY (INI_EX_MEMDELAY, "memory");
    READ_ENTRY (INI_EX_TASK_PRIORITY, "task");
    READ_ENTRY (INI_EX_MINSYNC, "minsync");

    widget = lookup_widget (main_dlg, "netscape");
    GetSavedVar(ini_section, INI_FIXNETSCAPE, strtmp);
    if (strcmp (strtmp, INI_YES) == 0)
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
    else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);

    if ((current_applet == APPLET_CUBEMENU) ||
	(current_applet == APPLET_ANFADE) ||
	(current_applet == APPLET_BOOKFLIP) ||
	(current_applet == APPLET_MOSAIC) ||
	(current_applet == APPLET_WHEEL) ||
	(current_applet == APPLET_MORPHMENU) ||
	(current_applet == APPLET_TREEMENU))
    {
      widget = lookup_widget (main_dlg, "statusbar");
      gtk_entry_set_text (GTK_ENTRY (widget), "");
      gtk_widget_set_sensitive (widget, FALSE);
    }
    else
      READ_ENTRY (INI_STATUSMSG, "statusbar");

    READ_ENTRY (INI_NOJAVAMSG, "nojava");

    GetSavedVar(ini_section, INI_OVERIMG, strtmp);
    if (strcmp (strtmp, INI_NO) == 0)
    {
      widget = lookup_widget (main_dlg, "image");
      gtk_entry_set_text (GTK_ENTRY (widget), "");

      widget = lookup_widget (main_dlg, "enable_image");
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    }
    else
    {
      READ_ENTRY (INI_OVERIMG, "image");

      widget = lookup_widget (main_dlg, "enable_image");
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
    }

    READ_ENTRY (INI_OVERIMGX, "xoffset");
    READ_ENTRY (INI_OVERIMGY, "yoffset");
    break;
    /*
		case DLG_REGCODE:
    */
  case DLG_REGISTRATION:
  {
    GtkWidget *menu, *item;
    char strDomain[256], tmp[256];
    GList *list;
    int history = 0;

    menu = gtk_menu_new ();
    GetSavedVar(INI_APP_SECTION, INI_DOMAIN, tmp);

    for (index = 0; ;index++)
    {
      sprintf (section, "%s%d", INI_NDOMAIN_, index);
      GetSavedVar(INI_APP_SECTION, section, strDomain);
      if (strlen (strDomain) != 0)
      {
	if (strcmp (strDomain, tmp) == 0)
	  history = index;

	item = gtk_menu_item_new_with_label (strDomain);
	gtk_signal_connect (GTK_OBJECT (item), "activate",
			    GTK_SIGNAL_FUNC (OnSelchangeDomains), NULL);
	gtk_widget_show (item);
	gtk_menu_append (GTK_MENU (menu), item);                              
      }
      else
	break;
    }

    widget = lookup_widget (main_dlg, "domains");
    gtk_option_menu_set_menu (GTK_OPTION_MENU (widget), menu);
    gtk_option_menu_set_history (GTK_OPTION_MENU (widget), history);

    if (current_dialog == DLG_REGISTRATION)
    {
      if (current_applet != APPLET_CUBEMENU
	  && current_applet != APPLET_ANFADE
	  && current_applet != APPLET_MOSAIC
	  && current_applet != APPLET_BOOKFLIP
	  && current_applet != APPLET_WHEEL
	  && current_applet != APPLET_MORPHMENU
	  && current_applet != APPLET_TREEMENU)
	{
	  GetSavedVar(ini_section, INI_REGLINK, strtmp);
	  widget = lookup_widget (main_dlg, "enable_link");
	  
	  if (strcmp (strtmp, INI_NO) != 0)
	  {
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
	    gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "link_entry")), strtmp);
	  }
	  else
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
	}

      GetSavedVar(ini_section, INI_REGNEWFRAME, strtmp);
      if (strcmp (strtmp, INI_YES) == 0)
      {
	widget = lookup_widget (main_dlg, "enable_link");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
	widget = lookup_widget (main_dlg, "enable_target");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);

	widget = lookup_widget (main_dlg, "mode_combo");
	GetSavedVar(ini_section, INI_REGFRAMENAME, strtmp);
	list = GTK_LIST (GTK_COMBO (widget)->list)->children;
	while (list)
	{
	  if (strcmp (list->data, strtmp) == 0)
	  {
	    gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "target_entry")), list->data);
	    break;
	  }
	  list = g_list_next (list);
	}

	if (list == NULL)
	{
	  gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "mode_entry")), _("other target..."));
	  gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "target_entry")), strtmp);
	}
      }
      else
      {
	widget = lookup_widget (main_dlg, "enable_target");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "target_entry")), "");
	gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "mode_entry")), "_blank");
      }
      /*
	OnEnableLink();
      */
    }
  } break;

  case DLG_BLOBS:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY (INI_NBLOBS, "number_entry");

    READ_ENTRY (INI_BVAL1, "i");
    READ_ENTRY (INI_BVAL2, "j");
    READ_ENTRY (INI_BVAL3, "k");

    READ_ENTRY (INI_RES, "resolution_entry");
    READ_ENTRY (INI_MINSPEED, "min_entry");
    READ_ENTRY (INI_COLORPAL, "color_entry");

    READ_CHECK (INI_SINEMODE, "sine");
    READ_CHECK (INI_STARSHAPE, "star");
    READ_CHECK (INI_NEGCOLOR, "negative");
    break;

  case DLG_ANBLUR:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY (INI_FORMAT_VALUE, "image_type");
    READ_ENTRY (INI_IMGS_VALUE, "frames" );
    READ_ENTRY (INI_NIMGS, "num" );

    GetSavedVar (ini_section, INI_PINGPONG, strtmp);
    if (strcmp (strtmp, INI_YES) == 0)
    {
      widget = lookup_widget (main_dlg, "ping_pong");
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
    }
    else
    {
      widget = lookup_widget (main_dlg, "cyclic");
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
    }

    READ_CHECK (INI_DOUBLESIZE, "double_size");

    READ_ENTRY (INI_SPEED, "play");
    READ_ENTRY (INI_PINGPAUSE, "ping_pause");
    READ_ENTRY (INI_PONGPAUSE, "pong_pause");
    READ_ENTRY (INI_AUDIOPING, "ping_audio");
    READ_ENTRY (INI_AUDIOPONG, "pong_audio");
    break;

  case DLG_ANFYBUMP:
    READ_ENTRY (INI_IMAGE_FILE, "image");

    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY_INT (INI_RES, "resolution_entry", dlg_oldres);

    widget = lookup_widget (main_dlg, "alt_image");
    GetSavedVar(ini_section, INI_ALT_IMAGE_FILE, strtmp);
    if (strcmp (strtmp, INI_NO) == 0)
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    else
    {
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
      gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "bump_image")), strtmp);
    }
    /*
      OnEnableAlt();
    */

    READ_ENTRY (INI_BUMP_HEIGHT, "bump_entry");
    READ_ENTRY (INI_LIGHTSIZE, "light_entry");
    READ_CHECK (INI_INTERACTIVE_MODE, "interactive");

    READ_ENTRY (INI_ANGLE_X, "anglex");
    READ_ENTRY (INI_ANGLE_Y, "angley");

    READ_ENTRY (INI_LMIN, "min");
    READ_ENTRY (INI_LMAX, "max");
    READ_ENTRY (INI_LPOW, "power");
    break;

  case DLG_ANFADE:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY_INT (INI_RES, "resolution_entry", dlg_oldres);

    widget = lookup_widget (main_dlg, "image_list");
    gtk_clist_clear (GTK_CLIST (widget));

    while (image_info)
    {
      info = image_info->data;

      g_free (info->image);
      g_free (info->link);
      g_free (info->status);
      g_free (info->flip);

      image_info = g_list_remove (image_info, info);
      g_free (info);
    }

    for (index = 0; ; index++)
    {
      sprintf (tmp, "%d", index+1);

      strcpy (section, INI_IMAGE_);
      strcat (section, tmp);

      if (GetSavedVar(ini_section, section, strtmp) == 0)
	break;

      row[0] = strtmp;
      gtk_clist_append (GTK_CLIST (widget), row);

      info = g_malloc (sizeof (IMAGE_INFO));
      gtk_clist_set_row_data (GTK_CLIST (widget), index, info);
      image_info = g_list_append (image_info, info);
      info->image = g_strdup (strtmp);

      strcpy (section, INI_LINK_);
      strcat (section, tmp);
      GetSavedVar(ini_section, section, strtmp);
      info->link = g_strdup (strtmp);

      strcpy (section, INI_STATUS_MSG_);
      strcat (section, tmp);
      GetSavedVar(ini_section, section, strtmp);
      info->status = g_strdup (strtmp);

      info->flip = g_malloc (0);
    }

    READ_ENTRY (INI_FRAME_SPEED, "frame_speed");
    READ_ENTRY (INI_PAUSE, "pause");
    READ_CHECK (INI_PROGFADE, "progressive");
    break;

  case DLG_ANFLAG:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY_INT (INI_FLAG_RES, "resolution_entry", dlg_oldres);
    READ_ENTRY (INI_FLAG_PATTERN, "pattern_entry" );
    READ_ENTRY (INI_WIND_SPEED, "speed" );
    READ_ENTRY (INI_WIND, "wind_entry" );
    READ_ENTRY (INI_FLAG_NATION, "nation_entry");
    READ_ENTRY (INI_CURVE, "curve_entry");

    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);

    READ_ENTRY (INI_PIXDENSITY, "pix_entry");
    break;

  case DLG_CUBEMENU:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_RES, "resolution_entry");

    widget = lookup_widget (main_dlg, "image_list");
    gtk_clist_clear (GTK_CLIST (widget));

    while (image_info)
    {
      info = image_info->data;

      g_free (info->image);
      g_free (info->link);
      g_free (info->status);
      g_free (info->flip);

      image_info = g_list_remove (image_info, info);
      g_free (info);
    }

    for (index = 0; index < 6; index++)
    {
      sprintf (tmp, "%d", index+1);

      strcpy (section, INI_IMAGE_);
      strcat (section, tmp);

      GetSavedVar(ini_section, section, strtmp);

      row[0] = strtmp;
      gtk_clist_append (GTK_CLIST (widget), row);

      info = g_malloc (sizeof (IMAGE_INFO));
      gtk_clist_set_row_data (GTK_CLIST (widget), index, info);
      image_info = g_list_append (image_info, info);
      info->image = g_strdup (strtmp);

      strcpy (section, INI_LINK_);
      strcat (section, tmp);
      GetSavedVar(ini_section, section, strtmp);
      info->link = g_strdup (strtmp);

      strcpy (section, INI_STATUS_MSG_);
      strcat (section, tmp);
      GetSavedVar(ini_section, section, strtmp);
      info->status = g_strdup (strtmp);

      info->flip = g_malloc (0);
    }

    if (GTK_CLIST (widget)->rows == 6)
      gtk_widget_set_sensitive (lookup_widget (main_dlg, "add"), FALSE);

    READ_ENTRY (INI_ROTX, "x");
    READ_ENTRY (INI_ROTY, "y");
    READ_ENTRY (INI_ROTZ, "z");

    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);

    READ_CHECK (INI_CLEAR_BACKGROUND, "clear");
    READ_ENTRY (INI_BACK_IMAGE_PATH, "back_image_entry");
    break;

  case DLG_DEFORM:
    READ_ENTRY (INI_IMAGE, "image");
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY_INT (INI_RES, "resolution_entry", dlg_oldres);
    READ_ENTRY (INI_DISTVAL, "value");
    READ_ENTRY (INI_DFACT, "factor");
    READ_ENTRY (INI_DSPEED, "speed");
    READ_ENTRY (INI_DOFFSET, "offset");
    READ_ENTRY (INI_XV1, "x1");
    READ_ENTRY (INI_YV1, "y1");
    READ_ENTRY (INI_XV2, "x2");
    READ_ENTRY (INI_YV2, "y2");
    break;

  case DLG_FIRE:
    READ_ENTRY (INI_FIRE_WIDTH, "fire_width");
    READ_ENTRY (INI_FIRE_HEIGHT, "fire_height");
    READ_ENTRY (INI_FIRE_X_RES, "x_entry");
    READ_ENTRY (INI_FIRE_Y_RES, "y_entry");
    /*
      OnSelchangeFireXRes();
    */
    READ_ENTRY (INI_FC_START, "start");
    READ_ENTRY (INI_FC_VALUE, "value");
    READ_ENTRY (INI_DLIGHT, "def");

    GetSavedVar (ini_section, INI_FIRE_FORM, strtmp);
    if (strcmp (strtmp, "1") == 0)
    {
      widget = lookup_widget (main_dlg, "rectangle");
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
    }
    else
    {
      widget = lookup_widget (main_dlg, "convex");
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
    }

    READ_ENTRY (INI_RND_REP, "repeat_entry" );
    READ_ENTRY (INI_PALR, "r_entry");
    READ_ENTRY (INI_PALG, "g_entry");
    READ_ENTRY (INI_PALB, "b_entry");
    break;

  case DLG_FLAGLOAD:
    READ_ENTRY (INI_FLAGLOAD, "image" );
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY_INT (INI_FLAG_RES, "resolution_entry", dlg_oldres);

    READ_ENTRY (INI_FLAG_PATTERN, "pattern_entry");
    READ_ENTRY (INI_WIND_SPEED, "speed");
    READ_ENTRY (INI_WIND, "wind_entry");
    READ_ENTRY (INI_CURVE, "curve_entry");

    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);

    READ_ENTRY (INI_PIXDENSITY, "pix_entry");

    widget = lookup_widget (main_dlg, "back_image_check");
    GetSavedVar(ini_section, INI_BACK_IMAGE_PATH, strtmp);
    if (strcmp (strtmp, INI_NO) == 0)
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    else
    {	
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
      gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "back_image")), strtmp);
    }
    /*
      OnFlozBackImage();
    */
    break;

  case DLG_FLOZOIDS:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);

    READ_ENTRY (INI_NFLOZ, "number");
    READ_ENTRY (INI_DISTANCE, "distance");
    READ_ENTRY (INI_TOCENTER, "center");
    READ_ENTRY (INI_ACCELL, "acceleration");
    READ_ENTRY (INI_FLOZ_SPEED, "speed");
    READ_ENTRY (INI_SIDE_BOUNCING, "bouncing");

    READ_CHECK (INI_HEADS, "heads");
    READ_CHECK (INI_GO_OVER_TEXT, "over_text");

    READ_INT (INI_FIRST_COLOR_R, dlg_f1color_red);
    READ_INT (INI_FIRST_COLOR_G, dlg_f1color_green);
    READ_INT (INI_FIRST_COLOR_B, dlg_f1color_blue);
    READ_INT (INI_LAST_COLOR_R, dlg_f2color_red);
    READ_INT (INI_LAST_COLOR_G, dlg_f2color_green);
    READ_INT (INI_LAST_COLOR_B, dlg_f2color_blue);

    widget = lookup_widget (main_dlg, "back_image_check");
    GetSavedVar(ini_section, INI_BACK_IMAGE_PATH, strtmp);
    if (strcmp (strtmp, INI_NO) == 0)
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    else
    {	
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
      widget = lookup_widget (main_dlg, "back_image");
      gtk_entry_set_text (GTK_ENTRY (widget), strtmp);
    }
    /*
    OnFlozBackImage();
    */
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "first_pixmap"),
		      dlg_f1color_red, dlg_f1color_green, dlg_f1color_blue);
    set_color_pixmap (lookup_widget (main_dlg, "last_pixmap"),
		      dlg_f2color_red, dlg_f2color_green, dlg_f2color_blue);

    READ_CHECK (INI_INTERACTIVE_MODE, "interactive");
    break;

  case DLG_FLUID:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY_INT (INI_RES, "resolution_entry", dlg_oldres);

    READ_CHECK (INI_CHK_AUTODESIGN, "autodesign");
    /*
      OnChkAutodesign();
    */
    READ_ENTRY (INI_FLUID_DENSITY, "fluid_entry");

    READ_ENTRY (INI_RSIZE, "rsize");
    READ_ENTRY (INI_RFACTOR, "rfactor");
    READ_ENTRY (INI_SRSIZE, "ssize");
    READ_ENTRY (INI_SRFACTOR, "sfactor");

    READ_CHECK (INI_CHK_VOLCANO, "volcano");

    READ_ENTRY (INI_NFISH, "fish_entry");
    break;

  case DLG_HUEROT:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY_INT (INI_RES, "resolution_entry", dlg_oldres);

    READ_ENTRY (INI_IMAGE_FILE, "image");
    READ_ENTRY (INI_HUESHIFT, "hueshift");
    break;

  case DLG_ANFRACT:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_DIM, "dimension");
    READ_ENTRY (INI_BRANCH, "branches");
    READ_ENTRY (INI_MORPH_SPEED, "morph");
    READ_ENTRY (INI_ROT_SPEED, "rotation");
    READ_ENTRY (INI_ROT_SPEED2, "rotation2");
    READ_ENTRY (INI_DECLINE, "decline");
    READ_ENTRY (INI_LENGTH, "length");

    READ_ENTRY (INI_PENSIZE, "pen_entry");

    READ_CHECK (INI_PROGRESS, "progress");
    /*
      OnProgress();
    */

    READ_ENTRY (INI_PEN_PROGR, "pen_progr");

    READ_CHECK (INI_PROGINVERSE, "progr_inv");
    READ_CHECK (INI_ITERSKIP, "iterskip");

    READ_INT (INI_IFS1_R, dlg_f1color_red);
    READ_INT (INI_IFS1_G, dlg_f1color_green);
    READ_INT (INI_IFS1_B, dlg_f1color_blue);
    READ_INT (INI_IFS2_R, dlg_f2color_red);
    READ_INT (INI_IFS2_G, dlg_f2color_green);
    READ_INT (INI_IFS2_B, dlg_f2color_blue);

    READ_CHECK (INI_OVERTEXT, "over_text");

    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);

    widget = lookup_widget (main_dlg, "back_image_check");
    GetSavedVar(ini_section, INI_BACK_IMAGE_PATH, strtmp);
    if (strcmp (strtmp, INI_NO) == 0)
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    else
    {	
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
      widget = lookup_widget (main_dlg, "back_image");
      gtk_entry_set_text (GTK_ENTRY (widget), strtmp);
    }

    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "first_pixmap"),
		      dlg_f1color_red, dlg_f1color_green, dlg_f1color_blue);
    set_color_pixmap (lookup_widget (main_dlg, "last_pixmap"),
		      dlg_f2color_red, dlg_f2color_green, dlg_f2color_blue);
    break;

  case DLG_ANLAKE:
    READ_ENTRY (INI_IMAGE_FILE, "image");
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY_INT (INI_RES, "resolution_entry", dlg_oldres);

    READ_ENTRY (INI_WIND, "intensity_entry");
    READ_ENTRY (INI_WIND_VSPEED, "wind_speed");
    READ_ENTRY (INI_WIND_VMIN, "wind_min_entry");
    READ_ENTRY (INI_WIND_VMAX, "wind_max_entry");

    READ_ENTRY (INI_WSPEED, "wave");
    READ_ENTRY (INI_PERSPECTIVE, "perspective");
    READ_ENTRY (INI_FARWAVING, "farwaving");

    READ_CHECK (INI_HALFREFLECT, "half_effect");
    break;

  case DLG_ANLENS:
    READ_ENTRY (INI_IMAGE_FILE, "image");
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_LENS_WIDTH, "lens_width");
    READ_ENTRY (INI_ZOOM_FACTOR, "zoom");

    READ_ENTRY (INI_XSPEED, "x_entry");
    READ_ENTRY (INI_YSPEED, "y_entry");

    READ_CHECK (INI_INTERACTIVE, "interactive");

    READ_CHECK (INI_CHK_DISTORSION, "distortion");
    /*
      OnChkDistorsion();
    */
    READ_ENTRY (INI_DIAG_DISTORSION, "diagonal_entry");
    READ_ENTRY (INI_XY_DISTORSION, "xy");
    break;

  case DLG_LIFE2D:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_RES_LIFE, "resolution_entry");

    READ_INT (INI_FOR_COLOR_R, dlg_forcolor_red);
    READ_INT (INI_FOR_COLOR_G, dlg_forcolor_green);
    READ_INT (INI_FOR_COLOR_B, dlg_forcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "fore_pixmap"),
		      dlg_forcolor_red, dlg_forcolor_green, dlg_forcolor_blue);

    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);

    READ_ENTRY (INI_LIFEDENSITY, "life_entry");
    break;

  case DLG_MANDEL:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_MANDEL_RES, "resolution_entry");

    READ_ENTRY (INI_XSTART, "startx");
    READ_ENTRY (INI_YSTART, "starty");

    READ_ENTRY (INI_NUMPAL, "palette_entry");

    READ_ENTRY (INI_XMIN, "xmin");
    READ_ENTRY (INI_XMAX, "xmax");

    READ_ENTRY (INI_YMIN, "ymin");
    READ_ENTRY (INI_YMAX, "ymax");
    break;

  case DLG_PLASMA:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY (INI_PLASMA_RES, "resolution_entry");

    READ_ENTRY (INI_GEN1, "gen1");
    READ_ENTRY (INI_GEN2, "gen2");
    READ_ENTRY (INI_GEN3, "gen3");

    READ_ENTRY (INI_RED1, "r0");
    READ_ENTRY (INI_RED2, "r1");
    READ_ENTRY (INI_RED3, "red_entry");

    READ_ENTRY (INI_GREEN1, "g0");
    READ_ENTRY (INI_GREEN2, "g1");
    READ_ENTRY (INI_GREEN3, "green_entry");

    READ_ENTRY (INI_BLU1, "b0");
    READ_ENTRY (INI_BLU2, "b1");
    READ_ENTRY (INI_BLU3, "blue_entry");

    READ_ENTRY (INI_PLASMA_SPEED, "speed_entry");
    break;

  case DLG_ROTATE:
    READ_ENTRY (INI_IMAGE_FILE, "image");
    READ_ENTRY (INI_BACK_IMAGE_PATH, "back_image");

    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_ROT_RES, "resolution_entry");
    READ_ENTRY (INI_ROTMODE, "mode_entry");
    /*
      OnSelchangeRotmode();
    */
    READ_CHECK (INI_TILE_IMAGE, "tile");
    /*
      OnTileImage();
    */

    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);

    READ_ENTRY (INI_DISTVALUE, "distortion");

    READ_ENTRY (INI_RSPEED, "rot_entry");

    READ_ENTRY (INI_ZMIN, "zoom_min");
    READ_ENTRY (INI_ZMAX, "zoom_max");
    READ_ENTRY (INI_ZSPEED, "zoom_speed");

    READ_ENTRY (INI_MODIX, "x_entry");
    READ_ENTRY (INI_MODIY, "y_entry");

    READ_ENTRY (INI_AUTO1, "first");
    READ_ENTRY (INI_AUTO2, "second");
    break;

  case DLG_TMAPCUBE:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY (INI_RES, "resolution_entry");

    widget = lookup_widget (main_dlg, "image_list");
    gtk_clist_clear (GTK_CLIST (widget));
    for (index = 0; index < 6 ; index++)
    {
      sprintf (section, "%s%d", INI_IMAGE_, index+1);
      GetSavedVar(ini_section, section, strtmp);
      if (strtmp[0] == '\0')
	break;

      row[0] = strtmp;
      gtk_clist_append (GTK_CLIST (widget), row);
    }

    if (GTK_CLIST (widget)->rows == 6)
      gtk_widget_set_sensitive (lookup_widget (main_dlg, "add"), FALSE);

    READ_ENTRY (INI_ROTX, "x");
    READ_ENTRY (INI_ROTY, "y");
    READ_ENTRY (INI_ROTZ, "z");

    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);

    READ_CHECK (INI_LIGHTSOURCE, "lightsource");
    /*
      OnLightsource();
    */
    READ_ENTRY (INI_LIGHT_INT, "intensity");
    READ_ENTRY (INI_LIGHT_MAX, "light_min");
    READ_ENTRY (INI_LIGHT_MIN, "light_max");
			
    READ_CHECK (INI_INTERACTIVE_MODE, "interactive");
    READ_CHECK (INI_CLEAR_BACKGROUND, "clear");

    READ_ENTRY (INI_BACK_IMAGE_PATH, "image");
    break;

  case DLG_TUNNEL:
    READ_ENTRY (INI_IMAGE_FILE, "image");

    READ_ENTRY (INI_IMG_WIDTH, "image_width");
    READ_ENTRY (INI_IMG_HEIGHT, "image_height");

    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_TUNNEL_RES, "resolution_entry");

    READ_ENTRY (INI_CONEX, "x");
    READ_ENTRY (INI_CONEY, "y");
    READ_ENTRY (INI_CONEZ, "z");

    READ_ENTRY ( INI_XSTART, "startx");
    READ_ENTRY ( INI_YSTART, "starty");

    READ_ENTRY (INI_MOVEMENT, "move_entry");
    READ_ENTRY (INI_EFFECT, "effect_entry");
    break;

  case DLG_TUNNEL3D:
    READ_ENTRY (INI_IMAGE_FILE, "image");
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_TUNNEL_RES, "resolution_entry");

    READ_ENTRY (INI_RADIUS, "radius");
    READ_ENTRY (INI_ROTATION, "rotation");
    READ_ENTRY (INI_ADVANCING, "advancing");
    READ_ENTRY (INI_LMIN, "light_min");
    READ_ENTRY (INI_LMAX, "light_max");
    READ_ENTRY (INI_LDEC, "light_dec");
    READ_CHECK (INI_BENDS, "bends");
    /*
      OnBends();
    */
    READ_ENTRY ( INI_NBENDS, "bends_num");
    READ_ENTRY ( INI_SBMIN, "bends_min");
    READ_ENTRY ( INI_SBMAX, "bends_max");
    READ_ENTRY ( INI_BOFFSET, "bends_offset");
    READ_ENTRY ( INI_BOFFSETINC, "bends_offset_inc");
    READ_ENTRY ( INI_BSIZEINC, "bends_size_inc");
    READ_ENTRY ( INI_ROTX, "x");
    READ_ENTRY ( INI_ROTY, "y");
    READ_ENTRY ( INI_ROTZ, "z");

    READ_CHECK ( INI_REVERSE, "reverse");
    READ_CHECK ( INI_SHADING, "shading");
    READ_CHECK ( INI_SQUARE, "square");
    READ_CHECK ( INI_INTERACTIVE, "interactive");
    break;

  case DLG_VOXEL:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY ( INI_RES, "resolution_entry");
    READ_ENTRY ( INI_NUMPAL, "palette_entry");

    READ_ENTRY ( INI_SHADOW, "shadow");
    READ_ENTRY ( INI_ROUGHNESS, "roughness");
    READ_ENTRY ( INI_IMAGE_FILE, "image" );
    READ_ENTRY ( INI_HORIZON, "horizon" );

    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);
    break;

  case DLG_WARP:
    READ_ENTRY (INI_IMAGE_FILE, "image");
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_RES, "resolution_entry");
    READ_ENTRY (INI_WARP_MODE, "mode_entry");

    READ_ENTRY (INI_WSTART1, "spiral_start");
    READ_ENTRY (INI_WADD1, "spiral_add");
    READ_ENTRY (INI_WMIN1, "spiral_min");
    READ_ENTRY (INI_WMAX1, "spiral_max");
    READ_ENTRY (INI_WSTART2, "breath_start");
    READ_ENTRY (INI_WADD2, "breath_add");
    READ_ENTRY (INI_WMIN2, "breath_min");
    READ_ENTRY (INI_WMAX2, "breath_max");
    break;

  case DLG_ANWATER:
    READ_ENTRY (INI_IMAGE_FILE, "image");
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY_INT (INI_RES, "resolution_entry", dlg_oldres);

    READ_CHECK (INI_CHK_AUTODESIGN, "autodesign");
    /*
      OnChkAutodesign();
    */		
    READ_ENTRY (INI_FLUID_DENSITY, "fluid_entry");

    READ_ENTRY (INI_RSIZE, "rsize");
    READ_ENTRY (INI_RFACTOR, "rfactor");
    READ_ENTRY (INI_SRSIZE, "ssize");
    READ_ENTRY (INI_SRFACTOR, "sfactor");

    READ_CHECK (INI_FIXDROPVALUE, "fix_drops");
    READ_ENTRY (INI_FIXDROPX, "fix_x");
    READ_ENTRY (INI_FIXDROPY, "fix_y");
    READ_ENTRY (INI_FIXDROPS, "fix_size");
    READ_ENTRY (INI_FIXDROPF, "fix_factor");
    /*
      OnFixdropvalue();
    */

    READ_ENTRY (INI_NFISH, "fish_entry");

    READ_CHECK (INI_CROSS, "cross");
    /*
      OnCross();
    */
    READ_ENTRY (INI_CROSS_FACTOR, "factor");

    READ_CHECK (INI_ANWATER_LIGHT, "light");
    /*
      OnAnwaterLight();
    */
    READ_ENTRY (INI_LIGHT_MIN, "min");
    READ_ENTRY (INI_LIGHT_MAX, "max");

    READ_ENTRY (INI_PRESSURE, "pressure");

    READ_ENTRY (INI_FLUIDMODE, "fluid_mode_entry");

    READ_CHECK (INI_INTERACTIVE_MODE, "interactive");
    break;

  case DLG_WORMHOLE:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_XHOLESPEED, "x_entry");
    READ_ENTRY (INI_YHOLESPEED, "y_entry");
    READ_ENTRY (INI_DOT, "dot");
			
    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);

    READ_CHECK (INI_NEGATIVE, "negative");
    break;

  case DLG_GALAXY:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_PARTICLES, "particles_entry");

    widget = lookup_widget (main_dlg, "random");
    GetSavedVar (ini_section, INI_RANDOM, strtmp);
    if (strcmp (strtmp, "0") == 0)
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);

    READ_ENTRY (INI_SCRIPT, "script_entry");
    READ_ENTRY (INI_GPALETTE, "palette_entry");

    READ_ENTRY (INI_PERSIST, "light");
    READ_ENTRY (INI_DINPERSIST, "dynamic");
    READ_ENTRY (INI_DINPERSISTMIN, "min");
    READ_ENTRY (INI_DINPERSISTMAX, "max");
    break;

  case DLG_BOOKFLIP:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY_INT (INI_RES, "resolution_entry", dlg_oldres);

    widget = lookup_widget (main_dlg, "image_list");
    gtk_clist_clear (GTK_CLIST (widget));

    while (image_info)
    {
      info = image_info->data;

      g_free (info->image);
      g_free (info->link);
      g_free (info->status);
      g_free (info->flip);

      image_info = g_list_remove (image_info, info);
      g_free (info);
    }

    for (index = 0; ; index++)
    {
      sprintf (tmp, "%d", index+1);

      strcpy (section, INI_IMAGE_);
      strcat (section, tmp);

      if (GetSavedVar(ini_section, section, strtmp) == 0)
	break;

      row[0] = strtmp;
      gtk_clist_append (GTK_CLIST (widget), row);

      info = g_malloc (sizeof (IMAGE_INFO));
      gtk_clist_set_row_data (GTK_CLIST (widget), index, info);
      image_info = g_list_append (image_info, info);
      info->image = g_strdup (strtmp);

      strcpy (section, INI_LINK_);
      strcat (section, tmp);
      GetSavedVar(ini_section, section, strtmp);
      info->link = g_strdup (strtmp);

      strcpy (section, INI_STATUS_MSG_);
      strcat (section, tmp);
      GetSavedVar(ini_section, section, strtmp);
      info->status = g_strdup (strtmp);

      strcpy (section, INI_FLIP_);
      strcat (section, tmp);
      GetSavedVar(ini_section, section, strtmp);
      info->flip = g_strdup (strtmp);
    }

    READ_ENTRY (INI_FRAME_SPEED, "frame_speed");
    READ_ENTRY (INI_PAUSE, "pause");
    READ_ENTRY_INT (INI_EXTRAH, "extra_height", dlg_oldextrah);
    READ_ENTRY (INI_FLIPCURVE, "flip_entry");
    READ_ENTRY (INI_SHADING_BF, "shading_entry");
    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);
    break;

  case DLG_MOSAIC:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY_INT (INI_RES, "resolution_entry", dlg_oldres);

    widget = lookup_widget (main_dlg, "image_list");
    gtk_clist_clear (GTK_CLIST (widget));

    while (image_info)
    {
      info = image_info->data;

      g_free (info->image);
      g_free (info->link);
      g_free (info->status);
      g_free (info->flip);

      image_info = g_list_remove (image_info, info);
      g_free (info);
    }

    for (index = 0; ; index++)
    {
      sprintf (tmp, "%d", index+1);

      strcpy (section, INI_IMAGE_);
      strcat (section, tmp);

      if (GetSavedVar(ini_section, section, strtmp) == 0)
	break;

      row[0] = strtmp;
      gtk_clist_append (GTK_CLIST (widget), row);

      info = g_malloc (sizeof (IMAGE_INFO));
      gtk_clist_set_row_data (GTK_CLIST (widget), index, info);
      image_info = g_list_append (image_info, info);
      info->image = g_strdup (strtmp);

      strcpy (section, INI_LINK_);
      strcat (section, tmp);
      GetSavedVar(ini_section, section, strtmp);
      info->link = g_strdup (strtmp);

      strcpy (section, INI_STATUS_MSG_);
      strcat (section, tmp);
      GetSavedVar(ini_section, section, strtmp);
      info->status = g_strdup (strtmp);

      info->flip = g_malloc (0);
    }

    READ_ENTRY (INI_TILESWIDTH, "tile_width");
    READ_ENTRY (INI_TILESHEIGHT, "tile_height");
    READ_ENTRY (INI_TILESSTEPS, "tile_steps");
    READ_ENTRY (INI_PAUSE, "pause");
    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);

    widget = lookup_widget (main_dlg, "back_image_check");
    GetSavedVar (ini_section, INI_BACK_IMAGE_PATH, strtmp);
    if (strcmp (strtmp, INI_NO) == 0)
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    else
    {	
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
      gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "back_image")), strtmp);
    }
    on_back_image_toggle (widget, NULL);
    break;

  case DLG_ANFY3D:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY (INI_REALWIDTH, "real_w");
    READ_ENTRY (INI_REALHEIGTH, "real_h");

    GetSavedVar(ini_section, INI_TEXTURE0, strtmp);
    if ((strcmp (strtmp, INI_NO) != 0) && (strlen (strtmp) != 0))
      gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "t0_entry")), strtmp);

    widget = lookup_widget (main_dlg, "texture1");
    GetSavedVar(ini_section, INI_TEXTURE1, strtmp);
    if ((strcmp (strtmp, INI_NO) != 0) && (strlen (strtmp) != 0))
    {
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
      gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "t1_entry")), strtmp);
    }
    else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    /*
      OnChkTexture1();
    */

    widget = lookup_widget (main_dlg, "texture2");
    GetSavedVar(ini_section, INI_TEXTURE2, strtmp);
    if ((strcmp (strtmp, INI_NO) != 0) && (strlen (strtmp) != 0))
    {
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
      gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "t2_entry")), strtmp);
    }
    else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    /*
      OnChkTexture2();
    */

    widget = lookup_widget (main_dlg, "phong");
    GetSavedVar(ini_section, INI_PHONGMAP, strtmp);
    if ((strcmp (strtmp, INI_NO) != 0) && (strlen (strtmp) != 0))
    {
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
      gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "p_entry")), strtmp);
    }
    else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    /*
      OnChkPhongmap();
    */

    widget = lookup_widget (main_dlg, "gauss");
    GetSavedVar(ini_section, INI_GPHONGMAP, strtmp);
    if ((strcmp (strtmp, INI_NO) != 0) && (strlen (strtmp) != 0))
    {
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
      gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "g_entry")), strtmp);
    }
    else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    /*
      OnChkGphongmap();
    */

    READ_CHECK (INI_INTERACTIVE_MODE, "interactive");
    READ_CHECK (INI_FOG, "fog");
    /*
      OnFog();
    */

    READ_ENTRY (INI_FOGNEAR, "start");
    READ_ENTRY (INI_FOGFAR, "stop");

    READ_ENTRY (INI_BACKMODE, "back_entry");
    /*
      OnSelchangeBackmode();
    */
    READ_ENTRY (INI_BACK_RENDER, "render_entry");
    READ_ENTRY (INI_BACKTEXTURE, "bt_entry");
    READ_ENTRY (INI_SCRIPT, "script_entry");

    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);

    READ_CHECK (INI_BLUR, "blur");
    break;

  case DLG_ANFY3D_0:
    READ_ENTRY (INI_MAINRENDER, "main_render_entry");
    READ_ENTRY (INI_MAINTEXTURE, "main_tex_entry");
    READ_ENTRY (INI_CHILDRENDER, "child_render_entry");
    READ_ENTRY (INI_CHILDTEXTURE, "child_tex_entry");
    READ_CHECK (INI_AIMLIGHT, "animlight");

    GetSavedVar(ini_section, INI_SCRIPT, strtmp);
    if (strcmp (strtmp, "Objects") == 0)
    {
      READ_ENTRY (INI_MAINTYPE, "main_type_entry");
      /*
	OnSelchangeMaintype();
      */
      READ_ENTRY (INI_CHILDTYPE, "child_type_entry");
      /*
	OnSelchangeChildtype();
      */
      READ_ENTRY (INI_ROTX, "x");
      READ_ENTRY (INI_ROTY, "y");
      READ_ENTRY (INI_ROTZ, "z");
      READ_ENTRY (INI_SHEET_HEIGHT, "height");
      READ_ENTRY (INI_SHEET_WIDTH, "width");
      READ_ENTRY (INI_SHEET_NUMX, "width_faces");
      READ_ENTRY (INI_SHEET_NUMY, "height_faces");
      READ_ENTRY (INI_SHEET_ADD, "add");
      READ_ENTRY (INI_SHEET_H, "ampl");
      READ_ENTRY (INI_SHEET_PERIOD1, "p1");
      READ_ENTRY (INI_SHEET_PERIOD2, "p2");
      READ_ENTRY (INI_SHEET_FUNCTION, "func_entry");
      READ_ENTRY (INI_SHADOW, "shadow_entry");

      widget = lookup_widget (main_dlg, "mirror");
      GetSavedVar(ini_section, INI_MIRROR, strtmp);
      if (strcmp (strtmp, "0") == 0)
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
      else
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);

      READ_ENTRY (INI_LIGHTBALLS, "light_entry");
    }
    break;

  case DLG_TSCROLLER:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_INT (INI_BACK_COLOR_R , dlg_backcolor_red);
    READ_INT (INI_BACK_COLOR_G , dlg_backcolor_green);
    READ_INT (INI_BACK_COLOR_B , dlg_backcolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"),
		      dlg_backcolor_red, dlg_backcolor_green, dlg_backcolor_blue);

    widget = lookup_widget (main_dlg, "back_image_check");
    GetSavedVar(ini_section, INI_BACK_IMAGE_PATH, strtmp);
    if (strcmp (strtmp, INI_NO) == 0)
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    else
    {
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
      gtk_entry_set_text (GTK_ENTRY (lookup_widget (main_dlg, "back_image")), strtmp);
    }
    /*
      OnFlozBackImage();
    */
    break;

  case DLG_CONF_MENU:
    widget = lookup_widget (main_dlg, "tree");

    gtk_clist_clear (GTK_CLIST (widget));

    if (current_applet == APPLET_TREEMENU)
    {
      while (icon_list)
      {
	g_free (icon_list->data);
	icon_list = g_list_remove (icon_list, icon_list->data);
      }

      for (index=0; ;index++)
      {
	sprintf (section, "%s%d", INI_ICON_, index);
	GetSavedVar(ini_section, section, strtmp);
	if (strlen (strtmp) == 0)
	    break;
	icon_list = g_list_append (icon_list, g_strdup(strtmp));
      }

      {
	guint32 idMenu=0;
	RestoreTreeMenu(ini_section, GTK_CTREE (widget), NULL, &idMenu, 0);
      }

      if (GTK_CLIST (widget)->rows == 0 )
      {
	GtkCTreeNode* sel;
	ITEM_DATA* pItemData;
	char* row[2] = { "Main", NULL };

	sel = gtk_ctree_insert_node (GTK_CTREE (widget), NULL, NULL, row, 5, folder0_pixmap, folder0_mask,
				     folder1_pixmap, folder1_mask, FALSE, FALSE);

	pItemData = malloc (sizeof (ITEM_DATA));
	if (pItemData != NULL)
	{
	  strcpy (pItemData->strURL, "");
	  pItemData->bNewFrame=FALSE;
	  strcpy (pItemData->strNewFrameName, "_blank");
	  pItemData->bBack=FALSE;
	  pItemData->iIconIndex=-1;
	  pItemData->bDisableDropAfter=TRUE;
	  gtk_ctree_node_set_row_data (GTK_CTREE (widget), sel, pItemData);
	}
	gtk_ctree_select (GTK_CTREE (widget), sel);
      }
    }
    else
    {
      char link = '0';
      RestoreTreeCtrl(ini_section, GTK_CTREE (widget), NULL, '0', '0', &link, '0');
    }
    gtk_ctree_select (GTK_CTREE (widget), gtk_ctree_node_nth (GTK_CTREE (widget), 0));

    READ_CHECK (INI_AUTOAPPLY, "auto_apply");
    /*
      OnAutoapply();
    */
    break;

  case DLG_CONF_MENU_2:
    READ_CHECK (INI_FLOATINFRONT, "top");
    READ_ENTRY (INI_FLOAT_TITLE, "title");
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY (INI_FLOAT_X, "x");
    READ_ENTRY (INI_FLOAT_Y, "y");
    break;

  case DLG_WOBBLER:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY (INI_RES, "resolution_entry");
    READ_ENTRY (INI_IMAGE, "image");

    READ_ENTRY (INI_INITDISTANCE, "dist_initial");
    READ_ENTRY (INI_ZOOMSPEED, "zoom");
    READ_ENTRY (INI_MINDISTANCE, "dist_min");
    READ_ENTRY (INI_MAXDISTANCE, "dist_max");
    READ_ENTRY (INI_WRADIUS, "radius");
    READ_ENTRY (INI_WSTRENGTH, "wave");
    READ_ENTRY (INI_SPD1, "speed1");
    READ_ENTRY (INI_SPD2, "speed2");
    READ_ENTRY (INI_SPD3, "speed3");
    READ_ENTRY (INI_SPD4, "speed4");
    READ_ENTRY (INI_XMOVE, "movex");
    READ_ENTRY (INI_YMOVE, "movey");
    READ_ENTRY (INI_VAR_START, "start");
    READ_ENTRY (INI_VAR_MOVE, "move");
    READ_ENTRY (INI_PRECISION, "precision_entry");
    OnPresets(lookup_widget (main_dlg, "preset"), NULL);
    break;

  case DLG_WHEEL:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY (INI_FILTER, "filter_entry");
    READ_ENTRY (INI_FONT, "font_entry");
    READ_ENTRY (INI_BACK_TYPE, "mode_entry");
    /*
      OnSelchangeBackType();
    */
    READ_CHECK (INI_FLAT, "flat");

    GetSavedVar(ini_section, INI_MODE, strtmp);
    if (strcmp (strtmp, "gouraud") == 0)
      widget = lookup_widget (main_dlg, "gouraud");
    else
      widget = lookup_widget (main_dlg, "texture");
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);

    READ_ENTRY (INI_STATUSBARY, "statusbar");
    READ_ENTRY (INI_OFFSETSTEP, "submenu");
    READ_ENTRY (INI_MOUSESENS, "up");
    READ_ENTRY (INI_YROTATION, "left");
    READ_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    READ_ENTRY (INI_TEXTURE_FILE, "texture_entry");
    READ_ENTRY (INI_EXTRUDE_DIFF, "extrude");
    READ_ENTRY (INI_TEXTDIFF, "text");

    READ_UL (INI_BK_COLOR, dlg_ul_backcolor);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"), GetRValue(dlg_ul_backcolor),
		      GetGValue(dlg_ul_backcolor), GetBValue(dlg_ul_backcolor));

    READ_UL (INI_WHEEL_COLOR, dlg_ul_wheelcolor);
    set_color_pixmap (lookup_widget (main_dlg, "wheel_pixmap"), GetRValue(dlg_ul_wheelcolor),
		      GetGValue(dlg_ul_wheelcolor), GetBValue(dlg_ul_wheelcolor));

    READ_UL (INI_TEXT_COLOR, dlg_ul_textcolor);
    set_color_pixmap (lookup_widget (main_dlg, "text_pixmap"), GetRValue(dlg_ul_textcolor),
		      GetGValue(dlg_ul_textcolor), GetBValue(dlg_ul_textcolor));

    READ_UL (INI_SEL_COLOR, dlg_ul_selectcolor);
    set_color_pixmap (lookup_widget (main_dlg, "select_pixmap"), GetRValue(dlg_ul_selectcolor),
		      GetGValue(dlg_ul_selectcolor), GetBValue(dlg_ul_selectcolor));
    break;

  case DLG_MORPHMENU:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY (INI_MENUFX, "menu_entry");
    READ_ENTRY (INI_STATUSBARY, "statusbar");
    READ_ENTRY (INI_MENUY, "menu_y");
    //    READ_CHECK (INI_STANDARD_FONT, "standard");
    /*
      OnChkStdFont();
    */
    READ_ENTRY (INI_TEXT_FONT, "font_entry");
    READ_ENTRY (INI_TEXT_SIZE, "size_entry");
    READ_ENTRY (INI_ALIGN, "align_entry");

    READ_UL (INI_BK_COLOR, dlg_ul_backcolor);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"), GetRValue(dlg_ul_backcolor),
		      GetGValue(dlg_ul_backcolor), GetBValue(dlg_ul_backcolor));

    READ_UL (INI_TEXT_COLOR, dlg_ul_textcolor);
    set_color_pixmap (lookup_widget (main_dlg, "text_pixmap"), GetRValue(dlg_ul_textcolor),
		      GetGValue(dlg_ul_textcolor), GetBValue(dlg_ul_textcolor));

    READ_UL (INI_SEL_COLOR, dlg_ul_selectcolor);
    set_color_pixmap (lookup_widget (main_dlg, "select_pixmap"), GetRValue(dlg_ul_selectcolor),
		      GetGValue(dlg_ul_selectcolor), GetBValue(dlg_ul_selectcolor));

    READ_ENTRY (INI_BACKFX, "fx_entry");
    if (strcmp (strtmp, "color") == 0)
      dlg_plugin = -2;
    else if (strcmp (strtmp, "image") == 0)
      dlg_plugin = -1;
    else if (strcmp (strtmp, "mmgalaxy") == 0)
      dlg_plugin = 0;
    else
      dlg_plugin = 1;

    READ_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    break;

  case DLG_MM_GALAXY:
    READ_UL (INI_SEED_COLOR, dlg_ul_seedcolor);
    set_color_pixmap (lookup_widget (main_dlg, "seed_pixmap"), GetRValue(dlg_ul_seedcolor),
		      GetGValue(dlg_ul_seedcolor), GetBValue(dlg_ul_seedcolor));

    READ_ENTRY (INI_BACK_CLR, "back_entry");
    READ_CHECK (INI_CHK_BACK_COLOR, "back");
    READ_CHECK (INI_SMOOTH_FILTER, "smooth");

    READ_INT (INI_FIRE_COLOR_R , dlg_firecolor_red);
    READ_INT (INI_FIRE_COLOR_G , dlg_firecolor_green);
    READ_INT (INI_FIRE_COLOR_B , dlg_firecolor_blue);
    set_color_pixmap (lookup_widget (main_dlg, "fire_pixmap"), dlg_firecolor_red,
		      dlg_firecolor_green, dlg_firecolor_blue);

    READ_ENTRY (INI_SHAPE, "shape_entry");
    break;

  case DLG_MM_BLOBS:
    READ_ENTRY (INI_NBLOBS, "number_entry");
    READ_ENTRY (INI_BVAL1, "i");
    READ_ENTRY (INI_BVAL2, "j");
    READ_ENTRY (INI_BVAL3, "k");
    READ_ENTRY (INI_MINSPEED, "min_entry");
    READ_ENTRY (INI_COLORPAL, "color_entry");

    READ_CHECK (INI_SINEMODE, "sine");
    READ_CHECK (INI_STARSHAPE, "starshape");
    READ_CHECK (INI_NEGCOLOR, "negative");
    break;

  case DLG_TREEMENU:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY (INI_INGOING, "scroll_close");
    READ_ENTRY (INI_OUTGOING, "scroll_open");
    //    READ_CHECK (INI_STANDARD_FONT, "standard");
    READ_ENTRY (INI_TEXT_FONT, "font_entry");
    READ_ENTRY (INI_TEXT_SIZE, "size_entry");
    READ_CHECK (INI_TEXT_ITALIC, "italic");
    READ_CHECK (INI_TEXT_BOLD, "bold");
    READ_CHECK (INI_AUTOHIGHLIGHT, "highlight");
    READ_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    READ_ENTRY (INI_SCROLLBAR_SIZE, "scroll_entry");
    READ_ENTRY (INI_BORDER_STYLE, "border_entry");

    READ_UL (INI_TEXT_COLOR, dlg_ul_textcolor);
    set_color_pixmap (lookup_widget (main_dlg, "text_pixmap"), GetRValue(dlg_ul_textcolor),
		      GetGValue(dlg_ul_textcolor), GetBValue(dlg_ul_textcolor));

    READ_UL (INI_BK_COLOR, dlg_ul_backcolor);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"), GetRValue(dlg_ul_backcolor),
		      GetGValue(dlg_ul_backcolor), GetBValue(dlg_ul_backcolor));

    READ_UL (INI_SEL_COLOR, dlg_ul_selectcolor);
    set_color_pixmap (lookup_widget (main_dlg, "select_pixmap"), GetRValue(dlg_ul_selectcolor),
		      GetGValue(dlg_ul_selectcolor), GetBValue(dlg_ul_selectcolor));

    READ_UL (INI_SEL_BAKC_COLOR, dlg_ul_selbackcolor);
    set_color_pixmap (lookup_widget (main_dlg, "selback_pixmap"), GetRValue(dlg_ul_selbackcolor),
		      GetGValue(dlg_ul_selbackcolor), GetBValue(dlg_ul_selbackcolor));

    READ_UL (INI_SCROLL_COLOR, dlg_ul_scrollcolor);
    set_color_pixmap (lookup_widget (main_dlg, "scroll_pixmap"), GetRValue(dlg_ul_scrollcolor),
		      GetGValue(dlg_ul_scrollcolor), GetBValue(dlg_ul_scrollcolor));

    READ_UL (INI_FILTER_COLOR, dlg_ul_filtercolor);
    set_color_pixmap (lookup_widget (main_dlg, "filter_pixmap"), GetRValue(dlg_ul_filtercolor),
		      GetGValue(dlg_ul_filtercolor), GetBValue(dlg_ul_filtercolor));

    READ_ENTRY (INI_INBOUNC, "close");
    READ_ENTRY (INI_OUTBOUNC, "open");
    READ_ENTRY (INI_BGRAVITY, "gravity");
    READ_ENTRY (INI_BAMPLITUDE, "amplitude");
    break;

  case DLG_ANFYCAM:
    READ_ENTRY (INI_IMAGE_FILE, "image");
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY_INT (INI_RES, "resolution_entry", dlg_oldres);

    READ_ENTRY (INI_INTERVAL, "interval");
    READ_ENTRY (INI_FADESPEED, "fade");

    READ_CHECK (INI_PROGRFADE, "progressive");
    break;

  case DLG_ANFYPAINT:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY (INI_JPGQUALITY, "jpeg");
    READ_CHECK (INI_SAVEBUTTON, "save");

    READ_UL (INI_BK_COLOR, dlg_ul_backcolor);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"), GetRValue(dlg_ul_backcolor),
		      GetGValue(dlg_ul_backcolor), GetBValue(dlg_ul_backcolor));
    READ_UL (INI_PEN_COLOR, dlg_ul_pencolor);
    set_color_pixmap (lookup_widget (main_dlg, "pen_pixmap"), GetRValue(dlg_ul_pencolor),
		      GetGValue(dlg_ul_pencolor), GetBValue(dlg_ul_pencolor));

    READ_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    READ_ENTRY (INI_SENDTOMAIL, "mail");
    READ_ENTRY (INI_STARTMESSAGE, "start");
    READ_ENTRY (INI_NOJAVAMSG, "nojava");
    break;

  case DLG_SOLIDSCROLLER:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_TEXT_TYPE, "type_entry");
    /*
      OnSelchangeText_Type();
    */
    READ_ENTRY (INI_WAVEMODE, "wave_mode_entry");
    READ_ENTRY (INI_WAVESPEED, "wave_speed");
    READ_ENTRY (INI_WAVETYPE, "wave_type_entry");
    READ_CHECK (INI_REVERSEFX, "reverse");

    READ_ENTRY (INI_TEXTVSPACE, "v_spac");
    READ_ENTRY (INI_TEXTSPEED, "speed");
    READ_ENTRY (INI_TEXTOFFSET, "y_offset");
    READ_ENTRY (INI_TEXTJUMPAMP, "jump_amp");
    READ_ENTRY (INI_TEXTJUMPSPEED, "jump_speed");
    READ_ENTRY (INI_MIRRORMODE, "mirror_mode_entry");
    /*
      OnSelchangeMirrormode();
    */
    READ_ENTRY (INI_MIRRORHEIGTH, "mirror_height");

    READ_UL (INI_BK_COLOR, dlg_ul_backcolor);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"), GetRValue(dlg_ul_backcolor),
		      GetGValue(dlg_ul_backcolor), GetBValue(dlg_ul_backcolor));
    break;

  case DLG_ANFYFONT:
    {
      char pszScrollText[MAX_SCROLLTEXT_SIZE];

      widget = lookup_widget (main_dlg, "text");

      if (ReadWriteFileScrollText(current_applet, pszScrollText, 0))
      {
	gtk_text_insert (GTK_TEXT (widget), NULL, NULL, NULL,
			 pszScrollText, strlen(pszScrollText));
	gtk_adjustment_set_value (GTK_TEXT(widget)->vadj, 0);
      }
      else
	gtk_text_insert (GTK_TEXT (widget), NULL, NULL, NULL, "", 0);
    }

    READ_ENTRY (INI_FONTINDEX, "font");

    {
      char strDir[1024];

      GetAppletPath(current_applet, strDir);
      strcat (strDir, "/");
      strcat (strDir, strtmp);
      UpdateFontProperties(strDir);
    }
    break;

  case DLG_ANFYSNOW:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");

    READ_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    READ_ENTRY (INI_F1_NUMFAR, "far");
    READ_ENTRY (INI_F2_NUMMIDDLE, "middle");
    READ_ENTRY (INI_F3_NUMNEAR, "near");
    READ_ENTRY (INI_F4_NUMFORROUND, "fore");

    READ_ENTRY (INI_WIND_MAX_SPEED, "speed_entry");
    READ_ENTRY (INI_WIND_VAR, "var_entry");

    READ_ENTRY (INI_SNOW_SPEED, "drop_speed");

    READ_UL (INI_BK_COLOR, dlg_ul_backcolor);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"), GetRValue(dlg_ul_backcolor),
		      GetGValue(dlg_ul_backcolor), GetBValue(dlg_ul_backcolor));
    READ_CHECK (INI_SNOWOVER, "snow_over");
    break;

  case DLG_FIREWORKS:
    READ_ENTRY (INI_WIDTH, "width");
    READ_ENTRY (INI_HEIGHT, "height");
    READ_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    READ_ENTRY (INI_AUDIOFILE, "audio");
    READ_ENTRY (INI_FW_MAX, "max");
    READ_ENTRY (INI_FW_POWER, "power");
    READ_ENTRY (INI_FW_DENSITY, "density");
    READ_ENTRY (INI_FW_TIMEDURATION, "duration");
    READ_ENTRY (INI_GRAVITY, "gravity");

    READ_CHECK (INI_SHOWOVERTEXT, "over_text");
    READ_UL (INI_BK_COLOR, dlg_ul_backcolor);
    set_color_pixmap (lookup_widget (main_dlg, "color_pixmap"), GetRValue(dlg_ul_backcolor),
		      GetGValue(dlg_ul_backcolor), GetBValue(dlg_ul_backcolor));
    break;
  }

  widget = valid_widget (main_dlg, "textscroll");
  if (widget != NULL)
  {
    GetSavedVar(ini_section, INI_TEXTSCROLL, strtmp);

    if (strcmp (strtmp, GetScrollTextFile(current_applet)) == 0)
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), TRUE);
    else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (widget), FALSE);
    /*
      OnChkEnableText();
    */
  }

  widget = valid_widget (main_dlg, "float_mode");
  if (widget != NULL)
  {
    READ_CHECK (INI_FLOATMODE, "float_mode");
    OnFloatmode (widget, NULL);
  }

  widget = valid_widget (main_dlg, "charset");
  if (widget != NULL)
  {
    GList* list = NULL;
    int i;

    for (i = 0; map_char_set[i].description != NULL; i++)
      list = g_list_append (list, (char*)map_char_set[i].description);
    list = g_list_append (list, _("Other..."));

    gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget (main_dlg, "charset_combo")), list);
    g_list_free (list);

    READ_ENTRY (INI_CHARSET, "charset_entry");
  }

  /*
    m_bRestoreData=FALSE;
  */
}
