#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "main.h"
#include "custom.h"
#include "support.h"
#include "misc.h"

// =========================================================

char* GetScrollTextFile (int applet);
void GetListRegCode(char* strRegCode, GtkWidget* dlg);

#define IS_CHECKED(w) gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (lookup_widget (main_dlg, w)))
#define GET_TEXT(w) gtk_entry_get_text (GTK_ENTRY (lookup_widget (main_dlg, w)))

#define SAVE_INT(v,i) { \
  char tmp[8]; \
  sprintf (tmp, "%d", i); \
  SaveVar(ini_section, v, tmp); }

#define SAVE_UL(v,i) { \
  char tmp[8]; \
  sprintf (tmp, "%lx", (long unsigned int)i); \
  SaveVar(ini_section, v, tmp); }

#define SAVE_ENTRY(v,w) \
	SaveVar(ini_section, v, gtk_entry_get_text (GTK_ENTRY (lookup_widget (main_dlg, w))))

#define SAVE_CHECK(v,w) { \
  widget = lookup_widget (main_dlg, w); \
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)) == TRUE) \
    SaveVar(ini_section, v, INI_YES); \
  else \
    SaveVar(ini_section, v, INI_NO); }

#define SAVE_CHECK_ENTRY(s,c,e) { \
  widget = lookup_widget (main_dlg, c); \
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)) == TRUE) \
    SaveVar(ini_section, s, gtk_entry_get_text (GTK_ENTRY (lookup_widget (main_dlg, e)))); \
  else \
    SaveVar(ini_section, s, INI_NO); }

// =========================================================

guint8* m_aiIconFlag;

void SaveTreeMenu(GtkCTree* ptc, GtkCTreeNode* item, guint32* pidMenu, guint32 idLevel)
{
  GtkCTreeNode* child = NULL;
  char strItem[256], *strText, strCaption[256];
  ITEM_DATA* pItemData;

  if (item == NULL || ptc == NULL)
  {
    --(*pidMenu);
    return;
  }

  sprintf (strCaption, "%s%d", INI_MENU_TEXT_, *pidMenu);
  gtk_ctree_get_node_info (ptc, item, &strText, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
  SaveVar (applet_info[current_applet].name, strCaption, strText);

  sprintf (strCaption, "%s%d",INI_MENU_LEVEL_, *pidMenu);
  sprintf (strItem, "%d", idLevel);
  SaveVar(applet_info[current_applet].name, strCaption, strItem);

  pItemData=(ITEM_DATA*)gtk_ctree_node_get_row_data (ptc, item);
  if (pItemData != NULL)
  {
    sprintf (strCaption, "%s%d",INI_MENU_URL_, *pidMenu);
    SaveVar(applet_info[current_applet].name, strCaption, pItemData->strURL);

    if (pItemData->iIconIndex >=0)
    {
      /*
	m_aiIconFlag.SetAtGrow(m_astrIconList.GetSize(),0);

	if( m_aiIconFlag[pItemData->iIconIndex] != 1 )
	{
				sprintf (strCaption, "%s%d",INI_ICON_, m_iIndex);
				SaveVar( applet_info[current_applet].name, strCaption, m_astrIconList[pItemData->iIconIndex] );
				m_aiIconFlag.SetAt(pItemData->iIconIndex,1);

				//salvo in questo vettore la posizione in cui o mem. l'icona
				//nelle impostazioni
				//m_uiIconPos[pItemData->iIconIndex]=m_iIndex;
				m_aiIconPos.SetAtGrow(pItemData->iIconIndex,m_iIndex);

				//salvo una stringa nulla nella posizione successiva
				//per impdeire fusioni con le impostazioni precedenti
				sprintf (strCaption, "%s%d",INI_ICON_, m_iIndex+1);
				SaveVar( applet_info[current_applet].name, strCaption, _T("") );

				m_iIndex++;
			}

			sprintf (strCaption, "%s%d",INI_MENU_ICON_, *pidMenu);
			CString strPos;
			strPos.Format(_T("%d"), m_aiIconPos[pItemData->iIconIndex] );
			SaveVar(applet_info[current_applet].name, strCaption, strPos );
      */
    }
  }

  if ((child = GTK_CTREE_ROW (item)->children) != NULL)
  {
    //se e' un nodo salvo anche se e' espanso o no
    sprintf (strCaption, "%s%d",INI_MENU_STATE, *pidMenu);
    if (GTK_CTREE_ROW (item)->expanded)
      SaveVar(applet_info[current_applet].name, strCaption, "1");
    else
      SaveVar(applet_info[current_applet].name, strCaption, "0");

    sprintf (strCaption, "%s%d",INI_MENU_LINK_, *pidMenu);
    sprintf (strItem, "%d", *pidMenu+1);
    SaveVar(applet_info[current_applet].name, strCaption, strItem);

    ++(*pidMenu);
    SaveTreeMenu( ptc, child , pidMenu, idLevel+1);
  }
  else
  {
    sprintf (strCaption, "%s%d",INI_MENU_LINK_, *pidMenu);
    SaveVar(applet_info[current_applet].name, strCaption, "");
  }

  if ((child = GTK_CTREE_ROW (item)->sibling) != NULL)
  {
    ++(*pidMenu);
    SaveTreeMenu( ptc, child, pidMenu, idLevel );
  }
  else
  {
    sprintf (strCaption, "%s%d",INI_MENU_TEXT_, (*pidMenu)+1);
    SaveVar(applet_info[current_applet].name, strCaption, "");
  }
}

void SaveTreeCtrl(GtkCTree* ptc, GtkCTreeNode* item, char x, char y, char* pcLink, char cParent)
{
  char strCaption[256];
  GtkCTreeNode* child = NULL;
  ITEM_DATA* pItemData;

  if (item == NULL || ptc == NULL)
    return;

  sprintf (strCaption, "%s%c%c", INI_MENU_TEXT_, x, y);
  {
    gchar* strText;
    gtk_ctree_get_node_info (ptc, item, &strText, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
    SaveVar (applet_info[current_applet].name, strCaption, strText);
  }

  pItemData=(ITEM_DATA*)gtk_ctree_node_get_row_data (ptc, item);
  if( pItemData != NULL )
  {
    sprintf (strCaption, "%s%c%c",INI_MENU_URL_, x, y);
    SaveVar(applet_info[current_applet].name, strCaption, pItemData->strURL );
    sprintf (strCaption, "%s%c%c",INI_MENU_TARGET_, x, y);
    SaveVar(applet_info[current_applet].name, strCaption, pItemData->strNewFrameName );
  }

  if ((child = GTK_CTREE_ROW (item)->children) != NULL)
  {
    //se e' un nodo salvo anche se e' espanso o no
    sprintf (strCaption, "%s%c%c", INI_MENU_STATE, x, y);
    if (GTK_CTREE_ROW (item)->expanded)
      SaveVar(applet_info[current_applet].name, strCaption, "1");
    else
      SaveVar(applet_info[current_applet].name, strCaption, "0");

    (*pcLink)=GetMenuLinkNext(applet_info[current_applet].name, (*pcLink));
    sprintf (strCaption, "%s%c%c", INI_MENU_LINK_, x, y);

    SaveVar(applet_info[current_applet].name, strCaption, pcLink);
    SaveTreeCtrl(ptc, child , *pcLink, '0', pcLink, x);
  }
  else if (pItemData != NULL)
  {
    if (pItemData->bBack)
    {
      char tmp[2] = { cParent, 0 };

      sprintf (strCaption, "%s%c%c", INI_MENU_LINK_, x, y);
      SaveVar(applet_info[current_applet].name, strCaption, tmp);
    }
    else
    {
      sprintf (strCaption, "%s%c%c", INI_MENU_LINK_, x, y);
      SaveVar(applet_info[current_applet].name, strCaption, "");
    }
  }

  if ((child = GTK_CTREE_ROW (item)->sibling) != NULL)
  {
    SaveTreeCtrl(ptc, child, x, GetMenuLinkNext(applet_info[current_applet].name, y), pcLink, cParent);
  }
  else
  {
    //salvo anche una voce successiva vuota per evitare "fusioni" con le
    //impostazioni precedenti
    sprintf (strCaption, "%s%c%c", INI_MENU_TEXT_, x, GetMenuLinkNext(applet_info[current_applet].name, y));
    SaveVar(applet_info[current_applet].name, strCaption, "");
  }
}

// =========================================================

void save_dialog_data ( /* char* lpcstrPathFileName*/ )
{
  char strtmp[256], ini_section[64], section[64];
  int items, index;
  GtkWidget* widget = NULL;
  IMAGE_INFO *info;

  if (current_applet != -1)
    strcpy (ini_section, applet_info[current_applet].name);

  switch (current_dialog)
  {
  case DLG_STEP0:
    SaveVar(INI_APP_SECTION, INI_LAST_APPLET_CONFIGURED, GET_TEXT("applet_entry"));
    /*
    ((CAppletWzdDlg*)m_pParentWnd)->m_strCurrentApplet=strTmp;
    */

    if (IS_CHECKED("cat_banner"))
      strcpy (strtmp, "1");
    else if (IS_CHECKED("cat_fractals"))
      strcpy (strtmp, "2");
    else if (IS_CHECKED("cat_image"))
      strcpy (strtmp, "3");
    else if (IS_CHECKED("cat_3d"))
      strcpy (strtmp, "4");
    else if (IS_CHECKED("cat_navigation"))
      strcpy (strtmp, "5");
    else // if (IS_CHECKED("cat_other"))
      strcpy (strtmp, "6");

    SaveVar(INI_APP_SECTION, INI_LAST_APPLET_CATEGORY, strtmp);

    break;

  case DLG_TEXTSTYLE:
    SAVE_ENTRY (INI_TEXTMODE, "text_type_entry");

    {
      char* txt;

      txt = gtk_editable_get_chars (GTK_EDITABLE (lookup_widget (main_dlg, "text")), 0, -1);

      if (strchr (txt, '\n') == NULL)
	strcat(txt, "\r\n");
      ReadWriteFileScrollText(current_applet, txt, 1); //write
    }

    SAVE_ENTRY (INI_TEXTVSPACE, "v_spac");
    SAVE_ENTRY (INI_TEXTSPEED, "speed");
    SAVE_ENTRY (INI_TEXTOFFSET, "y_offset");
    SAVE_ENTRY (INI_TEXTSINANGLE, "sine_angle");
    SAVE_ENTRY (INI_TEXTSINEAMPL, "sine_amplitude");
    SAVE_ENTRY (INI_TEXTSINSPEED, "sine_speed");
    SAVE_ENTRY (INI_TEXTJUMPAMP, "jump_amplitude");
    SAVE_ENTRY (INI_TEXTJUMPSPEED, "jump_speed");

    SAVE_CHECK (INI_TEXTSHADOW, "shadow");

    SAVE_INT (INI_TEXT_COLORRED, dlg_textcolor_red);
    SAVE_INT (INI_TEXT_COLORGREEN, dlg_textcolor_green);
    SAVE_INT (INI_TEXT_COLORBLU, dlg_textcolor_blue);

    //    SAVE_CHECK (INI_STANDARD_FONT, "standard");

    SAVE_ENTRY (INI_TEXT_FONT, "font_entry");
    SAVE_ENTRY (INI_TEXT_SIZE, "size_entry");
    SAVE_ENTRY (INI_TEXT_SIZE_MIN, "min_entry");
    SAVE_ENTRY (INI_TEXT_SIZE_MAX, "max_entry");

    SAVE_CHECK (INI_TEXT_ITALIC, "italic");
    SAVE_CHECK (INI_TEXT_BOLD, "bold");

    SAVE_INT (INI_TEXTS_COLORRED, dlg_textscolor_red);
    SAVE_INT (INI_TEXTS_COLORGREEN, dlg_textscolor_green);
    SAVE_INT (INI_TEXTS_COLORBLU, dlg_textscolor_blue);
    break;

  case DLG_EXPERTMODE:
    SAVE_ENTRY (INI_EX_MEMDELAY, "memory");
    SAVE_ENTRY (INI_EX_TASK_PRIORITY, "task");
    SAVE_ENTRY (INI_EX_MINSYNC, "minsync");
    SAVE_CHECK (INI_FIXNETSCAPE, "netscape");

    SAVE_ENTRY (INI_STATUSMSG, "statusbar");
    SAVE_ENTRY (INI_NOJAVAMSG, "nojava");

    widget = lookup_widget (main_dlg, "enable_image");
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget)) == TRUE)
      SAVE_ENTRY (INI_OVERIMG, "image");
    else
      SaveVar(ini_section, INI_OVERIMG, INI_NO);

    SAVE_ENTRY (INI_OVERIMGX, "xoffset");
    SAVE_ENTRY (INI_OVERIMGY, "yoffset");
    break;
    /*
  case DLG_REGCODE:
    */
  case DLG_REGISTRATION:
    {
      char strRegCode[256], *strTmp;
      GtkWidget* label = GTK_BIN (lookup_widget (main_dlg, "domains"))->child;

      if (label != NULL)
      {
	gtk_label_get (GTK_LABEL (label), &strTmp);
	SaveVar(INI_APP_SECTION, INI_DOMAIN, strTmp);
      }

      GetListRegCode(strRegCode, main_dlg);
      SaveVar(INI_APP_SECTION, INI_REGCODE, strRegCode);

      if (current_dialog == DLG_REGISTRATION)
      {
	if (IS_CHECKED ("enable_link"))
	  SaveVar (ini_section, INI_REGLINK, INI_NO);
	else
	  SAVE_ENTRY (INI_REGLINK, "link_entry");
      
	if (!(IS_CHECKED ("enable_target")))
	{
	  SaveVar(ini_section, INI_REGNEWFRAME, INI_NO);
	  SaveVar(ini_section, INI_REGFRAMENAME, "_blank");
	}
	else
	{
	  SaveVar(ini_section, INI_REGNEWFRAME, INI_YES);
	  strTmp = GET_TEXT ("mode_entry");

	  if (strcmp (strTmp, _("other target...")) == 0)
	    SAVE_ENTRY (INI_REGFRAMENAME, "target_entry");
	  else
	    SaveVar(ini_section, INI_REGFRAMENAME, strTmp);
	}
      }
    }
    break;

  case DLG_BLOBS:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_NBLOBS, "number_entry");
    SAVE_ENTRY (INI_BVAL1, "i");
    SAVE_ENTRY (INI_BVAL2, "j");
    SAVE_ENTRY (INI_BVAL3, "k");
    SAVE_ENTRY (INI_RES, "resolution_entry");
    SAVE_ENTRY (INI_MINSPEED, "min_entry");
    SAVE_ENTRY (INI_COLORPAL, "color_entry");

    SAVE_CHECK (INI_SINEMODE, "sine");
    SAVE_CHECK (INI_STARSHAPE, "star");
    SAVE_CHECK (INI_NEGCOLOR, "negative");
    break;

  case DLG_ANBLUR:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_FORMAT_VALUE, "image_type");
    SAVE_ENTRY (INI_IMGS_VALUE, "frames");
    SAVE_ENTRY (INI_NIMGS, "num");

    SAVE_CHECK (INI_PINGPONG, "ping_pong");
    SAVE_CHECK (INI_DOUBLESIZE, "double_size");

    SAVE_ENTRY (INI_SPEED, "play");
    SAVE_ENTRY (INI_PINGPAUSE, "ping_pause");
    SAVE_ENTRY (INI_PONGPAUSE, "pong_pause");
    SAVE_ENTRY (INI_AUDIOPING, "ping_audio");
    SAVE_ENTRY (INI_AUDIOPONG, "pong_audio");
    break;

  case DLG_ANFYBUMP:
    SAVE_ENTRY (INI_IMAGE_FILE, "image");
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");

    SAVE_CHECK_ENTRY (INI_ALT_IMAGE_FILE, "alt_image", "bump_image");

    SAVE_ENTRY (INI_BUMP_HEIGHT, "bump_entry");
    SAVE_ENTRY (INI_LIGHTSIZE, "light_entry");

    SAVE_CHECK (INI_INTERACTIVE_MODE, "interactive");

    SAVE_ENTRY (INI_ANGLE_X, "anglex");
    SAVE_ENTRY (INI_ANGLE_Y, "angley");
    SAVE_ENTRY (INI_LMIN, "min");
    SAVE_ENTRY (INI_LMAX, "max");
    SAVE_ENTRY (INI_LPOW, "power");
    break;

  case DLG_ANFADE:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");

    widget = lookup_widget (main_dlg, "image_list");
    items = GTK_CLIST (widget)->rows;
    for(index = 0; index < items; index++)
    {
      info = gtk_clist_get_row_data (GTK_CLIST (widget), index);

      sprintf (section, "%s%d", INI_IMAGE_, index+1);
      SaveVar(ini_section, section, info->image);
      sprintf (section, "%s%d", INI_LINK_, index+1);
      SaveVar(ini_section, section, info->link);
      sprintf (section, "%s%d", INI_STATUS_MSG_, index+1);
      SaveVar(ini_section, section, info->status);
    }

    sprintf (section, "%s%d", INI_IMAGE_, index+1);
    SaveVar(ini_section, section, "");

    SAVE_CHECK (INI_PROGFADE, "progressive");
    SAVE_ENTRY (INI_FRAME_SPEED, "frame_speed");
    SAVE_ENTRY (INI_PAUSE, "pause");
    break;

  case DLG_ANFLAG:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_FLAG_RES, "resolution_entry");
    SAVE_ENTRY (INI_FLAG_PATTERN, "pattern_entry");
    SAVE_ENTRY (INI_WIND_SPEED, "speed");
    SAVE_ENTRY (INI_WIND, "wind_entry");
    SAVE_ENTRY (INI_FLAG_NATION, "nation_entry");
    SAVE_ENTRY (INI_CURVE, "curve_entry");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);

    SAVE_ENTRY (INI_PIXDENSITY, "pix_entry");
    break;

  case DLG_CUBEMENU:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");

    widget = lookup_widget (main_dlg, "image_list");
    items = GTK_CLIST (widget)->rows;
    for(index = 0; index < items; index++)
    {
      info = gtk_clist_get_row_data (GTK_CLIST (widget), index);

      sprintf (section, "%s%d", INI_IMAGE_, index+1);
      SaveVar(ini_section, section, info->image);
      sprintf (section, "%s%d", INI_LINK_, index+1);
      SaveVar(ini_section, section, info->link);
      sprintf (section, "%s%d", INI_STATUS_MSG_, index+1);
      SaveVar(ini_section, section, info->status);
    }

    for (; index < 6; index++)
    {
      sprintf (section, "%s%d", INI_IMAGE_, index+1);
      SaveVar(ini_section, section, "");
      sprintf (section, "%s%d", INI_LINK_, index+1);
      SaveVar(ini_section, section, "");
      sprintf (section, "%s%d", INI_STATUS_MSG_, index+1);
      SaveVar(ini_section, section, "");
    }

    SAVE_ENTRY (INI_ROTX, "x");
    SAVE_ENTRY (INI_ROTY, "y");
    SAVE_ENTRY (INI_ROTZ, "z");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);

    SAVE_CHECK (INI_CLEAR_BACKGROUND, "clear");	

    SAVE_ENTRY (INI_BACK_IMAGE_PATH, "back_image_entry");
    break;

  case DLG_DEFORM:
    SAVE_ENTRY (INI_IMAGE, "image");
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");
    SAVE_ENTRY (INI_DISTVAL, "value");
    SAVE_ENTRY (INI_DFACT, "factor");
    SAVE_ENTRY (INI_DSPEED, "speed");
    SAVE_ENTRY (INI_DOFFSET, "offset");
    SAVE_ENTRY (INI_XV1, "x1");
    SAVE_ENTRY (INI_YV1, "y1");
    SAVE_ENTRY (INI_XV2, "x2");
    SAVE_ENTRY (INI_YV2, "y2");
    break;

  case DLG_FIRE:
    SAVE_ENTRY (INI_FIRE_WIDTH, "fire_width");
    SAVE_ENTRY (INI_FIRE_HEIGHT, "fire_height");
    SAVE_ENTRY (INI_FIRE_X_RES, "x_entry");
    SAVE_ENTRY (INI_FIRE_Y_RES, "y_entry");
    SAVE_ENTRY (INI_FC_START, "start");
    SAVE_ENTRY (INI_FC_VALUE, "value");
    SAVE_ENTRY (INI_DLIGHT, "def");

    if (IS_CHECKED ("rectangle"))
      SaveVar(ini_section, INI_FIRE_FORM, "1");
    else
      SaveVar(ini_section, INI_FIRE_FORM, "2");

    SAVE_ENTRY (INI_RND_REP, "repeat_entry");
    SAVE_ENTRY (INI_PALR, "r_entry");
    SAVE_ENTRY (INI_PALG, "g_entry");
    SAVE_ENTRY (INI_PALB, "b_entry");
    break;

  case DLG_FLAGLOAD:
    SAVE_ENTRY (INI_FLAGLOAD, "image");
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_FLAG_RES, "resolution_entry");
    SAVE_ENTRY (INI_FLAG_PATTERN, "pattern_entry");
    SAVE_ENTRY (INI_WIND_SPEED, "speed");
    SAVE_ENTRY (INI_WIND, "wind_entry");
    SAVE_ENTRY (INI_CURVE, "curve_entry");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);

    SAVE_ENTRY (INI_PIXDENSITY, "pix_entry");

    SAVE_CHECK_ENTRY (INI_BACK_IMAGE_PATH, "back_image_check", "back_image");
    break;

  case DLG_FLOZOIDS:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);

    SAVE_ENTRY (INI_NFLOZ, "number");
    SAVE_ENTRY (INI_DISTANCE, "distance");
    SAVE_ENTRY (INI_TOCENTER, "center");
    SAVE_ENTRY (INI_ACCELL, "acceleration");
    SAVE_ENTRY (INI_FLOZ_SPEED, "speed");
    SAVE_ENTRY (INI_SIDE_BOUNCING, "bouncing");

    SAVE_CHECK (INI_HEADS, "heads");
    SAVE_CHECK (INI_GO_OVER_TEXT, "over_text");

    SAVE_INT (INI_FIRST_COLOR_R, dlg_f1color_red);
    SAVE_INT (INI_FIRST_COLOR_G, dlg_f1color_green);
    SAVE_INT (INI_FIRST_COLOR_B, dlg_f1color_blue);
    SAVE_INT (INI_LAST_COLOR_R, dlg_f2color_red);
    SAVE_INT (INI_LAST_COLOR_G, dlg_f2color_green);
    SAVE_INT (INI_LAST_COLOR_B, dlg_f2color_blue);

    SAVE_CHECK_ENTRY (INI_BACK_IMAGE_PATH, "back_image_check", "back_image");
    SAVE_CHECK (INI_INTERACTIVE_MODE, "interactive");
    break;

  case DLG_FLUID:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");

    SAVE_CHECK (INI_CHK_AUTODESIGN, "autodesign");
			
    SAVE_ENTRY (INI_FLUID_DENSITY, "fluid_entry");
    SAVE_ENTRY (INI_RSIZE, "rsize");
    SAVE_ENTRY (INI_RFACTOR, "rfactor");
    SAVE_ENTRY (INI_SRSIZE, "ssize");
    SAVE_ENTRY (INI_SRFACTOR, "sfactor");

    SAVE_CHECK (INI_CHK_VOLCANO, "volcano");

    SAVE_ENTRY (INI_NFISH, "fish_entry");
    break;

  case DLG_HUEROT:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");
    SAVE_ENTRY (INI_IMAGE_FILE, "image");
    SAVE_ENTRY (INI_HUESHIFT, "hueshift");
    break;

  case DLG_ANFRACT:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_DIM, "dimension");
    SAVE_ENTRY (INI_BRANCH, "branches");
    SAVE_ENTRY (INI_MORPH_SPEED, "morph");
    SAVE_ENTRY (INI_ROT_SPEED, "rotation");
    SAVE_ENTRY (INI_ROT_SPEED2, "rotation2");
    SAVE_ENTRY (INI_DECLINE, "decline");
    SAVE_ENTRY (INI_LENGTH, "length");
    SAVE_ENTRY (INI_PENSIZE, "pen_entry");

    SAVE_CHECK (INI_PROGRESS, "progress");

    SAVE_ENTRY (INI_PEN_PROGR, "pen_progr");

    SAVE_CHECK (INI_PROGINVERSE, "progr_inv");
    SAVE_CHECK (INI_ITERSKIP, "iterskip");

    SAVE_INT (INI_IFS1_R, dlg_f1color_red);
    SAVE_INT (INI_IFS1_G, dlg_f1color_green);
    SAVE_INT (INI_IFS1_B, dlg_f1color_blue);
    SAVE_INT (INI_IFS2_R, dlg_f2color_red);
    SAVE_INT (INI_IFS2_G, dlg_f2color_green);
    SAVE_INT (INI_IFS2_B, dlg_f2color_blue);

    SAVE_CHECK (INI_OVERTEXT, "over_text");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);

    SAVE_CHECK_ENTRY (INI_BACK_IMAGE_PATH, "back_image_check", "back_image");
    break;

  case DLG_ANLAKE:
    SAVE_ENTRY (INI_IMAGE_FILE, "image");
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");
    SAVE_ENTRY (INI_WIND, "intensity_entry");
    SAVE_ENTRY (INI_WIND_VSPEED, "wind_speed");
    SAVE_ENTRY (INI_WIND_VMIN, "wind_min_entry");
    SAVE_ENTRY (INI_WIND_VMAX, "wind_max_entry");
    SAVE_ENTRY (INI_WSPEED, "wave");
    SAVE_ENTRY (INI_PERSPECTIVE, "perspective");
    SAVE_ENTRY (INI_FARWAVING, "farwaving");

    SAVE_CHECK (INI_HALFREFLECT, "half_effect");
    break;

  case DLG_ANLENS:
    SAVE_ENTRY (INI_IMAGE_FILE, "image");
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_LENS_WIDTH, "lens_width");
    SAVE_ENTRY (INI_ZOOM_FACTOR, "zoom");
    SAVE_ENTRY (INI_XSPEED, "x_entry");
    SAVE_ENTRY (INI_YSPEED, "y_entry");

    SAVE_CHECK (INI_INTERACTIVE, "interactive");
    SAVE_CHECK (INI_CHK_DISTORSION, "distortion");

    SAVE_ENTRY (INI_DIAG_DISTORSION, "diagonal_entry");
    SAVE_ENTRY (INI_XY_DISTORSION, "xy");
    break;

  case DLG_LIFE2D:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES_LIFE, "resolution_entry");

    SAVE_INT (INI_FOR_COLOR_R, dlg_forcolor_red);
    SAVE_INT (INI_FOR_COLOR_G, dlg_forcolor_green);
    SAVE_INT (INI_FOR_COLOR_B, dlg_forcolor_blue);
    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);

    SAVE_ENTRY (INI_LIFEDENSITY, "life_entry");
    break;

  case DLG_MANDEL:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_MANDEL_RES, "resolution_entry");
    SAVE_ENTRY (INI_XSTART, "startx");
    SAVE_ENTRY (INI_YSTART, "starty");
    SAVE_ENTRY (INI_NUMPAL, "palette_entry");
    SAVE_ENTRY (INI_XMIN, "xmin");
    SAVE_ENTRY (INI_XMAX, "xmax");
    SAVE_ENTRY (INI_YMIN, "ymin");
    SAVE_ENTRY (INI_YMAX, "ymax");
    break;

  case DLG_PLASMA:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_PLASMA_RES, "resolution_entry");
    SAVE_ENTRY (INI_GEN1, "gen1");
    SAVE_ENTRY (INI_GEN2, "gen2");
    SAVE_ENTRY (INI_GEN3, "gen3");
    SAVE_ENTRY (INI_RED1, "r0");
    SAVE_ENTRY (INI_RED2, "r1");
    SAVE_ENTRY (INI_RED3, "red_entry");
    SAVE_ENTRY (INI_GREEN1, "g0");
    SAVE_ENTRY (INI_GREEN2, "g1");
    SAVE_ENTRY (INI_GREEN3, "green_entry");
    SAVE_ENTRY (INI_BLU1, "b0");
    SAVE_ENTRY (INI_BLU2, "b1");
    SAVE_ENTRY (INI_BLU3, "blue_entry");
    SAVE_ENTRY (INI_PLASMA_SPEED, "speed_entry");
    break;

  case DLG_ROTATE:
    SAVE_ENTRY (INI_IMAGE_FILE, "image");
    SAVE_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_ROT_RES, "resolution_entry");

    SAVE_CHECK (INI_TILE_IMAGE, "tile");	

    SAVE_ENTRY (INI_DISTVALUE, "distortion");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);

    SAVE_ENTRY (INI_ROTMODE, "mode_entry");
    SAVE_ENTRY (INI_RSPEED, "rot_entry");
    SAVE_ENTRY (INI_ZMIN, "zoom_min");
    SAVE_ENTRY (INI_ZMAX, "zoom_max");
    SAVE_ENTRY (INI_ZSPEED, "zoom_speed");
    SAVE_ENTRY (INI_MODIX, "x_entry");
    SAVE_ENTRY (INI_MODIY, "y_entry");
    SAVE_ENTRY (INI_AUTO1, "first");
    SAVE_ENTRY (INI_AUTO2, "second");
    break;

  case DLG_TMAPCUBE:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");

    widget = lookup_widget (main_dlg, "image_list");
    for (index = 0; index < 6; index++)
    {
      char* ptr;
      sprintf (section, "%s%d", INI_IMAGE_, index+1);

      if (index < GTK_CLIST (widget)->rows)
      {
	gtk_clist_get_text (GTK_CLIST (widget), index, 0, &ptr);
	SaveVar(ini_section, section, ptr);
      }
      else
	SaveVar(ini_section, section, "");
    }

    SAVE_ENTRY (INI_ROTX, "x");
    SAVE_ENTRY (INI_ROTY, "y");
    SAVE_ENTRY (INI_ROTZ, "z");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);

    SAVE_CHECK (INI_LIGHTSOURCE, "lightsource");	

    SAVE_ENTRY (INI_LIGHT_INT, "intensity");
    SAVE_ENTRY (INI_LIGHT_MAX, "light_min");
    SAVE_ENTRY (INI_LIGHT_MIN, "light_max");

    SAVE_CHECK (INI_INTERACTIVE_MODE, "interactive");
    SAVE_CHECK (INI_CLEAR_BACKGROUND, "clear");	

    SAVE_ENTRY (INI_BACK_IMAGE_PATH, "image");
    break;

  case DLG_TUNNEL:
    SAVE_ENTRY (INI_IMAGE_FILE, "image");
    SAVE_ENTRY (INI_IMG_WIDTH, "image_width");
    SAVE_ENTRY (INI_IMG_HEIGHT, "image_height");
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_TUNNEL_RES, "resolution_entry");
    SAVE_ENTRY (INI_MOVEMENT, "move_entry");
    SAVE_ENTRY (INI_EFFECT, "effect_entry");
    SAVE_ENTRY (INI_CONEX, "x");
    SAVE_ENTRY (INI_CONEY, "y");
    SAVE_ENTRY (INI_CONEZ, "z");
    SAVE_ENTRY (INI_XSTART, "startx");
    SAVE_ENTRY (INI_YSTART, "starty");
    break;

  case DLG_TUNNEL3D:
    SAVE_ENTRY (INI_IMAGE_FILE, "image");
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_TUNNEL_RES, "resolution_entry");
    SAVE_ENTRY (INI_RADIUS, "radius");
    SAVE_ENTRY (INI_ROTATION, "rotation");
    SAVE_ENTRY (INI_ADVANCING, "advancing");
    SAVE_ENTRY (INI_LMIN, "light_min");
    SAVE_ENTRY (INI_LMAX, "light_max");
    SAVE_ENTRY (INI_LDEC, "light_dec");

    SAVE_CHECK (INI_BENDS, "bends");

    SAVE_ENTRY (INI_NBENDS, "bends_num");
    SAVE_ENTRY (INI_SBMIN, "bends_min");
    SAVE_ENTRY (INI_SBMAX, "bends_max");
    SAVE_ENTRY (INI_BOFFSET, "bends_offset");
    SAVE_ENTRY (INI_BOFFSETINC, "bends_offset_inc");
    SAVE_ENTRY (INI_BSIZEINC, "bends_size_inc");
    SAVE_ENTRY (INI_ROTX, "x");
    SAVE_ENTRY (INI_ROTY, "y");
    SAVE_ENTRY (INI_ROTZ, "z");

    SAVE_CHECK (INI_REVERSE, "reverse");
    SAVE_CHECK (INI_SHADING, "shading");
    SAVE_CHECK (INI_SQUARE, "square");
    SAVE_CHECK (INI_INTERACTIVE, "interactive");
    break;

  case DLG_VOXEL:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");
    SAVE_ENTRY (INI_NUMPAL, "palette_entry");
    SAVE_ENTRY (INI_SHADOW, "shadow");
    SAVE_ENTRY (INI_ROUGHNESS, "roughness");
    SAVE_ENTRY (INI_IMAGE_FILE, "image");
    SAVE_ENTRY (INI_HORIZON, "horizon");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);
    break;

  case DLG_WARP:
    SAVE_ENTRY (INI_IMAGE_FILE, "image");
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");
    SAVE_ENTRY (INI_WARP_MODE, "mode_entry");
    SAVE_ENTRY (INI_WSTART1, "spiral_start");
    SAVE_ENTRY (INI_WADD1, "spiral_add");
    SAVE_ENTRY (INI_WMIN1, "spiral_min");
    SAVE_ENTRY (INI_WMAX1, "spiral_max"); 
    SAVE_ENTRY (INI_WSTART2, "breath_start");
    SAVE_ENTRY (INI_WADD2, "breath_add");
    SAVE_ENTRY (INI_WMIN2, "breath_min");
    SAVE_ENTRY (INI_WMAX2, "breath_max");
    break;

  case DLG_ANWATER:
    SAVE_ENTRY (INI_IMAGE_FILE, "image");
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");

    SAVE_CHECK (INI_CHK_AUTODESIGN, "autodesign");

    SAVE_ENTRY (INI_FLUID_DENSITY, "fluid_entry");
    SAVE_ENTRY (INI_RSIZE, "rsize");
    SAVE_ENTRY (INI_RFACTOR, "rfactor");
    SAVE_ENTRY (INI_SRSIZE, "ssize");
    SAVE_ENTRY (INI_SRFACTOR, "sfactor");

    SAVE_CHECK (INI_FIXDROPVALUE, "fix_drops");

    SAVE_ENTRY (INI_FIXDROPX, "fix_x");
    SAVE_ENTRY (INI_FIXDROPY, "fix_y");
    SAVE_ENTRY (INI_FIXDROPS, "fix_size");
    SAVE_ENTRY (INI_FIXDROPF, "fix_factor");
    SAVE_ENTRY (INI_NFISH, "fish_entry");

    SAVE_CHECK (INI_CROSS, "cross");

    SAVE_ENTRY (INI_CROSS_FACTOR, "factor");

    SAVE_CHECK (INI_ANWATER_LIGHT, "light");

    SAVE_ENTRY (INI_LIGHT_MIN, "min");
    SAVE_ENTRY (INI_LIGHT_MAX, "max");
    SAVE_ENTRY (INI_PRESSURE, "pressure");
    SAVE_ENTRY (INI_FLUIDMODE, "fluid_mode_entry");

    SAVE_CHECK (INI_INTERACTIVE_MODE, "interactive");
    break;

  case DLG_WORMHOLE:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_XHOLESPEED, "x_entry");
    SAVE_ENTRY (INI_YHOLESPEED, "y_entry");
    SAVE_ENTRY (INI_DOT, "dot");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);

    SAVE_CHECK (INI_NEGATIVE, "negative");
    break;

  case DLG_GALAXY:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_PARTICLES, "particles_entry");

    if (IS_CHECKED ("random"))
      SaveVar(ini_section, INI_RANDOM, "1");
    else
      SaveVar(ini_section, INI_RANDOM, "0");

    SAVE_ENTRY (INI_SCRIPT, "script_entry");
    SAVE_ENTRY (INI_GPALETTE, "palette_entry");
    SAVE_ENTRY (INI_PERSIST, "light");
    SAVE_ENTRY (INI_DINPERSIST, "dynamic");
    SAVE_ENTRY (INI_DINPERSISTMIN, "min");
    SAVE_ENTRY (INI_DINPERSISTMAX, "max");
    break;

  case DLG_BOOKFLIP:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");

    widget = lookup_widget (main_dlg, "image_list");
    items = GTK_CLIST (widget)->rows;
    for(index = 0; index < items; index++)
    {
      info = gtk_clist_get_row_data (GTK_CLIST (widget), index);

      sprintf (section, "%s%d", INI_IMAGE_, index+1);
      SaveVar(ini_section, section, info->image);
      sprintf (section, "%s%d", INI_LINK_, index+1);
      SaveVar(ini_section, section, info->link);
      sprintf (section, "%s%d", INI_STATUS_MSG_, index+1);
      SaveVar(ini_section, section, info->status);
      sprintf (section, "%s%d", INI_FLIP_, index+1);
      SaveVar(ini_section, section, info->flip);
    }

    sprintf (section, "%s%d", INI_IMAGE_, index+1);
    SaveVar(ini_section, section, "");

    SAVE_ENTRY (INI_FRAME_SPEED, "frame_speed");
    SAVE_ENTRY (INI_PAUSE, "pause");
    SAVE_ENTRY (INI_EXTRAH, "extra_height");
    SAVE_ENTRY (INI_FLIPCURVE, "flip_entry");
    SAVE_ENTRY (INI_SHADING_BF, "shading_entry");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);
    break;

  case DLG_MOSAIC:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");

    widget = lookup_widget (main_dlg, "image_list");
    items = GTK_CLIST (widget)->rows;
    for(index = 0; index < items; index++)
    {
      info = gtk_clist_get_row_data (GTK_CLIST (widget), index);

      sprintf (section, "%s%d", INI_IMAGE_, index+1);
      SaveVar(ini_section, section, info->image);
      sprintf (section, "%s%d", INI_LINK_, index+1);
      SaveVar(ini_section, section, info->link);
      sprintf (section, "%s%d", INI_STATUS_MSG_, index+1);
      SaveVar(ini_section, section, info->status);
    }

    sprintf (section, "%s%d", INI_IMAGE_, index+1);
    SaveVar(ini_section, section, "");

    SAVE_ENTRY (INI_TILESWIDTH, "tile_width");
    SAVE_ENTRY (INI_TILESHEIGHT, "tile_height");
    SAVE_ENTRY (INI_TILESSTEPS, "tile_steps");
    SAVE_ENTRY (INI_PAUSE, "pause");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);

    SAVE_CHECK_ENTRY (INI_BACK_IMAGE_PATH, "back_image_check", "back_image");
    break;

  case DLG_ANFY3D:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_REALWIDTH, "real_w");
    SAVE_ENTRY (INI_REALHEIGTH, "real_h");
    SAVE_ENTRY (INI_TEXTURE0, "t0_entry");
    SAVE_ENTRY (INI_TEXTURE1, "t1_entry");
    SAVE_ENTRY (INI_TEXTURE2, "t2_entry");
    SAVE_ENTRY (INI_PHONGMAP, "p_entry");
    SAVE_ENTRY (INI_GPHONGMAP, "g_entry");
    SAVE_CHECK (INI_INTERACTIVE_MODE, "interactive");

    if (IS_CHECKED ("fog"))
      SaveVar(ini_section, INI_FOG, "1");
    else
      SaveVar(ini_section, INI_FOG, "0");

    SAVE_ENTRY (INI_FOGNEAR, "start");
    SAVE_ENTRY (INI_FOGFAR, "stop");
    SAVE_ENTRY (INI_BACKMODE, "back_entry");
			
    if (IS_CHECKED ("blur"))
      SaveVar(ini_section, INI_BLUR, "1");
    else
      SaveVar(ini_section, INI_BLUR, "0");

    SAVE_ENTRY (INI_BACK_RENDER, "render_entry");
    SAVE_ENTRY (INI_BACKTEXTURE, "bt_entry");
    SAVE_ENTRY (INI_SCRIPT, "script_entry");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);
    break;

  case DLG_ANFY3D_0:
    SAVE_ENTRY (INI_MAINRENDER, "main_render_entry");
    SAVE_ENTRY (INI_MAINTEXTURE, "main_tex_entry");
    SAVE_ENTRY (INI_CHILDRENDER, "child_render_entry");
    SAVE_ENTRY (INI_CHILDTEXTURE, "child_tex_entry");
    SAVE_CHECK (INI_AIMLIGHT, "animlight");

    GetSavedVar(ini_section, INI_SCRIPT, strtmp);
    if (strcmp (strtmp, "Objects") == 0)
    {
      SAVE_ENTRY (INI_MAINTYPE, "main_type_entry");
      SAVE_ENTRY (INI_CHILDTYPE, "child_type_entry");
      SAVE_ENTRY (INI_ROTX, "x");
      SAVE_ENTRY (INI_ROTY, "y");
      SAVE_ENTRY (INI_ROTZ, "z");
      SAVE_ENTRY (INI_SHEET_HEIGHT, "height");
      SAVE_ENTRY (INI_SHEET_WIDTH, "width");
      SAVE_ENTRY (INI_SHEET_NUMX, "width_faces");
      SAVE_ENTRY (INI_SHEET_NUMY, "height_faces");
      SAVE_ENTRY (INI_SHEET_ADD, "add");
      SAVE_ENTRY (INI_SHEET_H, "ampl");
      SAVE_ENTRY (INI_SHEET_PERIOD1, "p1");
      SAVE_ENTRY (INI_SHEET_PERIOD2, "p2");
      SAVE_ENTRY (INI_SHEET_FUNCTION, "func_entry");
      SAVE_ENTRY (INI_SHADOW, "shadow_entry");

      if (IS_CHECKED ("mirror"))
	SaveVar(ini_section, INI_MIRROR, "0");
      else
	SaveVar(ini_section, INI_MIRROR, "1");

      SAVE_ENTRY (INI_LIGHTBALLS, "light_entry");
    }
    break;

  case DLG_TSCROLLER:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");

    SAVE_INT (INI_BACK_COLOR_R, dlg_backcolor_red);
    SAVE_INT (INI_BACK_COLOR_G, dlg_backcolor_green);
    SAVE_INT (INI_BACK_COLOR_B, dlg_backcolor_blue);

    SAVE_CHECK_ENTRY (INI_BACK_IMAGE_PATH, "back_image_check", "back_image");

    dlg_showtextstyle=TRUE;
    SaveVar(ini_section, INI_TEXTSCROLL, GetScrollTextFile(current_applet));
    break;

  case DLG_CONF_MENU:
    widget = lookup_widget (main_dlg, "tree");

    if (current_applet == APPLET_TREEMENU)
    {
      /*
	m_iIndex = 0;
	UINT idMenu=0;
	SaveTreeMenu(ptc, ptc->GetRootItem(), &idMenu, 0);
	m_aiIconFlag.RemoveAll();
      */
    }
    else
    {
      char link='0';
      SaveTreeCtrl(GTK_CTREE (widget), gtk_ctree_node_nth (GTK_CTREE (widget), 0), '0', '0', &link, '0');
    }

    SAVE_CHECK (INI_AUTOAPPLY, "auto_apply");	
  break;

  case DLG_CONF_MENU_2:
    SAVE_CHECK (INI_FLOATINFRONT, "top");
    SAVE_ENTRY (INI_FLOAT_TITLE, "title");
    SAVE_ENTRY (INI_FLOAT_X, "x");
    SAVE_ENTRY (INI_FLOAT_Y, "y");
    break;

  case DLG_WOBBLER:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");
    SAVE_ENTRY (INI_IMAGE, "image");
    SAVE_ENTRY (INI_INITDISTANCE, "dist_initial");
    SAVE_ENTRY (INI_ZOOMSPEED, "zoom");
    SAVE_ENTRY (INI_MINDISTANCE, "dist_min");
    SAVE_ENTRY (INI_MAXDISTANCE, "dist_max");
    SAVE_ENTRY (INI_WRADIUS, "radius");
    SAVE_ENTRY (INI_WSTRENGTH, "wave");
    SAVE_ENTRY (INI_SPD1, "speed1");
    SAVE_ENTRY (INI_SPD2, "speed2");
    SAVE_ENTRY (INI_SPD3, "speed3");
    SAVE_ENTRY (INI_SPD4, "speed4");
    SAVE_ENTRY (INI_XMOVE, "movex");
    SAVE_ENTRY (INI_YMOVE, "movey");
    SAVE_ENTRY (INI_VAR_START, "start");
    SAVE_ENTRY (INI_VAR_MOVE, "move");
    SAVE_ENTRY (INI_PRECISION, "precision_entry");
    break;

  case DLG_WHEEL:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_FILTER, "filter_entry");
    SAVE_ENTRY (INI_FONT, "font_entry");
    SAVE_ENTRY (INI_BACK_TYPE, "mode_entry");

    SAVE_CHECK (INI_FLAT, "flat");

    if (IS_CHECKED ("gouraud"))
      SaveVar(ini_section, INI_MODE, "gouraud");
    else
      SaveVar(ini_section, INI_MODE, "texture");

    SAVE_ENTRY (INI_STATUSBARY, "statusbar");
    SAVE_ENTRY (INI_OFFSETSTEP, "submenu");
    SAVE_ENTRY (INI_MOUSESENS, "up");
    SAVE_ENTRY (INI_YROTATION, "left");
    SAVE_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    SAVE_ENTRY (INI_TEXTURE_FILE, "texture_entry");
    SAVE_ENTRY (INI_EXTRUDE_DIFF, "extrude");
    SAVE_ENTRY (INI_TEXTDIFF, "text");

    SAVE_UL (INI_BK_COLOR, dlg_ul_backcolor);
    SAVE_UL (INI_WHEEL_COLOR, dlg_ul_wheelcolor);
    SAVE_UL (INI_TEXT_COLOR, dlg_ul_textcolor);
    SAVE_UL (INI_SEL_COLOR, dlg_ul_selectcolor);
    break;

  case DLG_MORPHMENU:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_MENUFX, "menu_entry");
    SAVE_ENTRY (INI_STATUSBARY, "statusbar");
    SAVE_ENTRY (INI_MENUY, "menu_y");
    SAVE_ENTRY (INI_TEXT_FONT, "font_entry");
    SAVE_ENTRY (INI_TEXT_SIZE, "size_entry");
    SAVE_ENTRY (INI_ALIGN, "align_entry");

    SAVE_UL (INI_BK_COLOR, dlg_ul_backcolor);
    SAVE_UL (INI_TEXT_COLOR, dlg_ul_textcolor);
    SAVE_UL (INI_SEL_COLOR, dlg_ul_selectcolor);

    SAVE_ENTRY (INI_BACKFX, "fx_entry");

    strcpy (strtmp, gtk_entry_get_text (GTK_ENTRY (lookup_widget (main_dlg, "fx_entry"))));
    if (strcmp (strtmp, "color") == 0)
      dlg_plugin = -2;
    else if (strcmp (strtmp, "image") == 0)
      dlg_plugin = -1;
    else if (strcmp (strtmp, "mmgalaxy") == 0)
      dlg_plugin = 0;
    else
      dlg_plugin = 1;

    SAVE_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    //    SAVE_CHECK (INI_STANDARD_FONT, "standard");
    break;

  case DLG_MM_GALAXY:
    SAVE_UL (INI_SEED_COLOR, dlg_ul_seedcolor);

    SAVE_ENTRY (INI_BACK_CLR, "back_entry");
    SAVE_CHECK (INI_CHK_BACK_COLOR, "back");
    SAVE_CHECK (INI_SMOOTH_FILTER, "smooth");

    SAVE_INT (INI_FIRE_COLOR_R , dlg_firecolor_red);
    SAVE_INT (INI_FIRE_COLOR_G , dlg_firecolor_green);
    SAVE_INT (INI_FIRE_COLOR_B , dlg_firecolor_blue);

    SAVE_ENTRY (INI_SHAPE, "shape_entry");
    break;

  case DLG_MM_BLOBS:
    SAVE_ENTRY (INI_NBLOBS, "number_entry");
    SAVE_ENTRY (INI_BVAL1, "i");
    SAVE_ENTRY (INI_BVAL2, "j");
    SAVE_ENTRY (INI_BVAL3, "k");
    SAVE_ENTRY (INI_MINSPEED, "min_entry");
    SAVE_ENTRY (INI_COLORPAL, "color_entry");

    SAVE_CHECK (INI_SINEMODE, "sine");
    SAVE_CHECK (INI_STARSHAPE, "starshape");
    SAVE_CHECK (INI_NEGCOLOR, "negative");
    break;

  case DLG_TREEMENU:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_INGOING, "scroll_close");
    SAVE_ENTRY (INI_OUTGOING, "scroll_open");
    SAVE_ENTRY (INI_TEXT_FONT, "font_entry");
    SAVE_ENTRY (INI_TEXT_SIZE, "size_entry");
    SAVE_CHECK (INI_TEXT_ITALIC, "italic");
    SAVE_CHECK (INI_TEXT_BOLD, "bold");
    SAVE_CHECK (INI_AUTOHIGHLIGHT, "highlight");
    SAVE_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    SAVE_ENTRY (INI_SCROLLBAR_SIZE, "scroll_entry");
    SAVE_ENTRY (INI_BORDER_STYLE, "border_entry");

    SAVE_UL (INI_TEXT_COLOR, dlg_ul_textcolor);
    SAVE_UL (INI_BK_COLOR, dlg_ul_backcolor);
    SAVE_UL (INI_SEL_COLOR, dlg_ul_selectcolor);
    SAVE_UL (INI_SEL_BAKC_COLOR, dlg_ul_selbackcolor);
    SAVE_UL (INI_SCROLL_COLOR, dlg_ul_scrollcolor);
    SAVE_UL (INI_FILTER_COLOR, dlg_ul_filtercolor);

    SAVE_ENTRY (INI_INBOUNC, "close");
    SAVE_ENTRY (INI_OUTBOUNC, "open");
    SAVE_ENTRY (INI_BGRAVITY, "gravity");
    SAVE_ENTRY (INI_BAMPLITUDE, "amplitude");

    //    SAVE_CHECK (INI_STANDARD_FONT, "standard");
    break;

  case DLG_ANFYCAM:
    SAVE_ENTRY (INI_IMAGE_FILE, "image");
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_RES, "resolution_entry");
    SAVE_ENTRY (INI_INTERVAL, "interval");
    SAVE_ENTRY (INI_FADESPEED, "fade");

    SAVE_CHECK (INI_PROGRFADE, "progressive");
    break;

  case DLG_ANFYPAINT:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_JPGQUALITY, "jpeg");

    SAVE_CHECK (INI_SAVEBUTTON, "save");

    sprintf (strtmp, "%lx", (long unsigned int)dlg_ul_backcolor);
    SaveVar(ini_section, INI_BK_COLOR, strtmp);

    sprintf (strtmp, "%lx", (long unsigned int)dlg_ul_pencolor);
    SaveVar(ini_section, INI_PEN_COLOR, strtmp);

    SAVE_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    SAVE_ENTRY (INI_SENDTOMAIL, "mail");
    SAVE_ENTRY (INI_STARTMESSAGE, "start");
    SAVE_ENTRY (INI_NOJAVAMSG, "nojava");			
    break;

  case DLG_SOLIDSCROLLER:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_TEXT_TYPE, "type_entry");
    SAVE_ENTRY (INI_WAVEMODE, "wave_mode_entry");
    SAVE_ENTRY (INI_WAVESPEED, "wave_speed");
    SAVE_ENTRY (INI_WAVETYPE, "wave_type_entry");
    SAVE_CHECK (INI_REVERSEFX, "reverse");
    SAVE_ENTRY (INI_TEXTVSPACE, "v_spac");
    SAVE_ENTRY (INI_TEXTSPEED, "speed");
    SAVE_ENTRY (INI_TEXTOFFSET, "y_offset");
    SAVE_ENTRY (INI_TEXTJUMPAMP, "jump_amp");
    SAVE_ENTRY (INI_TEXTJUMPSPEED, "jump_speed");
    SAVE_ENTRY (INI_MIRRORMODE, "mirror_mode_entry");
    SAVE_ENTRY (INI_MIRRORHEIGTH, "mirror_height");

    sprintf (strtmp, "%lx", (long unsigned int)dlg_ul_backcolor);
    SaveVar(ini_section, INI_BK_COLOR, strtmp);
    break;

  case DLG_ANFYFONT:
    {
      char* txt;

      txt = gtk_editable_get_chars (GTK_EDITABLE (lookup_widget (main_dlg, "text")), 0, -1);

      if (strchr (txt, '\n') == NULL)
	strcat(txt, "\r\n");
      ReadWriteFileScrollText(current_applet, txt, 1); //write

      txt = GetScrollTextFile(current_applet);
      SaveVar(ini_section, INI_TEXTSCROLL, txt);
    }

    SAVE_ENTRY (INI_FONTINDEX, "font");
    break;

  case DLG_ANFYSNOW:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    SAVE_ENTRY (INI_F1_NUMFAR, "far");
    SAVE_ENTRY (INI_F2_NUMMIDDLE, "middle");
    SAVE_ENTRY (INI_F3_NUMNEAR, "near");
    SAVE_ENTRY (INI_F4_NUMFORROUND, "fore");
    SAVE_ENTRY (INI_WIND_MAX_SPEED, "speed_entry");
    SAVE_ENTRY (INI_WIND_VAR, "var_entry");
    SAVE_ENTRY (INI_SNOW_SPEED, "drop_speed");

    sprintf (strtmp, "%lx", (long unsigned int)dlg_ul_backcolor);
    SaveVar(ini_section, INI_BK_COLOR, strtmp);

    SAVE_CHECK (INI_SNOWOVER, "snow_over");
    break;

  case DLG_FIREWORKS:
    SAVE_ENTRY (INI_WIDTH, "width");
    SAVE_ENTRY (INI_HEIGHT, "height");
    SAVE_ENTRY (INI_BACK_IMAGE_PATH, "back_image");
    SAVE_ENTRY (INI_AUDIOFILE, "audio");
    SAVE_ENTRY (INI_FW_MAX, "max");
    SAVE_ENTRY (INI_FW_POWER, "power");
    SAVE_ENTRY (INI_FW_DENSITY, "density");
    SAVE_ENTRY (INI_FW_TIMEDURATION, "duration");
    SAVE_ENTRY (INI_GRAVITY, "gravity");

    sprintf (strtmp, "%lx", (long unsigned int)dlg_ul_backcolor);
    SaveVar(ini_section, INI_BK_COLOR, strtmp);

    SAVE_CHECK (INI_SHOWOVERTEXT, "over_text");
    break;
  }

  widget = valid_widget (main_dlg, "textscroll");
  if (widget != NULL)
  {
    if (IS_CHECKED ("textscroll"))
      SaveVar (ini_section, INI_TEXTSCROLL, GetScrollTextFile(current_applet));
    else
      SaveVar (ini_section, INI_TEXTSCROLL, INI_NO);
  }

  widget = valid_widget (main_dlg, "float_mode");
  if (widget != NULL)
    SAVE_CHECK (INI_FLOATMODE, "float_mode");

  widget = valid_widget (main_dlg, "charset_entry");
  if (widget != NULL)
        SAVE_ENTRY (INI_CHARSET, "charset_entry");
}
