//
// Category 
//
// 
//

#include <gtk/gtk.h>
#include "callback.h"
#include "support.h"
#include "dialogs.h"
#include "main.h"

GtkWidget* create_anfycam ()
{
  GtkWidget *anfycam;
  GtkWidget *vbox175;
  GtkWidget *hbox276;
  GtkWidget *table105;
  GtkWidget *image_browse;
  GtkWidget *image;
  GtkWidget *label468;
  GtkWidget *label469;
  GtkWidget *label470;
  GtkWidget *fade;
  GtkWidget *interval;
  GtkWidget *progressive;
  GtkWidget *frame113;
  GtkWidget *table104;
  GtkWidget *height;
  GtkWidget *width;
  GtkWidget *label460;
  GtkWidget *label461;
  GtkWidget *resolution_combo;
  GtkWidget *resolution_entry;
  GtkWidget *label462;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;

  anfycam = init_dialog (&accel_group, &tooltips, &vbox175);

  hbox276 = gtk_hbox_new (FALSE, 10);
  gtk_widget_set_name (hbox276, "hbox276");
  gtk_widget_ref (hbox276);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "hbox276", hbox276,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox276);
  gtk_box_pack_start (GTK_BOX (vbox175), hbox276, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox276), 5);

  table105 = gtk_table_new (3, 4, FALSE);
  gtk_widget_set_name (table105, "table105");
  gtk_widget_ref (table105);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "table105", table105,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table105);
  gtk_box_pack_start (GTK_BOX (hbox276), table105, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table105), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table105), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table105), 5);

  image_browse = gtk_button_new_with_label (_("..."));
  gtk_widget_set_name (image_browse, "image_browse");
  gtk_widget_ref (image_browse);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "image_browse", image_browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_browse);
  gtk_table_attach (GTK_TABLE (table105), image_browse, 3, 4, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (image_browse, 20, -2);
  gtk_tooltips_set_tip (tooltips, image_browse, _("Browse for file/path"), NULL);

  image = gtk_entry_new ();
  gtk_widget_set_name (image, "image");
  gtk_widget_ref (image);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "image", image,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image);
  gtk_table_attach (GTK_TABLE (table105), image, 1, 3, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, image, _("Filename of the picture to display"), NULL);

  label468 = gtk_label_new (_("Image file/URL"));
  gtk_widget_set_name (label468, "label468");
  gtk_widget_ref (label468);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "label468", label468,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label468);
  gtk_table_attach (GTK_TABLE (table105), label468, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label468), 0, 0.5);

  label469 = gtk_label_new (_("Interval"));
  gtk_widget_set_name (label469, "label469");
  gtk_widget_ref (label469);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "label469", label469,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label469);
  gtk_table_attach (GTK_TABLE (table105), label469, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label469), 0, 0.5);

  label470 = gtk_label_new (_("Fade speed"));
  gtk_widget_set_name (label470, "label470");
  gtk_widget_ref (label470);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "label470", label470,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label470);
  gtk_table_attach (GTK_TABLE (table105), label470, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label470), 0, 0.5);

  fade = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (fade, "fade");
  gtk_widget_ref (fade);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "fade", fade,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fade);
  gtk_table_attach (GTK_TABLE (table105), fade, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (fade, 50, -2);
  gtk_tooltips_set_tip (tooltips, fade, _("Speed of fades between frames (1 .. 255)"), NULL);

  interval = gtk_entry_new ();
  gtk_widget_set_name (interval, "interval");
  gtk_widget_ref (interval);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "interval", interval,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (interval);
  gtk_table_attach (GTK_TABLE (table105), interval, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (interval, 50, -2);
  gtk_tooltips_set_tip (tooltips, interval, _("Pause, in seconds, between the frames reloads."), NULL);

  progressive = gtk_check_button_new_with_label (_("Progressive fade"));
  gtk_widget_set_name (progressive, "progressive");
  gtk_widget_ref (progressive);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "progressive", progressive,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (progressive);
  gtk_table_attach (GTK_TABLE (table105), progressive, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  frame113 = gtk_frame_new (_("Size"));
  gtk_widget_set_name (frame113, "frame113");
  gtk_widget_ref (frame113);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "frame113", frame113,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame113);
  gtk_box_pack_start (GTK_BOX (hbox276), frame113, FALSE, TRUE, 0);

  table104 = gtk_table_new (3, 2, TRUE);
  gtk_widget_set_name (table104, "table104");
  gtk_widget_ref (table104);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "table104", table104,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table104);
  gtk_container_add (GTK_CONTAINER (frame113), table104);
  gtk_container_set_border_width (GTK_CONTAINER (table104), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table104), 5);

  height = gtk_entry_new ();
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table104), height, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);

  width = gtk_entry_new ();
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table104), width, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);

  label460 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label460, "label460");
  gtk_widget_ref (label460);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "label460", label460,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label460);
  gtk_table_attach (GTK_TABLE (table104), label460, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label460), 0, 0.5);

  label461 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label461, "label461");
  gtk_widget_ref (label461);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "label461", label461,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label461);
  gtk_table_attach (GTK_TABLE (table104), label461, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label461), 0, 0.5);

  resolution_combo = gtk_combo_new ();
  gtk_widget_set_name (resolution_combo, "resolution_combo");
  gtk_widget_ref (resolution_combo);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "resolution_combo", resolution_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_combo);
  gtk_table_attach (GTK_TABLE (table104), resolution_combo, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (resolution_combo, 50, -2);
  fill_combo (resolution_combo, 1, 8);

  resolution_entry = GTK_COMBO (resolution_combo)->entry;
  gtk_widget_set_name (resolution_entry, "resolution_entry");
  gtk_widget_ref (resolution_entry);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "resolution_entry", resolution_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_entry);
  gtk_tooltips_set_tip (tooltips, resolution_entry, _("Resolution of applet/image"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (resolution_entry), FALSE);

  label462 = gtk_label_new (_("Resolution"));
  gtk_widget_set_name (label462, "label462");
  gtk_widget_ref (label462);
  gtk_object_set_data_full (GTK_OBJECT (anfycam), "label462", label462,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label462);
  gtk_table_attach (GTK_TABLE (table104), label462, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label462), 0, 0.5);

  finish_dialog (anfycam, vbox175, accel_group);

  gtk_signal_connect (GTK_OBJECT (image_browse), "clicked",
                      GTK_SIGNAL_FUNC (OnBrowseFileImg), NULL);
  gtk_signal_connect (GTK_OBJECT (resolution_entry), "changed",
                      GTK_SIGNAL_FUNC (on_resolution_combo_changed), NULL);

  gtk_window_add_accel_group (GTK_WINDOW (anfycam), accel_group);
  gtk_object_set_data (GTK_OBJECT (anfycam), "tooltips", tooltips);

  return anfycam;
}

GtkWidget* create_anfypaint ()
{
  GtkWidget *anfypaint;
  GtkWidget *vbox180;
  GtkWidget *vbox181;
  GtkWidget *hbox281;
  GtkWidget *frame114;
  GtkWidget *table108;
  GtkWidget *height;
  GtkWidget *width;
  GtkWidget *label480;
  GtkWidget *label481;
  GtkWidget *vbox182;
  GtkWidget *hbox282;
  GtkWidget *label483;
  GtkWidget *jpeg;
  GtkWidget *save;
  GtkWidget *vbox183;
  GtkWidget *back_color;
  GtkWidget *pen_color;
  GtkWidget *vbox184;
  GtkWidget *table109;
  GtkWidget *mail;
  GtkWidget *hbox283;
  GtkWidget *back_image;
  GtkWidget *back_image_browse;
  GtkWidget *label484;
  GtkWidget *label485;
  GtkWidget *label486;
  GtkWidget *start;
  GtkWidget *label487;
  GtkWidget *nojava;
  GtkWidget *color_pixmap;
  GtkWidget *pen_pixmap;
  GtkWidget *hbox;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;

  anfypaint = init_dialog (&accel_group, &tooltips, &vbox180);

  vbox181 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox181, "vbox181");
  gtk_widget_ref (vbox181);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "vbox181", vbox181,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox181);
  gtk_box_pack_start (GTK_BOX (vbox180), vbox181, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox181), 5);

  hbox281 = gtk_hbox_new (FALSE, 10);
  gtk_widget_set_name (hbox281, "hbox281");
  gtk_widget_ref (hbox281);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "hbox281", hbox281,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox281);
  gtk_box_pack_start (GTK_BOX (vbox181), hbox281, TRUE, TRUE, 0);

  frame114 = gtk_frame_new (_("Size"));
  gtk_widget_set_name (frame114, "frame114");
  gtk_widget_ref (frame114);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "frame114", frame114,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame114);
  gtk_box_pack_start (GTK_BOX (hbox281), frame114, FALSE, TRUE, 0);

  table108 = gtk_table_new (2, 2, TRUE);
  gtk_widget_set_name (table108, "table108");
  gtk_widget_ref (table108);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "table108", table108,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table108);
  gtk_container_add (GTK_CONTAINER (frame114), table108);
  gtk_container_set_border_width (GTK_CONTAINER (table108), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table108), 5);

  height = gtk_entry_new ();
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table108), height, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);

  width = gtk_entry_new ();
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table108), width, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);

  label480 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label480, "label480");
  gtk_widget_ref (label480);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "label480", label480,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label480);
  gtk_table_attach (GTK_TABLE (table108), label480, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label480), 0, 0.5);

  label481 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label481, "label481");
  gtk_widget_ref (label481);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "label481", label481,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label481);
  gtk_table_attach (GTK_TABLE (table108), label481, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label481), 0, 0.5);

  vbox182 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox182, "vbox182");
  gtk_widget_ref (vbox182);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "vbox182", vbox182,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox182);
  gtk_box_pack_start (GTK_BOX (hbox281), vbox182, TRUE, FALSE, 0);

  hbox282 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox282, "hbox282");
  gtk_widget_ref (hbox282);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "hbox282", hbox282,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox282);
  gtk_box_pack_start (GTK_BOX (vbox182), hbox282, TRUE, TRUE, 0);

  label483 = gtk_label_new (_("Jpeg quality"));
  gtk_widget_set_name (label483, "label483");
  gtk_widget_ref (label483);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "label483", label483,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label483);
  gtk_box_pack_start (GTK_BOX (hbox282), label483, FALSE, FALSE, 0);

  jpeg = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (jpeg, "jpeg");
  gtk_widget_ref (jpeg);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "jpeg", jpeg,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (jpeg);
  gtk_box_pack_start (GTK_BOX (hbox282), jpeg, FALSE, TRUE, 0);
  gtk_widget_set_usize (jpeg, 80, -2);
  gtk_tooltips_set_tip (tooltips, jpeg, _("Jpeg saving quality (1 .. 100)"), NULL);

  save = gtk_check_button_new_with_label (_("Savebutton"));
  gtk_widget_set_name (save, "save");
  gtk_widget_ref (save);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "save", save,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save);
  gtk_box_pack_start (GTK_BOX (vbox182), save, TRUE, FALSE, 0);

  vbox183 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox183, "vbox183");
  gtk_widget_ref (vbox183);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "vbox183", vbox183,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox183);
  gtk_box_pack_start (GTK_BOX (hbox281), vbox183, FALSE, TRUE, 0);

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox183), hbox, FALSE, TRUE, 0);

  back_color = gtk_button_new_with_label (_("Back. color..."));
  gtk_widget_set_name (back_color, "back_color");
  gtk_widget_ref (back_color);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "back_color", back_color,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_color);
  gtk_box_pack_start (GTK_BOX (hbox), back_color, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, back_color, _("Background color"), NULL);

  color_pixmap = set_color_pixmap ((GtkWidget*)NULL, 0, 0, 0);
  gtk_widget_set_name (color_pixmap, "color_pixmap");
  gtk_widget_ref (color_pixmap);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "color_pixmap", color_pixmap,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (color_pixmap);
  gtk_box_pack_end (GTK_BOX (hbox), color_pixmap, FALSE, FALSE, 0);

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox183), hbox, FALSE, TRUE, 0);

  pen_color = gtk_button_new_with_label (_("Pen color..."));
  gtk_widget_set_name (pen_color, "pen_color");
  gtk_widget_ref (pen_color);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "pen_color", pen_color,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pen_color);
  gtk_box_pack_start (GTK_BOX (hbox), pen_color, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, pen_color, _("Change pen color"), NULL);

  pen_pixmap = set_color_pixmap ((GtkWidget*)NULL, 0, 0, 0);
  gtk_widget_set_name (pen_pixmap, "pen_pixmap");
  gtk_widget_ref (pen_pixmap);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "pen_pixmap", pen_pixmap,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pen_pixmap);
  gtk_box_pack_end (GTK_BOX (hbox), pen_pixmap, FALSE, FALSE, 0);

  vbox184 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox184, "vbox184");
  gtk_widget_ref (vbox184);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "vbox184", vbox184,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox184);
  gtk_box_pack_start (GTK_BOX (hbox281), vbox184, FALSE, TRUE, 0);

  table109 = gtk_table_new (2, 2, TRUE);
  gtk_widget_set_name (table109, "table109");
  gtk_widget_ref (table109);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "table109", table109,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table109);
  gtk_box_pack_start (GTK_BOX (vbox181), table109, TRUE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table109), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table109), 5);

  mail = gtk_entry_new ();
  gtk_widget_set_name (mail, "mail");
  gtk_widget_ref (mail);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "mail", mail,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mail);
  gtk_table_attach (GTK_TABLE (table109), mail, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, mail, _("E-mail address where save the image"), NULL);

  hbox283 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox283, "hbox283");
  gtk_widget_ref (hbox283);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "hbox283", hbox283,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox283);
  gtk_table_attach (GTK_TABLE (table109), hbox283, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  back_image = gtk_entry_new ();
  gtk_widget_set_name (back_image, "back_image");
  gtk_widget_ref (back_image);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "back_image", back_image,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_image);
  gtk_box_pack_start (GTK_BOX (hbox283), back_image, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, back_image, _("To make a coloring book"), NULL);

  back_image_browse = gtk_button_new_with_label (_("..."));
  gtk_widget_set_name (back_image_browse, "back_image_browse");
  gtk_widget_ref (back_image_browse);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "back_image_browse", back_image_browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_image_browse);
  gtk_box_pack_start (GTK_BOX (hbox283), back_image_browse, FALSE, FALSE, 0);
  gtk_widget_set_usize (back_image_browse, 20, -2);
  gtk_tooltips_set_tip (tooltips, back_image_browse, _("Browse for background image"), NULL);

  label484 = gtk_label_new (_("Send to mail (only when registered)"));
  gtk_widget_set_name (label484, "label484");
  gtk_widget_ref (label484);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "label484", label484,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label484);
  gtk_table_attach (GTK_TABLE (table109), label484, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label484), 0, 0.5);

  label485 = gtk_label_new (_("Optional background image"));
  gtk_widget_set_name (label485, "label485");
  gtk_widget_ref (label485);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "label485", label485,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label485);
  gtk_table_attach (GTK_TABLE (table109), label485, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label485), 0, 0.5);

  label486 = gtk_label_new (_("Start message"));
  gtk_widget_set_name (label486, "label486");
  gtk_widget_ref (label486);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "label486", label486,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label486);
  gtk_box_pack_start (GTK_BOX (vbox181), label486, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label486), 0, 0.5);

  start = gtk_entry_new ();
  gtk_widget_set_name (start, "start");
  gtk_widget_ref (start);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "start", start,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (start);
  gtk_box_pack_start (GTK_BOX (vbox181), start, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, start, _("Starting screen message"), NULL);

  label487 = gtk_label_new (_("Message for no Java(tm) browsers"));
  gtk_widget_set_name (label487, "label487");
  gtk_widget_ref (label487);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "label487", label487,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label487);
  gtk_box_pack_start (GTK_BOX (vbox181), label487, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (label487), 0, 0.5);

  nojava = gtk_entry_new ();
  gtk_widget_set_name (nojava, "nojava");
  gtk_widget_ref (nojava);
  gtk_object_set_data_full (GTK_OBJECT (anfypaint), "nojava", nojava,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (nojava);
  gtk_box_pack_start (GTK_BOX (vbox181), nojava, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, nojava, _("HTML fragment or message to display on browsers that doesn't support Java(tm)"), NULL);

  finish_dialog (anfypaint, vbox180, accel_group);

  gtk_signal_connect (GTK_OBJECT (back_color), "clicked",
                      GTK_SIGNAL_FUNC (on_back_color), NULL);
  gtk_signal_connect (GTK_OBJECT (pen_color), "clicked",
                      GTK_SIGNAL_FUNC (OnPenColor), NULL);
  gtk_signal_connect (GTK_OBJECT (back_image_browse), "clicked",
                      GTK_SIGNAL_FUNC (on_back_image_browse), NULL);

  gtk_window_add_accel_group (GTK_WINDOW (anfypaint), accel_group);
  gtk_object_set_data (GTK_OBJECT (anfypaint), "tooltips", tooltips);

  return anfypaint;
}

GtkWidget* create_blobs ()
{
  GtkWidget *blobs;
  GtkWidget *vbox185;
  GtkWidget *hbox285;
  GtkWidget *vbox191;
  GtkWidget *frame115;
  GtkWidget *table110;
  GtkWidget *height;
  GtkWidget *width;
  GtkWidget *label488;
  GtkWidget *label489;
  GtkWidget *textscroll;
  GtkWidget *vbox189;
  GtkWidget *frame116;
  GtkWidget *table111;
  GtkWidget *label497;
  GtkWidget *label498;
  GtkWidget *label499;
  GtkWidget *i;
  GtkWidget *j;
  GtkWidget *k;
  GtkWidget *number_combo;
  GtkWidget *number_entry;
  GtkWidget *label496;
  GtkWidget *label495;
  GtkWidget *vbox190;
  GtkWidget *frame117;
  GtkWidget *table112;
  GtkWidget *negative;
  GtkWidget *star;
  GtkWidget *sine;
  GtkWidget *resolution_combo;
  GtkWidget *resolution_entry;
  GtkWidget *min_combo;
  GtkWidget *min_entry;
  GtkWidget *color_combo;
  GtkWidget *color_entry;
  GtkWidget *label500;
  GtkWidget *label501;
  GtkWidget *label502;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;

  blobs = init_dialog (&accel_group, &tooltips, &vbox185);

  hbox285 = gtk_hbox_new (FALSE, 10);
  gtk_widget_set_name (hbox285, "hbox285");
  gtk_widget_ref (hbox285);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "hbox285", hbox285,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox285);
  gtk_box_pack_start (GTK_BOX (vbox185), hbox285, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox285), 5);

  vbox191 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox191, "vbox191");
  gtk_widget_ref (vbox191);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "vbox191", vbox191,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox191);
  gtk_box_pack_start (GTK_BOX (hbox285), vbox191, FALSE, TRUE, 0);

  frame115 = gtk_frame_new (_("Size"));
  gtk_widget_set_name (frame115, "frame115");
  gtk_widget_ref (frame115);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "frame115", frame115,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame115);
  gtk_box_pack_start (GTK_BOX (vbox191), frame115, FALSE, TRUE, 0);

  table110 = gtk_table_new (2, 2, TRUE);
  gtk_widget_set_name (table110, "table110");
  gtk_widget_ref (table110);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "table110", table110,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table110);
  gtk_container_add (GTK_CONTAINER (frame115), table110);
  gtk_container_set_border_width (GTK_CONTAINER (table110), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table110), 5);

  height = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table110), height, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);

  width = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table110), width, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);

  label488 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label488, "label488");
  gtk_widget_ref (label488);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "label488", label488,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label488);
  gtk_table_attach (GTK_TABLE (table110), label488, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label488), 0, 0.5);

  label489 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label489, "label489");
  gtk_widget_ref (label489);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "label489", label489,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label489);
  gtk_table_attach (GTK_TABLE (table110), label489, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label489), 0, 0.5);

  textscroll = gtk_check_button_new_with_label (_("Enable textscroll"));
  gtk_widget_set_name (textscroll, "textscroll");
  gtk_widget_ref (textscroll);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "textscroll", textscroll,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (textscroll);
  gtk_box_pack_start (GTK_BOX (vbox191), textscroll, FALSE, FALSE, 0);

  vbox189 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox189, "vbox189");
  gtk_widget_ref (vbox189);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "vbox189", vbox189,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox189);
  gtk_box_pack_start (GTK_BOX (hbox285), vbox189, TRUE, FALSE, 0);

  frame116 = gtk_frame_new (_("Blobs"));
  gtk_widget_set_name (frame116, "frame116");
  gtk_widget_ref (frame116);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "frame116", frame116,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame116);
  gtk_box_pack_start (GTK_BOX (vbox189), frame116, FALSE, TRUE, 0);

  table111 = gtk_table_new (4, 3, FALSE);
  gtk_widget_set_name (table111, "table111");
  gtk_widget_ref (table111);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "table111", table111,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table111);
  gtk_container_add (GTK_CONTAINER (frame116), table111);
  gtk_container_set_border_width (GTK_CONTAINER (table111), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table111), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table111), 5);

  label497 = gtk_label_new (_("I"));
  gtk_widget_set_name (label497, "label497");
  gtk_widget_ref (label497);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "label497", label497,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label497);
  gtk_table_attach (GTK_TABLE (table111), label497, 1, 2, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label498 = gtk_label_new (_("J"));
  gtk_widget_set_name (label498, "label498");
  gtk_widget_ref (label498);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "label498", label498,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label498);
  gtk_table_attach (GTK_TABLE (table111), label498, 1, 2, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label499 = gtk_label_new (_("K"));
  gtk_widget_set_name (label499, "label499");
  gtk_widget_ref (label499);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "label499", label499,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label499);
  gtk_table_attach (GTK_TABLE (table111), label499, 1, 2, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  i = gtk_entry_new_with_max_length (5);
  gtk_widget_set_name (i, "i");
  gtk_widget_ref (i);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "i", i,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (i);
  gtk_table_attach (GTK_TABLE (table111), i, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (i, 50, -2);
  gtk_tooltips_set_tip (tooltips, i, _("Intesity I (suggested: 210)"), NULL);

  j = gtk_entry_new_with_max_length (5);
  gtk_widget_set_name (j, "j");
  gtk_widget_ref (j);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "j", j,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (j);
  gtk_table_attach (GTK_TABLE (table111), j, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (j, 50, -2);
  gtk_tooltips_set_tip (tooltips, j, _("Intesity J (suggested: 35600)"), NULL);

  k = gtk_entry_new_with_max_length (5);
  gtk_widget_set_name (k, "k");
  gtk_widget_ref (k);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "k", k,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (k);
  gtk_table_attach (GTK_TABLE (table111), k, 2, 3, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (k, 50, -2);
  gtk_tooltips_set_tip (tooltips, k, _("Intesity K (suggested: 35600)"), NULL);

  number_combo = gtk_combo_new ();
  gtk_widget_set_name (number_combo, "number_combo");
  gtk_widget_ref (number_combo);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "number_combo", number_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (number_combo);
  gtk_table_attach (GTK_TABLE (table111), number_combo, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (number_combo, 50, -2);
  fill_combo (number_combo, 2, 8);

  number_entry = GTK_COMBO (number_combo)->entry;
  gtk_widget_set_name (number_entry, "number_entry");
  gtk_widget_ref (number_entry);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "number_entry", number_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (number_entry);
  gtk_tooltips_set_tip (tooltips, number_entry, _("Number of blobs"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (number_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (number_entry), _("2"));

  label496 = gtk_label_new (_("Intensity"));
  gtk_widget_set_name (label496, "label496");
  gtk_widget_ref (label496);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "label496", label496,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label496);
  gtk_table_attach (GTK_TABLE (table111), label496, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label496), 0, 0.5);

  label495 = gtk_label_new (_("Number"));
  gtk_widget_set_name (label495, "label495");
  gtk_widget_ref (label495);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "label495", label495,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label495);
  gtk_table_attach (GTK_TABLE (table111), label495, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label495), 0, 0.5);

  vbox190 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox190, "vbox190");
  gtk_widget_ref (vbox190);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "vbox190", vbox190,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox190);
  gtk_box_pack_start (GTK_BOX (hbox285), vbox190, FALSE, TRUE, 0);

  frame117 = gtk_frame_new (_("Render style"));
  gtk_widget_set_name (frame117, "frame117");
  gtk_widget_ref (frame117);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "frame117", frame117,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame117);
  gtk_box_pack_start (GTK_BOX (vbox190), frame117, FALSE, TRUE, 0);

  table112 = gtk_table_new (6, 2, FALSE);
  gtk_widget_set_name (table112, "table112");
  gtk_widget_ref (table112);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "table112", table112,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table112);
  gtk_container_add (GTK_CONTAINER (frame117), table112);
  gtk_container_set_border_width (GTK_CONTAINER (table112), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table112), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table112), 5);

  negative = gtk_check_button_new_with_label (_("Negative color"));
  gtk_widget_set_name (negative, "negative");
  gtk_widget_ref (negative);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "negative", negative,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (negative);
  gtk_table_attach (GTK_TABLE (table112), negative, 0, 2, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  star = gtk_check_button_new_with_label (_("Starshape"));
  gtk_widget_set_name (star, "star");
  gtk_widget_ref (star);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "star", star,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (star);
  gtk_table_attach (GTK_TABLE (table112), star, 0, 2, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  sine = gtk_check_button_new_with_label (_("Sine mode"));
  gtk_widget_set_name (sine, "sine");
  gtk_widget_ref (sine);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "sine", sine,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sine);
  gtk_table_attach (GTK_TABLE (table112), sine, 0, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  resolution_combo = gtk_combo_new ();
  gtk_widget_set_name (resolution_combo, "resolution_combo");
  gtk_widget_ref (resolution_combo);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "resolution_combo", resolution_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_combo);
  gtk_table_attach (GTK_TABLE (table112), resolution_combo, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (resolution_combo, 50, -2);
  fill_combo (resolution_combo, 1, 8);

  resolution_entry = GTK_COMBO (resolution_combo)->entry;
  gtk_widget_set_name (resolution_entry, "resolution_entry");
  gtk_widget_ref (resolution_entry);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "resolution_entry", resolution_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_entry);
  gtk_tooltips_set_tip (tooltips, resolution_entry, _("Resolution of applet/image"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (resolution_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (resolution_entry), _("1"));

  min_combo = gtk_combo_new ();
  gtk_widget_set_name (min_combo, "min_combo");
  gtk_widget_ref (min_combo);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "min_combo", min_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (min_combo);
  gtk_table_attach (GTK_TABLE (table112), min_combo, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (min_combo, 50, -2);
  fill_combo (min_combo, 1, 8);

  min_entry = GTK_COMBO (min_combo)->entry;
  gtk_widget_set_name (min_entry, "min_entry");
  gtk_widget_ref (min_entry);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "min_entry", min_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (min_entry);
  gtk_tooltips_set_tip (tooltips, min_entry, _("Minimum speed (1 .. 15)"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (min_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (min_entry), _("1"));

  color_combo = gtk_combo_new ();
  gtk_widget_set_name (color_combo, "color_combo");
  gtk_widget_ref (color_combo);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "color_combo", color_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (color_combo);
  gtk_table_attach (GTK_TABLE (table112), color_combo, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (color_combo, 50, -2);
  fill_combo (color_combo, 1, 6);

  color_entry = GTK_COMBO (color_combo)->entry;
  gtk_widget_set_name (color_entry, "color_entry");
  gtk_widget_ref (color_entry);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "color_entry", color_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (color_entry);
  gtk_tooltips_set_tip (tooltips, color_entry, _("Number of color palette"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (color_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (color_entry), _("1"));

  label500 = gtk_label_new (_("Resolution"));
  gtk_widget_set_name (label500, "label500");
  gtk_widget_ref (label500);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "label500", label500,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label500);
  gtk_table_attach (GTK_TABLE (table112), label500, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label500), 0, 0.5);

  label501 = gtk_label_new (_("Min. speed"));
  gtk_widget_set_name (label501, "label501");
  gtk_widget_ref (label501);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "label501", label501,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label501);
  gtk_table_attach (GTK_TABLE (table112), label501, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label501), 0, 0.5);

  label502 = gtk_label_new (_("Color palette"));
  gtk_widget_set_name (label502, "label502");
  gtk_widget_ref (label502);
  gtk_object_set_data_full (GTK_OBJECT (blobs), "label502", label502,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label502);
  gtk_table_attach (GTK_TABLE (table112), label502, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label502), 0, 0.5);

  finish_dialog (blobs, vbox185, accel_group);

  gtk_signal_connect (GTK_OBJECT (textscroll), "toggled",
                      GTK_SIGNAL_FUNC (on_textscroll), NULL);

  gtk_window_add_accel_group (GTK_WINDOW (blobs), accel_group);
  gtk_object_set_data (GTK_OBJECT (blobs), "tooltips", tooltips);

  return blobs;
}

GtkWidget* create_blur ()
{
  GtkWidget *blur;
  GtkWidget *vbox192;
  GtkWidget *vbox195;
  GtkWidget *hbox291;
  GtkWidget *label516;
  GtkWidget *frames;
  guint frames_browse_key;
  GtkWidget *frames_browse;
  GtkWidget *hbox292;
  GtkWidget *frame122;
  GtkWidget *vbox196;
  GSList *vbox196_group = NULL;
  GtkWidget *ping_pong;
  GtkWidget *cyclic;
  GtkWidget *table117;
  GtkWidget *image_type;
  GtkWidget *play;
  GtkWidget *num;
  GtkWidget *label519;
  GtkWidget *label518;
  GtkWidget *label517;
  GtkWidget *frame123;
  GtkWidget *table118;
  GtkWidget *width;
  GtkWidget *height;
  GtkWidget *label520;
  GtkWidget *label521;
  GtkWidget *double_size;
  GtkWidget *frame120;
  GtkWidget *table115;
  guint pong_browse_key;
  GtkWidget *pong_browse;
  GtkWidget *pong_audio;
  GtkWidget *hbox293;
  GtkWidget *pong_pause;
  GtkWidget *label512;
  GtkWidget *label510;
  GtkWidget *label511;
  GtkWidget *frame121;
  GtkWidget *table116;
  guint ping_browse_key;
  GtkWidget *ping_browse;
  GtkWidget *ping_audio;
  GtkWidget *hbox294;
  GtkWidget *ping_pause;
  GtkWidget *label513;
  GtkWidget *label514;
  GtkWidget *label515;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  blur = init_dialog (&accel_group, &tooltips, &vbox192);

  vbox195 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox195, "vbox195");
  gtk_widget_ref (vbox195);
  gtk_object_set_data_full (GTK_OBJECT (blur), "vbox195", vbox195,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox195);
  gtk_box_pack_start (GTK_BOX (vbox192), vbox195, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox195), 5);

  hbox291 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox291, "hbox291");
  gtk_widget_ref (hbox291);
  gtk_object_set_data_full (GTK_OBJECT (blur), "hbox291", hbox291,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox291);
  gtk_box_pack_start (GTK_BOX (vbox195), hbox291, TRUE, TRUE, 0);

  label516 = gtk_label_new (_("Frames"));
  gtk_widget_set_name (label516, "label516");
  gtk_widget_ref (label516);
  gtk_object_set_data_full (GTK_OBJECT (blur), "label516", label516,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label516);
  gtk_box_pack_start (GTK_BOX (hbox291), label516, FALSE, FALSE, 0);

  frames = gtk_entry_new ();
  gtk_widget_set_name (frames, "frames");
  gtk_widget_ref (frames);
  gtk_object_set_data_full (GTK_OBJECT (blur), "frames", frames,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frames);
  gtk_box_pack_start (GTK_BOX (hbox291), frames, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, frames, _("Image files relative path"), NULL);

  frames_browse = gtk_button_new_with_label ("");
  frames_browse_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (frames_browse)->child),
                                   _("_Browse..."));
  gtk_widget_add_accelerator (frames_browse, "clicked", accel_group,
                              frames_browse_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (frames_browse, "frames_browse");
  gtk_widget_ref (frames_browse);
  gtk_object_set_data_full (GTK_OBJECT (blur), "frames_browse", frames_browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frames_browse);
  gtk_box_pack_start (GTK_BOX (hbox291), frames_browse, FALSE, FALSE, 0);
  gtk_widget_set_usize (frames_browse, 90, -2);
  gtk_tooltips_set_tip (tooltips, frames_browse, _("Browse for path"), NULL);

  hbox292 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox292, "hbox292");
  gtk_widget_ref (hbox292);
  gtk_object_set_data_full (GTK_OBJECT (blur), "hbox292", hbox292,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox292);
  gtk_box_pack_start (GTK_BOX (vbox195), hbox292, TRUE, TRUE, 0);

  frame122 = gtk_frame_new (_("Replay mode"));
  gtk_widget_set_name (frame122, "frame122");
  gtk_widget_ref (frame122);
  gtk_object_set_data_full (GTK_OBJECT (blur), "frame122", frame122,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame122);
  gtk_box_pack_start (GTK_BOX (hbox292), frame122, FALSE, TRUE, 0);

  vbox196 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox196, "vbox196");
  gtk_widget_ref (vbox196);
  gtk_object_set_data_full (GTK_OBJECT (blur), "vbox196", vbox196,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox196);
  gtk_container_add (GTK_CONTAINER (frame122), vbox196);
  gtk_container_set_border_width (GTK_CONTAINER (vbox196), 5);

  ping_pong = gtk_radio_button_new_with_label (vbox196_group, _("Ping pong"));
  vbox196_group = gtk_radio_button_group (GTK_RADIO_BUTTON (ping_pong));
  gtk_widget_set_name (ping_pong, "ping_pong");
  gtk_widget_ref (ping_pong);
  gtk_object_set_data_full (GTK_OBJECT (blur), "ping_pong", ping_pong,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ping_pong);
  gtk_box_pack_start (GTK_BOX (vbox196), ping_pong, TRUE, FALSE, 0);

  cyclic = gtk_radio_button_new_with_label (vbox196_group, _("Cyclic"));
  vbox196_group = gtk_radio_button_group (GTK_RADIO_BUTTON (cyclic));
  gtk_widget_set_name (cyclic, "cyclic");
  gtk_widget_ref (cyclic);
  gtk_object_set_data_full (GTK_OBJECT (blur), "cyclic", cyclic,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cyclic);
  gtk_box_pack_start (GTK_BOX (vbox196), cyclic, TRUE, FALSE, 0);

  table117 = gtk_table_new (3, 2, FALSE);
  gtk_widget_set_name (table117, "table117");
  gtk_widget_ref (table117);
  gtk_object_set_data_full (GTK_OBJECT (blur), "table117", table117,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table117);
  gtk_box_pack_start (GTK_BOX (hbox292), table117, TRUE, FALSE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table117), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table117), 5);

  image_type = gtk_entry_new ();
  gtk_widget_set_name (image_type, "image_type");
  gtk_widget_ref (image_type);
  gtk_object_set_data_full (GTK_OBJECT (blur), "image_type", image_type,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_type);
  gtk_table_attach (GTK_TABLE (table117), image_type, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (image_type, 50, -2);
  gtk_widget_set_sensitive (image_type, FALSE);
  gtk_entry_set_editable (GTK_ENTRY (image_type), FALSE);

  play = gtk_entry_new ();
  gtk_widget_set_name (play, "play");
  gtk_widget_ref (play);
  gtk_object_set_data_full (GTK_OBJECT (blur), "play", play,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (play);
  gtk_table_attach (GTK_TABLE (table117), play, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (play, 50, -2);
  gtk_tooltips_set_tip (tooltips, play, _("Play speed (milliseconds)"), NULL);

  num = gtk_entry_new ();
  gtk_widget_set_name (num, "num");
  gtk_widget_ref (num);
  gtk_object_set_data_full (GTK_OBJECT (blur), "num", num,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (num);
  gtk_table_attach (GTK_TABLE (table117), num, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (num, 50, -2);
  gtk_tooltips_set_tip (tooltips, num, _("Number of images"), NULL);

  label519 = gtk_label_new (_("Num. Frames"));
  gtk_widget_set_name (label519, "label519");
  gtk_widget_ref (label519);
  gtk_object_set_data_full (GTK_OBJECT (blur), "label519", label519,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label519);
  gtk_table_attach (GTK_TABLE (table117), label519, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label519), 0, 0.5);

  label518 = gtk_label_new (_("Play speed"));
  gtk_widget_set_name (label518, "label518");
  gtk_widget_ref (label518);
  gtk_object_set_data_full (GTK_OBJECT (blur), "label518", label518,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label518);
  gtk_table_attach (GTK_TABLE (table117), label518, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label518), 0, 0.5);

  label517 = gtk_label_new (_("Image type"));
  gtk_widget_set_name (label517, "label517");
  gtk_widget_ref (label517);
  gtk_object_set_data_full (GTK_OBJECT (blur), "label517", label517,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label517);
  gtk_table_attach (GTK_TABLE (table117), label517, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label517), 0, 0.5);

  frame123 = gtk_frame_new (_("Double size"));
  gtk_widget_set_name (frame123, "frame123");
  gtk_widget_ref (frame123);
  gtk_object_set_data_full (GTK_OBJECT (blur), "frame123", frame123,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame123);
  gtk_box_pack_start (GTK_BOX (hbox292), frame123, FALSE, TRUE, 0);

  table118 = gtk_table_new (3, 2, FALSE);
  gtk_widget_set_name (table118, "table118");
  gtk_widget_ref (table118);
  gtk_object_set_data_full (GTK_OBJECT (blur), "table118", table118,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table118);
  gtk_container_add (GTK_CONTAINER (frame123), table118);
  gtk_container_set_border_width (GTK_CONTAINER (table118), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table118), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table118), 5);

  width = gtk_entry_new ();
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (blur), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table118), width, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_widget_set_sensitive (width, FALSE);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (width), FALSE);

  height = gtk_entry_new ();
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (blur), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table118), height, 1, 2, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_widget_set_sensitive (height, FALSE);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (height), FALSE);

  label520 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label520, "label520");
  gtk_widget_ref (label520);
  gtk_object_set_data_full (GTK_OBJECT (blur), "label520", label520,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label520);
  gtk_table_attach (GTK_TABLE (table118), label520, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label520), 0, 0.5);

  label521 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label521, "label521");
  gtk_widget_ref (label521);
  gtk_object_set_data_full (GTK_OBJECT (blur), "label521", label521,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label521);
  gtk_table_attach (GTK_TABLE (table118), label521, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label521), 0, 0.5);

  double_size = gtk_check_button_new_with_label (_("Enable"));
  gtk_widget_set_name (double_size, "double_size");
  gtk_widget_ref (double_size);
  gtk_object_set_data_full (GTK_OBJECT (blur), "double_size", double_size,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (double_size);
  gtk_table_attach (GTK_TABLE (table118), double_size, 0, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  frame120 = gtk_frame_new (_("Pong"));
  gtk_widget_set_name (frame120, "frame120");
  gtk_widget_ref (frame120);
  gtk_object_set_data_full (GTK_OBJECT (blur), "frame120", frame120,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame120);
  gtk_box_pack_start (GTK_BOX (vbox195), frame120, TRUE, TRUE, 0);

  table115 = gtk_table_new (2, 3, FALSE);
  gtk_widget_set_name (table115, "table115");
  gtk_widget_ref (table115);
  gtk_object_set_data_full (GTK_OBJECT (blur), "table115", table115,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table115);
  gtk_container_add (GTK_CONTAINER (frame120), table115);
  gtk_container_set_border_width (GTK_CONTAINER (table115), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table115), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table115), 5);

  pong_browse = gtk_button_new_with_label ("");
  pong_browse_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (pong_browse)->child),
                                   _("Br_owse..."));
  gtk_widget_add_accelerator (pong_browse, "clicked", accel_group,
                              pong_browse_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (pong_browse, "pong_browse");
  gtk_widget_ref (pong_browse);
  gtk_object_set_data_full (GTK_OBJECT (blur), "pong_browse", pong_browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pong_browse);
  gtk_table_attach (GTK_TABLE (table115), pong_browse, 2, 3, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (pong_browse, 90, -2);
  gtk_tooltips_set_tip (tooltips, pong_browse, _("Browse for file"), NULL);

  pong_audio = gtk_entry_new ();
  gtk_widget_set_name (pong_audio, "pong_audio");
  gtk_widget_ref (pong_audio);
  gtk_object_set_data_full (GTK_OBJECT (blur), "pong_audio", pong_audio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pong_audio);
  gtk_table_attach (GTK_TABLE (table115), pong_audio, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, pong_audio, _("Sound file for effect during last frame"), NULL);

  hbox293 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox293, "hbox293");
  gtk_widget_ref (hbox293);
  gtk_object_set_data_full (GTK_OBJECT (blur), "hbox293", hbox293,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox293);
  gtk_table_attach (GTK_TABLE (table115), hbox293, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  pong_pause = gtk_entry_new ();
  gtk_widget_set_name (pong_pause, "pong_pause");
  gtk_widget_ref (pong_pause);
  gtk_object_set_data_full (GTK_OBJECT (blur), "pong_pause", pong_pause,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pong_pause);
  gtk_box_pack_start (GTK_BOX (hbox293), pong_pause, FALSE, TRUE, 0);
  gtk_widget_set_usize (pong_pause, 50, -2);
  gtk_tooltips_set_tip (tooltips, pong_pause, _("Pause after last frame"), NULL);

  label512 = gtk_label_new (_("milliseconds"));
  gtk_widget_set_name (label512, "label512");
  gtk_widget_ref (label512);
  gtk_object_set_data_full (GTK_OBJECT (blur), "label512", label512,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label512);
  gtk_box_pack_start (GTK_BOX (hbox293), label512, FALSE, FALSE, 0);

  label510 = gtk_label_new (_("Pause"));
  gtk_widget_set_name (label510, "label510");
  gtk_widget_ref (label510);
  gtk_object_set_data_full (GTK_OBJECT (blur), "label510", label510,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label510);
  gtk_table_attach (GTK_TABLE (table115), label510, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label510), 0, 0.5);

  label511 = gtk_label_new (_("Audio"));
  gtk_widget_set_name (label511, "label511");
  gtk_widget_ref (label511);
  gtk_object_set_data_full (GTK_OBJECT (blur), "label511", label511,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label511);
  gtk_table_attach (GTK_TABLE (table115), label511, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label511), 0, 0.5);

  frame121 = gtk_frame_new (_("Ping"));
  gtk_widget_set_name (frame121, "frame121");
  gtk_widget_ref (frame121);
  gtk_object_set_data_full (GTK_OBJECT (blur), "frame121", frame121,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame121);
  gtk_box_pack_start (GTK_BOX (vbox195), frame121, TRUE, TRUE, 0);

  table116 = gtk_table_new (2, 3, FALSE);
  gtk_widget_set_name (table116, "table116");
  gtk_widget_ref (table116);
  gtk_object_set_data_full (GTK_OBJECT (blur), "table116", table116,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table116);
  gtk_container_add (GTK_CONTAINER (frame121), table116);
  gtk_container_set_border_width (GTK_CONTAINER (table116), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table116), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table116), 5);

  ping_browse = gtk_button_new_with_label ("");
  ping_browse_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (ping_browse)->child),
                                   _("Bro_wse..."));
  gtk_widget_add_accelerator (ping_browse, "clicked", accel_group,
                              ping_browse_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (ping_browse, "ping_browse");
  gtk_widget_ref (ping_browse);
  gtk_object_set_data_full (GTK_OBJECT (blur), "ping_browse", ping_browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ping_browse);
  gtk_table_attach (GTK_TABLE (table116), ping_browse, 2, 3, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (ping_browse, 90, -2);
  gtk_tooltips_set_tip (tooltips, ping_browse, _("Browse for file"), NULL);

  ping_audio = gtk_entry_new ();
  gtk_widget_set_name (ping_audio, "ping_audio");
  gtk_widget_ref (ping_audio);
  gtk_object_set_data_full (GTK_OBJECT (blur), "ping_audio", ping_audio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ping_audio);
  gtk_table_attach (GTK_TABLE (table116), ping_audio, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, ping_audio, _("Sound file for effect during first frame"), NULL);

  hbox294 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox294, "hbox294");
  gtk_widget_ref (hbox294);
  gtk_object_set_data_full (GTK_OBJECT (blur), "hbox294", hbox294,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox294);
  gtk_table_attach (GTK_TABLE (table116), hbox294, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  ping_pause = gtk_entry_new ();
  gtk_widget_set_name (ping_pause, "ping_pause");
  gtk_widget_ref (ping_pause);
  gtk_object_set_data_full (GTK_OBJECT (blur), "ping_pause", ping_pause,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ping_pause);
  gtk_box_pack_start (GTK_BOX (hbox294), ping_pause, FALSE, TRUE, 0);
  gtk_widget_set_usize (ping_pause, 50, -2);
  gtk_tooltips_set_tip (tooltips, ping_pause, _("Pause first last frame"), NULL);

  label513 = gtk_label_new (_("milliseconds"));
  gtk_widget_set_name (label513, "label513");
  gtk_widget_ref (label513);
  gtk_object_set_data_full (GTK_OBJECT (blur), "label513", label513,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label513);
  gtk_box_pack_start (GTK_BOX (hbox294), label513, FALSE, FALSE, 0);

  label514 = gtk_label_new (_("Pause"));
  gtk_widget_set_name (label514, "label514");
  gtk_widget_ref (label514);
  gtk_object_set_data_full (GTK_OBJECT (blur), "label514", label514,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label514);
  gtk_table_attach (GTK_TABLE (table116), label514, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label514), 0, 0.5);

  label515 = gtk_label_new (_("Audio"));
  gtk_widget_set_name (label515, "label515");
  gtk_widget_ref (label515);
  gtk_object_set_data_full (GTK_OBJECT (blur), "label515", label515,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label515);
  gtk_table_attach (GTK_TABLE (table116), label515, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label515), 0, 0.5);

  finish_dialog (blur, vbox192, accel_group);

  gtk_signal_connect (GTK_OBJECT (double_size), "toggled",
                      GTK_SIGNAL_FUNC (OnDoublesize), NULL);
  gtk_signal_connect (GTK_OBJECT (ping_pong), "toggled",
                      GTK_SIGNAL_FUNC (OnPingpong), NULL);
  gtk_signal_connect (GTK_OBJECT (cyclic), "toggled",
                      GTK_SIGNAL_FUNC (OnCyclic), NULL);
  gtk_signal_connect (GTK_OBJECT (frames_browse), "clicked",
                      GTK_SIGNAL_FUNC (OnBrowseFileFrames), NULL);
  gtk_signal_connect (GTK_OBJECT (ping_browse), "clicked",
                      GTK_SIGNAL_FUNC (OnBrowseFilePing), NULL);
  gtk_signal_connect (GTK_OBJECT (pong_browse), "clicked",
                      GTK_SIGNAL_FUNC (OnBrowseFilePong), NULL);

  gtk_object_set_data (GTK_OBJECT (blur), "tooltips", tooltips);
  gtk_window_add_accel_group (GTK_WINDOW (blur), accel_group);

  return blur;
}

GtkWidget* create_fire ()
{
  GtkWidget *fire;
  GtkWidget *vbox197;
  GtkWidget *hbox300;
  GtkWidget *table122;
  GtkWidget *frame130;
  GtkWidget *vbox199;
  GSList *vbox199_group = NULL;
  GtkWidget *rectangle;
  GtkWidget *convex;
  GtkWidget *frame128;
  GtkWidget *table125;
  GtkWidget *label535;
  GtkWidget *label536;
  GtkWidget *start;
  GtkWidget *value;
  GtkWidget *hbox301;
  GtkWidget *textscroll;
  GtkWidget *frame129;
  GtkWidget *table124;
  GtkWidget *label541;
  GtkWidget *label540;
  GtkWidget *width;
  GtkWidget *height;
  GtkWidget *frame127;
  GtkWidget *table123;
  GtkObject *fire_width_adj;
  GtkWidget *fire_width;
  GtkObject *fire_height_adj;
  GtkWidget *fire_height;
  GtkWidget *x_combo;
  GtkWidget *x_entry;
  GtkWidget *y_combo;
  GtkWidget *y_entry;
  GtkWidget *label534;
  GtkWidget *label533;
  GtkWidget *label531;
  GtkWidget *label532;
  GtkWidget *vbox198;
  GtkWidget *table127;
  GtkWidget *label543;
  GtkWidget *repeat_combo;
  GtkWidget *repeat_entry;
  GtkObject *def_adj;
  GtkWidget *def;
  GtkWidget *label542;
  GtkWidget *frame131;
  GtkWidget *table126;
  GtkWidget *r_combo;
  GtkWidget *r_entry;
  GtkWidget *g_combo;
  GtkWidget *g_entry;
  GtkWidget *b_combo;
  GtkWidget *b_entry;
  GtkWidget *label537;
  GtkWidget *label538;
  GtkWidget *label539;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;

  fire = init_dialog (&accel_group, &tooltips, &vbox197);

  hbox300 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox300, "hbox300");
  gtk_widget_ref (hbox300);
  gtk_object_set_data_full (GTK_OBJECT (fire), "hbox300", hbox300,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox300);
  gtk_box_pack_start (GTK_BOX (vbox197), hbox300, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox300), 5);

  table122 = gtk_table_new (2, 2, FALSE);
  gtk_widget_set_name (table122, "table122");
  gtk_widget_ref (table122);
  gtk_object_set_data_full (GTK_OBJECT (fire), "table122", table122,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table122);
  gtk_box_pack_start (GTK_BOX (hbox300), table122, TRUE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table122), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table122), 10);

  frame130 = gtk_frame_new (_("Fire mode"));
  gtk_widget_set_name (frame130, "frame130");
  gtk_widget_ref (frame130);
  gtk_object_set_data_full (GTK_OBJECT (fire), "frame130", frame130,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame130);
  gtk_table_attach (GTK_TABLE (table122), frame130, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  vbox199 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox199, "vbox199");
  gtk_widget_ref (vbox199);
  gtk_object_set_data_full (GTK_OBJECT (fire), "vbox199", vbox199,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox199);
  gtk_container_add (GTK_CONTAINER (frame130), vbox199);
  gtk_container_set_border_width (GTK_CONTAINER (vbox199), 5);

  rectangle = gtk_radio_button_new_with_label (vbox199_group, _("Rectangle"));
  vbox199_group = gtk_radio_button_group (GTK_RADIO_BUTTON (rectangle));
  gtk_widget_set_name (rectangle, "rectangle");
  gtk_widget_ref (rectangle);
  gtk_object_set_data_full (GTK_OBJECT (fire), "rectangle", rectangle,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rectangle);
  gtk_box_pack_start (GTK_BOX (vbox199), rectangle, FALSE, FALSE, 0);

  convex = gtk_radio_button_new_with_label (vbox199_group, _("Convex"));
  vbox199_group = gtk_radio_button_group (GTK_RADIO_BUTTON (convex));
  gtk_widget_set_name (convex, "convex");
  gtk_widget_ref (convex);
  gtk_object_set_data_full (GTK_OBJECT (fire), "convex", convex,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (convex);
  gtk_box_pack_start (GTK_BOX (vbox199), convex, FALSE, FALSE, 0);

  frame128 = gtk_frame_new (_("Fire cut"));
  gtk_widget_set_name (frame128, "frame128");
  gtk_widget_ref (frame128);
  gtk_object_set_data_full (GTK_OBJECT (fire), "frame128", frame128,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame128);
  gtk_table_attach (GTK_TABLE (table122), frame128, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  table125 = gtk_table_new (2, 2, FALSE);
  gtk_widget_set_name (table125, "table125");
  gtk_widget_ref (table125);
  gtk_object_set_data_full (GTK_OBJECT (fire), "table125", table125,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table125);
  gtk_container_add (GTK_CONTAINER (frame128), table125);
  gtk_container_set_border_width (GTK_CONTAINER (table125), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table125), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table125), 5);

  label535 = gtk_label_new (_("Start"));
  gtk_widget_set_name (label535, "label535");
  gtk_widget_ref (label535);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label535", label535,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label535);
  gtk_table_attach (GTK_TABLE (table125), label535, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label535), 0, 0.5);

  label536 = gtk_label_new (_("Value"));
  gtk_widget_set_name (label536, "label536");
  gtk_widget_ref (label536);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label536", label536,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label536);
  gtk_table_attach (GTK_TABLE (table125), label536, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label536), 0, 0.5);

  start = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (start, "start");
  gtk_widget_ref (start);
  gtk_object_set_data_full (GTK_OBJECT (fire), "start", start,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (start);
  gtk_table_attach (GTK_TABLE (table125), start, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (start, 50, -2);
  gtk_tooltips_set_tip (tooltips, start, _("When fire starts to die (1 .. 127)"), NULL);

  value = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (value, "value");
  gtk_widget_ref (value);
  gtk_object_set_data_full (GTK_OBJECT (fire), "value", value,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (value);
  gtk_table_attach (GTK_TABLE (table125), value, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (value, 50, -2);
  gtk_tooltips_set_tip (tooltips, value, _("Fire deading speed (1 .. 127)"), NULL);

  hbox301 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox301, "hbox301");
  gtk_widget_ref (hbox301);
  gtk_object_set_data_full (GTK_OBJECT (fire), "hbox301", hbox301,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox301);
  gtk_table_attach (GTK_TABLE (table122), hbox301, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  textscroll = gtk_check_button_new_with_label (_("Enable textscroll"));
  gtk_widget_set_name (textscroll, "textscroll");
  gtk_widget_ref (textscroll);
  gtk_object_set_data_full (GTK_OBJECT (fire), "textscroll", textscroll,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (textscroll);
  gtk_box_pack_start (GTK_BOX (hbox301), textscroll, FALSE, FALSE, 0);

  frame129 = gtk_frame_new (_("Size"));
  gtk_widget_set_name (frame129, "frame129");
  gtk_widget_ref (frame129);
  gtk_object_set_data_full (GTK_OBJECT (fire), "frame129", frame129,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame129);
  gtk_box_pack_end (GTK_BOX (hbox301), frame129, FALSE, TRUE, 0);

  table124 = gtk_table_new (2, 2, FALSE);
  gtk_widget_set_name (table124, "table124");
  gtk_widget_ref (table124);
  gtk_object_set_data_full (GTK_OBJECT (fire), "table124", table124,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table124);
  gtk_container_add (GTK_CONTAINER (frame129), table124);
  gtk_container_set_border_width (GTK_CONTAINER (table124), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table124), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table124), 5);

  label541 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label541, "label541");
  gtk_widget_ref (label541);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label541", label541,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label541);
  gtk_table_attach (GTK_TABLE (table124), label541, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label541), 0, 0.5);

  label540 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label540, "label540");
  gtk_widget_ref (label540);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label540", label540,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label540);
  gtk_table_attach (GTK_TABLE (table124), label540, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label540), 0, 0.5);

  width = gtk_entry_new ();
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (fire), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table124), width, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_widget_set_sensitive (width, FALSE);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (width), FALSE);

  height = gtk_entry_new ();
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (fire), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table124), height, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_widget_set_sensitive (height, FALSE);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (height), FALSE);

  frame127 = gtk_frame_new (_("Fire size"));
  gtk_widget_set_name (frame127, "frame127");
  gtk_widget_ref (frame127);
  gtk_object_set_data_full (GTK_OBJECT (fire), "frame127", frame127,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame127);
  gtk_table_attach (GTK_TABLE (table122), frame127, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  table123 = gtk_table_new (2, 4, FALSE);
  gtk_widget_set_name (table123, "table123");
  gtk_widget_ref (table123);
  gtk_object_set_data_full (GTK_OBJECT (fire), "table123", table123,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table123);
  gtk_container_add (GTK_CONTAINER (frame127), table123);
  gtk_container_set_border_width (GTK_CONTAINER (table123), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table123), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table123), 5);

  fire_width_adj = gtk_adjustment_new (1, 1, 100, 1, 10, 10);
  fire_width = gtk_spin_button_new (GTK_ADJUSTMENT (fire_width_adj), 1, 0);
  gtk_widget_set_name (fire_width, "fire_width");
  gtk_widget_ref (fire_width);
  gtk_object_set_data_full (GTK_OBJECT (fire), "fire_width", fire_width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fire_width);
  gtk_table_attach (GTK_TABLE (table123), fire_width, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (fire_width, 50, -2);
  gtk_tooltips_set_tip (tooltips, fire_width, _("\"Internal\" fire width"), NULL);

  fire_height_adj = gtk_adjustment_new (1, 1, 100, 1, 10, 10);
  fire_height = gtk_spin_button_new (GTK_ADJUSTMENT (fire_height_adj), 1, 0);
  gtk_widget_set_name (fire_height, "fire_height");
  gtk_widget_ref (fire_height);
  gtk_object_set_data_full (GTK_OBJECT (fire), "fire_height", fire_height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fire_height);
  gtk_table_attach (GTK_TABLE (table123), fire_height, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (fire_height, 50, -2);
  gtk_tooltips_set_tip (tooltips, fire_height, _("\"Internal\" fire height"), NULL);

  x_combo = gtk_combo_new ();
  gtk_widget_set_name (x_combo, "x_combo");
  gtk_widget_ref (x_combo);
  gtk_object_set_data_full (GTK_OBJECT (fire), "x_combo", x_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_combo);
  gtk_table_attach (GTK_TABLE (table123), x_combo, 3, 4, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (x_combo, 50, -2);
  fill_combo (x_combo, 1, 8);

  x_entry = GTK_COMBO (x_combo)->entry;
  gtk_widget_set_name (x_entry, "x_entry");
  gtk_widget_ref (x_entry);
  gtk_object_set_data_full (GTK_OBJECT (fire), "x_entry", x_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (x_entry);
  gtk_tooltips_set_tip (tooltips, x_entry, _("Multiply factor of width"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (x_entry), FALSE);

  y_combo = gtk_combo_new ();
  gtk_widget_set_name (y_combo, "y_combo");
  gtk_widget_ref (y_combo);
  gtk_object_set_data_full (GTK_OBJECT (fire), "y_combo", y_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (y_combo);
  gtk_table_attach (GTK_TABLE (table123), y_combo, 3, 4, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (y_combo, 50, -2);
  fill_combo (y_combo, 1, 8);

  y_entry = GTK_COMBO (y_combo)->entry;
  gtk_widget_set_name (y_entry, "y_entry");
  gtk_widget_ref (y_entry);
  gtk_object_set_data_full (GTK_OBJECT (fire), "y_entry", y_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (y_entry);
  gtk_tooltips_set_tip (tooltips, y_entry, _("Multiply factor of height"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (y_entry), FALSE);

  label534 = gtk_label_new (_("X res"));
  gtk_widget_set_name (label534, "label534");
  gtk_widget_ref (label534);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label534", label534,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label534);
  gtk_table_attach (GTK_TABLE (table123), label534, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label534), 0, 0.5);

  label533 = gtk_label_new (_("Y res"));
  gtk_widget_set_name (label533, "label533");
  gtk_widget_ref (label533);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label533", label533,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label533);
  gtk_table_attach (GTK_TABLE (table123), label533, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label533), 0, 0.5);

  label531 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label531, "label531");
  gtk_widget_ref (label531);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label531", label531,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label531);
  gtk_table_attach (GTK_TABLE (table123), label531, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label531), 0, 0.5);

  label532 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label532, "label532");
  gtk_widget_ref (label532);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label532", label532,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label532);
  gtk_table_attach (GTK_TABLE (table123), label532, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label532), 0, 0.5);

  vbox198 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox198, "vbox198");
  gtk_widget_ref (vbox198);
  gtk_object_set_data_full (GTK_OBJECT (fire), "vbox198", vbox198,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox198);
  gtk_box_pack_start (GTK_BOX (hbox300), vbox198, TRUE, TRUE, 0);

  table127 = gtk_table_new (2, 2, FALSE);
  gtk_widget_set_name (table127, "table127");
  gtk_widget_ref (table127);
  gtk_object_set_data_full (GTK_OBJECT (fire), "table127", table127,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table127);
  gtk_box_pack_start (GTK_BOX (vbox198), table127, TRUE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table127), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table127), 5);

  label543 = gtk_label_new (_("Repeat"));
  gtk_widget_set_name (label543, "label543");
  gtk_widget_ref (label543);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label543", label543,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label543);
  gtk_table_attach (GTK_TABLE (table127), label543, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label543), 0, 0.5);

  repeat_combo = gtk_combo_new ();
  gtk_widget_set_name (repeat_combo, "repeat_combo");
  gtk_widget_ref (repeat_combo);
  gtk_object_set_data_full (GTK_OBJECT (fire), "repeat_combo", repeat_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (repeat_combo);
  gtk_table_attach (GTK_TABLE (table127), repeat_combo, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (repeat_combo, 50, -2);
  fill_combo (repeat_combo, 1, 9);

  repeat_entry = GTK_COMBO (repeat_combo)->entry;
  gtk_widget_set_name (repeat_entry, "repeat_entry");
  gtk_widget_ref (repeat_entry);
  gtk_object_set_data_full (GTK_OBJECT (fire), "repeat_entry", repeat_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (repeat_entry);
  gtk_tooltips_set_tip (tooltips, repeat_entry, _("Smoothing rate"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (repeat_entry), FALSE);

  def_adj = gtk_adjustment_new (1, 0, 100, 1, 10, 10);
  def = gtk_spin_button_new (GTK_ADJUSTMENT (def_adj), 1, 0);
  gtk_widget_set_name (def, "def");
  gtk_widget_ref (def);
  gtk_object_set_data_full (GTK_OBJECT (fire), "def", def,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (def);
  gtk_table_attach (GTK_TABLE (table127), def, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_tooltips_set_tip (tooltips, def, _("Determine the minimal light at the base of fire"), NULL);

  label542 = gtk_label_new (_("Def. light"));
  gtk_widget_set_name (label542, "label542");
  gtk_widget_ref (label542);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label542", label542,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label542);
  gtk_table_attach (GTK_TABLE (table127), label542, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label542), 0, 0.5);

  frame131 = gtk_frame_new (_("Palette"));
  gtk_widget_set_name (frame131, "frame131");
  gtk_widget_ref (frame131);
  gtk_object_set_data_full (GTK_OBJECT (fire), "frame131", frame131,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame131);
  gtk_box_pack_start (GTK_BOX (vbox198), frame131, TRUE, TRUE, 0);

  table126 = gtk_table_new (3, 2, FALSE);
  gtk_widget_set_name (table126, "table126");
  gtk_widget_ref (table126);
  gtk_object_set_data_full (GTK_OBJECT (fire), "table126", table126,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table126);
  gtk_container_add (GTK_CONTAINER (frame131), table126);
  gtk_container_set_border_width (GTK_CONTAINER (table126), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table126), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table126), 5);

  r_combo = gtk_combo_new ();
  gtk_widget_set_name (r_combo, "r_combo");
  gtk_widget_ref (r_combo);
  gtk_object_set_data_full (GTK_OBJECT (fire), "r_combo", r_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (r_combo);
  gtk_table_attach (GTK_TABLE (table126), r_combo, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (r_combo, 50, -2);
  fill_combo (r_combo, 0, 8);

  r_entry = GTK_COMBO (r_combo)->entry;
  gtk_widget_set_name (r_entry, "r_entry");
  gtk_widget_ref (r_entry);
  gtk_object_set_data_full (GTK_OBJECT (fire), "r_entry", r_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (r_entry);
  gtk_tooltips_set_tip (tooltips, r_entry, _("Red intensity"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (r_entry), FALSE);

  g_combo = gtk_combo_new ();
  gtk_widget_set_name (g_combo, "g_combo");
  gtk_widget_ref (g_combo);
  gtk_object_set_data_full (GTK_OBJECT (fire), "g_combo", g_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (g_combo);
  gtk_table_attach (GTK_TABLE (table126), g_combo, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (g_combo, 50, -2);
  fill_combo (g_combo, 0, 8);

  g_entry = GTK_COMBO (g_combo)->entry;
  gtk_widget_set_name (g_entry, "g_entry");
  gtk_widget_ref (g_entry);
  gtk_object_set_data_full (GTK_OBJECT (fire), "g_entry", g_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (g_entry);
  gtk_tooltips_set_tip (tooltips, g_entry, _("Green intensity"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (g_entry), FALSE);

  b_combo = gtk_combo_new ();
  gtk_widget_set_name (b_combo, "b_combo");
  gtk_widget_ref (b_combo);
  gtk_object_set_data_full (GTK_OBJECT (fire), "b_combo", b_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (b_combo);
  gtk_table_attach (GTK_TABLE (table126), b_combo, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (b_combo, 50, -2);
  fill_combo (b_combo, 0, 8);

  b_entry = GTK_COMBO (b_combo)->entry;
  gtk_widget_set_name (b_entry, "b_entry");
  gtk_widget_ref (b_entry);
  gtk_object_set_data_full (GTK_OBJECT (fire), "b_entry", b_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (b_entry);
  gtk_tooltips_set_tip (tooltips, b_entry, _("Blue intensity"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (b_entry), FALSE);

  label537 = gtk_label_new (_("Red"));
  gtk_widget_set_name (label537, "label537");
  gtk_widget_ref (label537);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label537", label537,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label537);
  gtk_table_attach (GTK_TABLE (table126), label537, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label537), 0, 0.5);

  label538 = gtk_label_new (_("Green"));
  gtk_widget_set_name (label538, "label538");
  gtk_widget_ref (label538);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label538", label538,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label538);
  gtk_table_attach (GTK_TABLE (table126), label538, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label538), 0, 0.5);

  label539 = gtk_label_new (_("Blue"));
  gtk_widget_set_name (label539, "label539");
  gtk_widget_ref (label539);
  gtk_object_set_data_full (GTK_OBJECT (fire), "label539", label539,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label539);
  gtk_table_attach (GTK_TABLE (table126), label539, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label539), 0, 0.5);

  finish_dialog (fire, vbox197, accel_group);

  gtk_signal_connect (GTK_OBJECT (textscroll), "toggled",
                      GTK_SIGNAL_FUNC (on_textscroll), NULL);
  gtk_signal_connect (GTK_OBJECT (x_entry), "changed",
                      GTK_SIGNAL_FUNC (on_fire_changeres), NULL);
  gtk_signal_connect (GTK_OBJECT (y_entry), "changed",
                      GTK_SIGNAL_FUNC (on_fire_changeres), NULL);
  gtk_signal_connect (GTK_OBJECT (fire_width), "changed",
                      GTK_SIGNAL_FUNC (on_fire_changeres), NULL);
  gtk_signal_connect (GTK_OBJECT (fire_height), "changed",
                      GTK_SIGNAL_FUNC (on_fire_changeres), NULL);

  gtk_window_add_accel_group (GTK_WINDOW (fire), accel_group);
  gtk_object_set_data (GTK_OBJECT (fire), "tooltips", tooltips);

  return fire;
}

GtkWidget* create_flag ()
{
  GtkWidget *flag;
  GtkWidget *vbox200;
  GtkWidget *hbox302;
  GtkWidget *table133;
  GtkWidget *nation_combo;
  GList *nation_combo_items = NULL;
  GtkWidget *nation_entry;
  GtkWidget *pattern_combo;
  GList *pattern_combo_items = NULL;
  GtkWidget *pattern_entry;
  GtkWidget *label559;
  GtkWidget *label558;
  GtkWidget *label557;
  GtkWidget *label556;
  GtkWidget *speed;
  GtkWidget *curve_combo;
  GtkWidget *curve_entry;
  GtkWidget *hbox306;
  GtkWidget *wind_combo;
  GtkWidget *wind_entry;
  GtkWidget *label560;
  GtkWidget *hbox307;
  GtkWidget *textscroll;
  GtkWidget *back_color;
  GtkWidget *vbox202;
  GtkWidget *frame136;
  GtkWidget *table132;
  GtkWidget *label552;
  GtkWidget *label553;
  GtkWidget *width;
  GtkWidget *height;
  GtkWidget *label554;
  GtkWidget *resolution_combo;
  GtkWidget *resolution_entry;
  GtkWidget *hbox305;
  GtkWidget *label555;
  GtkWidget *pix_combo;
  GtkWidget *pix_entry;
  GtkWidget *color_pixmap;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;

  flag = init_dialog (&accel_group, &tooltips, &vbox200);

  hbox302 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox302, "hbox302");
  gtk_widget_ref (hbox302);
  gtk_object_set_data_full (GTK_OBJECT (flag), "hbox302", hbox302,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox302);
  gtk_box_pack_start (GTK_BOX (vbox200), hbox302, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox302), 5);

  table133 = gtk_table_new (5, 3, FALSE);
  gtk_widget_set_name (table133, "table133");
  gtk_widget_ref (table133);
  gtk_object_set_data_full (GTK_OBJECT (flag), "table133", table133,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table133);
  gtk_box_pack_start (GTK_BOX (hbox302), table133, FALSE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table133), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table133), 5);

  nation_combo = gtk_combo_new ();
  gtk_widget_set_name (nation_combo, "nation_combo");
  gtk_widget_ref (nation_combo);
  gtk_object_set_data_full (GTK_OBJECT (flag), "nation_combo", nation_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (nation_combo);
  gtk_table_attach (GTK_TABLE (table133), nation_combo, 1, 3, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  nation_combo_items = g_list_append (nation_combo_items, _("Austria"));
  nation_combo_items = g_list_append (nation_combo_items, _("Belgium"));
  nation_combo_items = g_list_append (nation_combo_items, _("Denmark"));
  nation_combo_items = g_list_append (nation_combo_items, _("Finland"));
  nation_combo_items = g_list_append (nation_combo_items, _("France"));
  nation_combo_items = g_list_append (nation_combo_items, _("Germany"));
  nation_combo_items = g_list_append (nation_combo_items, _("Groenland"));
  nation_combo_items = g_list_append (nation_combo_items, _("Hungary"));
  nation_combo_items = g_list_append (nation_combo_items, _("Iceland"));
  nation_combo_items = g_list_append (nation_combo_items, _("Ireland"));
  nation_combo_items = g_list_append (nation_combo_items, _("Italy"));
  nation_combo_items = g_list_append (nation_combo_items, _("Luxembourg"));
  nation_combo_items = g_list_append (nation_combo_items, _("Netherlands (Holland)"));
  nation_combo_items = g_list_append (nation_combo_items, _("Norway"));
  nation_combo_items = g_list_append (nation_combo_items, _("Poland"));
  nation_combo_items = g_list_append (nation_combo_items, _("Russia"));
  nation_combo_items = g_list_append (nation_combo_items, _("South Africa"));
  nation_combo_items = g_list_append (nation_combo_items, _("Spain"));
  nation_combo_items = g_list_append (nation_combo_items, _("Sweden"));
  nation_combo_items = g_list_append (nation_combo_items, _("Switzerland"));
  gtk_combo_set_popdown_strings (GTK_COMBO (nation_combo), nation_combo_items);
  g_list_free (nation_combo_items);

  nation_entry = GTK_COMBO (nation_combo)->entry;
  gtk_widget_set_name (nation_entry, "nation_entry");
  gtk_widget_ref (nation_entry);
  gtk_object_set_data_full (GTK_OBJECT (flag), "nation_entry", nation_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (nation_entry);
  gtk_tooltips_set_tip (tooltips, nation_entry, _("Flag to display"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (nation_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (nation_entry), _("Austria"));

  pattern_combo = gtk_combo_new ();
  gtk_widget_set_name (pattern_combo, "pattern_combo");
  gtk_widget_ref (pattern_combo);
  gtk_object_set_data_full (GTK_OBJECT (flag), "pattern_combo", pattern_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pattern_combo);
  gtk_table_attach (GTK_TABLE (table133), pattern_combo, 1, 3, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  pattern_combo_items = g_list_append (pattern_combo_items, _("Small dots"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Double dots"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Stars"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Stars with central hole"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Triangles"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Triple dots"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Triple dots dithered 1"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Triple dots dithered 2"));
  gtk_combo_set_popdown_strings (GTK_COMBO (pattern_combo), pattern_combo_items);
  g_list_free (pattern_combo_items);

  pattern_entry = GTK_COMBO (pattern_combo)->entry;
  gtk_widget_set_name (pattern_entry, "pattern_entry");
  gtk_widget_ref (pattern_entry);
  gtk_object_set_data_full (GTK_OBJECT (flag), "pattern_entry", pattern_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pattern_entry);
  gtk_tooltips_set_tip (tooltips, pattern_entry, _("Style of painting"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (pattern_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (pattern_entry), _("Small dots"));

  label559 = gtk_label_new (_("Nation"));
  gtk_widget_set_name (label559, "label559");
  gtk_widget_ref (label559);
  gtk_object_set_data_full (GTK_OBJECT (flag), "label559", label559,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label559);
  gtk_table_attach (GTK_TABLE (table133), label559, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label559), 0, 0.5);

  label558 = gtk_label_new (_("Curve"));
  gtk_widget_set_name (label558, "label558");
  gtk_widget_ref (label558);
  gtk_object_set_data_full (GTK_OBJECT (flag), "label558", label558,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label558);
  gtk_table_attach (GTK_TABLE (table133), label558, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label558), 0, 0.5);

  label557 = gtk_label_new (_("Speed"));
  gtk_widget_set_name (label557, "label557");
  gtk_widget_ref (label557);
  gtk_object_set_data_full (GTK_OBJECT (flag), "label557", label557,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label557);
  gtk_table_attach (GTK_TABLE (table133), label557, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label557), 0, 0.5);

  label556 = gtk_label_new (_("Pattern"));
  gtk_widget_set_name (label556, "label556");
  gtk_widget_ref (label556);
  gtk_object_set_data_full (GTK_OBJECT (flag), "label556", label556,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label556);
  gtk_table_attach (GTK_TABLE (table133), label556, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label556), 0, 0.5);

  speed = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (speed, "speed");
  gtk_widget_ref (speed);
  gtk_object_set_data_full (GTK_OBJECT (flag), "speed", speed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (speed);
  gtk_table_attach (GTK_TABLE (table133), speed, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (speed, 50, -2);
  gtk_tooltips_set_tip (tooltips, speed, _("Speed of effect (1 .. 8)"), NULL);

  curve_combo = gtk_combo_new ();
  gtk_widget_set_name (curve_combo, "curve_combo");
  gtk_widget_ref (curve_combo);
  gtk_object_set_data_full (GTK_OBJECT (flag), "curve_combo", curve_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (curve_combo);
  gtk_table_attach (GTK_TABLE (table133), curve_combo, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (curve_combo, 50, -2);
  fill_combo (curve_combo, 1, 5);

  curve_entry = GTK_COMBO (curve_combo)->entry;
  gtk_widget_set_name (curve_entry, "curve_entry");
  gtk_widget_ref (curve_entry);
  gtk_object_set_data_full (GTK_OBJECT (flag), "curve_entry", curve_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (curve_entry);
  gtk_tooltips_set_tip (tooltips, curve_entry, _("Perturbation intensity"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (curve_entry), FALSE);

  hbox306 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox306, "hbox306");
  gtk_widget_ref (hbox306);
  gtk_object_set_data_full (GTK_OBJECT (flag), "hbox306", hbox306,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox306);
  gtk_table_attach (GTK_TABLE (table133), hbox306, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  wind_combo = gtk_combo_new ();
  gtk_widget_set_name (wind_combo, "wind_combo");
  gtk_widget_ref (wind_combo);
  gtk_object_set_data_full (GTK_OBJECT (flag), "wind_combo", wind_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wind_combo);
  gtk_box_pack_end (GTK_BOX (hbox306), wind_combo, FALSE, TRUE, 0);
  gtk_widget_set_usize (wind_combo, 50, -2);
  fill_combo (wind_combo, 0, 20);

  wind_entry = GTK_COMBO (wind_combo)->entry;
  gtk_widget_set_name (wind_entry, "wind_entry");
  gtk_widget_ref (wind_entry);
  gtk_object_set_data_full (GTK_OBJECT (flag), "wind_entry", wind_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wind_entry);
  gtk_tooltips_set_tip (tooltips, wind_entry, _("meteorologic situation (0=no waving .. 20=hurricane)"), NULL);

  label560 = gtk_label_new (_("Wind"));
  gtk_widget_set_name (label560, "label560");
  gtk_widget_ref (label560);
  gtk_object_set_data_full (GTK_OBJECT (flag), "label560", label560,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label560);
  gtk_box_pack_end (GTK_BOX (hbox306), label560, FALSE, FALSE, 0);

  hbox307 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox307, "hbox307");
  gtk_widget_ref (hbox307);
  gtk_object_set_data_full (GTK_OBJECT (flag), "hbox307", hbox307,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox307);
  gtk_table_attach (GTK_TABLE (table133), hbox307, 0, 3, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  textscroll = gtk_check_button_new_with_label (_("Enable textscroll"));
  gtk_widget_set_name (textscroll, "textscroll");
  gtk_widget_ref (textscroll);
  gtk_object_set_data_full (GTK_OBJECT (flag), "textscroll", textscroll,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (textscroll);
  gtk_box_pack_start (GTK_BOX (hbox307), textscroll, FALSE, FALSE, 0);

  color_pixmap = set_color_pixmap ((GtkWidget*)NULL, 0, 0, 0);
  gtk_widget_set_name (color_pixmap, "color_pixmap");
  gtk_widget_ref (color_pixmap);
  gtk_object_set_data_full (GTK_OBJECT (flag), "color_pixmap", color_pixmap,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (color_pixmap);
  gtk_box_pack_end (GTK_BOX (hbox307), color_pixmap, FALSE, FALSE, 0);

  back_color = gtk_button_new_with_label (_("Back. color..."));
  gtk_widget_set_name (back_color, "back_color");
  gtk_widget_ref (back_color);
  gtk_object_set_data_full (GTK_OBJECT (flag), "back_color", back_color,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_color);
  gtk_box_pack_end (GTK_BOX (hbox307), back_color, FALSE, FALSE, 0);
  gtk_widget_set_usize (back_color, 90, -2);
  gtk_tooltips_set_tip (tooltips, back_color, _("Background color"), NULL);

  vbox202 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox202, "vbox202");
  gtk_widget_ref (vbox202);
  gtk_object_set_data_full (GTK_OBJECT (flag), "vbox202", vbox202,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox202);
  gtk_box_pack_end (GTK_BOX (hbox302), vbox202, FALSE, TRUE, 0);

  frame136 = gtk_frame_new (_("Size"));
  gtk_widget_set_name (frame136, "frame136");
  gtk_widget_ref (frame136);
  gtk_object_set_data_full (GTK_OBJECT (flag), "frame136", frame136,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame136);
  gtk_box_pack_start (GTK_BOX (vbox202), frame136, FALSE, TRUE, 0);

  table132 = gtk_table_new (3, 2, FALSE);
  gtk_widget_set_name (table132, "table132");
  gtk_widget_ref (table132);
  gtk_object_set_data_full (GTK_OBJECT (flag), "table132", table132,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table132);
  gtk_container_add (GTK_CONTAINER (frame136), table132);
  gtk_container_set_border_width (GTK_CONTAINER (table132), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table132), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table132), 5);

  label552 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label552, "label552");
  gtk_widget_ref (label552);
  gtk_object_set_data_full (GTK_OBJECT (flag), "label552", label552,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label552);
  gtk_table_attach (GTK_TABLE (table132), label552, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label552), 0, 0.5);

  label553 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label553, "label553");
  gtk_widget_ref (label553);
  gtk_object_set_data_full (GTK_OBJECT (flag), "label553", label553,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label553);
  gtk_table_attach (GTK_TABLE (table132), label553, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label553), 0, 0.5);

  width = gtk_entry_new ();
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (flag), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table132), width, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);

  height = gtk_entry_new ();
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (flag), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table132), height, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);

  label554 = gtk_label_new (_("Resolution"));
  gtk_widget_set_name (label554, "label554");
  gtk_widget_ref (label554);
  gtk_object_set_data_full (GTK_OBJECT (flag), "label554", label554,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label554);
  gtk_table_attach (GTK_TABLE (table132), label554, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label554), 0, 0.5);

  resolution_combo = gtk_combo_new ();
  gtk_widget_set_name (resolution_combo, "resolution_combo");
  gtk_widget_ref (resolution_combo);
  gtk_object_set_data_full (GTK_OBJECT (flag), "resolution_combo", resolution_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_combo);
  gtk_table_attach (GTK_TABLE (table132), resolution_combo, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (resolution_combo, 50, -2);
  fill_combo (resolution_combo, 1, 8);

  resolution_entry = GTK_COMBO (resolution_combo)->entry;
  gtk_widget_set_name (resolution_entry, "resolution_entry");
  gtk_widget_ref (resolution_entry);
  gtk_object_set_data_full (GTK_OBJECT (flag), "resolution_entry", resolution_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_entry);
  gtk_entry_set_editable (GTK_ENTRY (resolution_entry), FALSE);

  hbox305 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox305, "hbox305");
  gtk_widget_ref (hbox305);
  gtk_object_set_data_full (GTK_OBJECT (flag), "hbox305", hbox305,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox305);
  gtk_box_pack_start (GTK_BOX (vbox202), hbox305, FALSE, TRUE, 0);

  label555 = gtk_label_new (_("Pixdensity"));
  gtk_widget_set_name (label555, "label555");
  gtk_widget_ref (label555);
  gtk_object_set_data_full (GTK_OBJECT (flag), "label555", label555,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label555);
  gtk_box_pack_start (GTK_BOX (hbox305), label555, FALSE, FALSE, 0);

  pix_combo = gtk_combo_new ();
  gtk_widget_set_name (pix_combo, "pix_combo");
  gtk_widget_ref (pix_combo);
  gtk_object_set_data_full (GTK_OBJECT (flag), "pix_combo", pix_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_combo);
  gtk_box_pack_end (GTK_BOX (hbox305), pix_combo, FALSE, TRUE, 0);
  gtk_widget_set_usize (pix_combo, 50, -2);
  fill_combo (pix_combo, 1, 20);

  pix_entry = GTK_COMBO (pix_combo)->entry;
  gtk_widget_set_name (pix_entry, "pix_entry");
  gtk_widget_ref (pix_entry);
  gtk_object_set_data_full (GTK_OBJECT (flag), "pix_entry", pix_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_entry);
  gtk_tooltips_set_tip (tooltips, pix_entry, _("Distance between plotted points"), NULL);

  finish_dialog (flag, vbox200, accel_group);

  gtk_signal_connect (GTK_OBJECT (textscroll), "toggled",
                      GTK_SIGNAL_FUNC (on_textscroll), NULL);
  gtk_signal_connect (GTK_OBJECT (back_color), "clicked",
                      GTK_SIGNAL_FUNC (on_back_color), NULL);

  gtk_window_add_accel_group (GTK_WINDOW (flag), accel_group);
  gtk_object_set_data (GTK_OBJECT (flag), "tooltips", tooltips);

  return flag;
}

GtkWidget* create_flagload ()
{
  GtkWidget *flagload;
  GtkWidget *vbox203;
  GtkWidget *vbox204;
  GtkWidget *hbox313;
  GtkWidget *label570;
  GtkWidget *image_browse;
  GtkWidget *image;
  GtkWidget *hbox308;
  GtkWidget *table134;
  GtkWidget *pattern_combo;
  GList *pattern_combo_items = NULL;
  GtkWidget *pattern_entry;
  GtkWidget *label562;
  GtkWidget *label563;
  GtkWidget *label564;
  GtkWidget *speed;
  GtkWidget *curve_combo;
  GtkWidget *curve_entry;
  GtkWidget *wind_combo;
  GtkWidget *wind_entry;
  GtkWidget *label565;
  GtkWidget *hbox311;
  GtkWidget *label569;
  GtkWidget *pix_combo;
  GtkWidget *pix_entry;
  GtkWidget *textscroll;
  GtkWidget *hbox315;
  GtkWidget *back_color;
  GtkWidget *vbox0204;
  GtkWidget *frame137;
  GtkWidget *table135;
  GtkWidget *label566;
  GtkWidget *label567;
  GtkWidget *width;
  GtkWidget *height;
  GtkWidget *label568;
  GtkWidget *resolution_combo;
  GtkWidget *resolution_entry;
  GtkWidget *hbox314;
  GtkWidget *back_image_check;
  GtkWidget *back_image_browse;
  GtkWidget *back_image;
  GtkWidget *color_pixmap;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;

  flagload = init_dialog (&accel_group, &tooltips, &vbox203);

  vbox204 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox204, "vbox204");
  gtk_widget_ref (vbox204);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "vbox204", vbox204,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox204);
  gtk_box_pack_start (GTK_BOX (vbox203), vbox204, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox204), 5);

  hbox313 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox313, "hbox313");
  gtk_widget_ref (hbox313);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "hbox313", hbox313,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox313);
  gtk_box_pack_start (GTK_BOX (vbox204), hbox313, TRUE, TRUE, 0);

  label570 = gtk_label_new (_("Image"));
  gtk_widget_set_name (label570, "label570");
  gtk_widget_ref (label570);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "label570", label570,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label570);
  gtk_box_pack_start (GTK_BOX (hbox313), label570, FALSE, FALSE, 0);

  image_browse = gtk_button_new_with_label (_("Browse..."));
  gtk_widget_set_name (image_browse, "image_browse");
  gtk_widget_ref (image_browse);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "image_browse", image_browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image_browse);
  gtk_box_pack_end (GTK_BOX (hbox313), image_browse, FALSE, FALSE, 0);
  gtk_widget_set_usize (image_browse, 90, -2);
  gtk_tooltips_set_tip (tooltips, image_browse, _("Search for image file"), NULL);

  image = gtk_entry_new ();
  gtk_widget_set_name (image, "image");
  gtk_widget_ref (image);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "image", image,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (image);
  gtk_box_pack_start (GTK_BOX (vbox204), image, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, image, _("Image to manipulate"), NULL);

  hbox308 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox308, "hbox308");
  gtk_widget_ref (hbox308);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "hbox308", hbox308,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox308);
  gtk_box_pack_start (GTK_BOX (vbox204), hbox308, TRUE, TRUE, 0);

  table134 = gtk_table_new (4, 3, FALSE);
  gtk_widget_set_name (table134, "table134");
  gtk_widget_ref (table134);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "table134", table134,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table134);
  gtk_box_pack_start (GTK_BOX (hbox308), table134, FALSE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table134), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table134), 10);

  pattern_combo = gtk_combo_new ();
  gtk_widget_set_name (pattern_combo, "pattern_combo");
  gtk_widget_ref (pattern_combo);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "pattern_combo", pattern_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pattern_combo);
  gtk_table_attach (GTK_TABLE (table134), pattern_combo, 1, 3, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  pattern_combo_items = g_list_append (pattern_combo_items, _("Small dots"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Double dots"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Stars"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Stars with central hole"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Triangles"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Triple dots"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Triple dots dithered 1"));
  pattern_combo_items = g_list_append (pattern_combo_items, _("Triple dots dithered 2"));
  gtk_combo_set_popdown_strings (GTK_COMBO (pattern_combo), pattern_combo_items);
  g_list_free (pattern_combo_items);

  pattern_entry = GTK_COMBO (pattern_combo)->entry;
  gtk_widget_set_name (pattern_entry, "pattern_entry");
  gtk_widget_ref (pattern_entry);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "pattern_entry", pattern_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pattern_entry);
  gtk_tooltips_set_tip (tooltips, pattern_entry, _("Style of painting"), NULL);
  gtk_entry_set_text (GTK_ENTRY (pattern_entry), _("Small dots"));

  label562 = gtk_label_new (_("Curve"));
  gtk_widget_set_name (label562, "label562");
  gtk_widget_ref (label562);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "label562", label562,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label562);
  gtk_table_attach (GTK_TABLE (table134), label562, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label562), 0, 0.5);

  label563 = gtk_label_new (_("Speed"));
  gtk_widget_set_name (label563, "label563");
  gtk_widget_ref (label563);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "label563", label563,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label563);
  gtk_table_attach (GTK_TABLE (table134), label563, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label563), 0, 0.5);

  label564 = gtk_label_new (_("Pattern"));
  gtk_widget_set_name (label564, "label564");
  gtk_widget_ref (label564);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "label564", label564,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label564);
  gtk_table_attach (GTK_TABLE (table134), label564, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label564), 0, 0.5);

  speed = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (speed, "speed");
  gtk_widget_ref (speed);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "speed", speed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (speed);
  gtk_table_attach (GTK_TABLE (table134), speed, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (speed, 50, -2);
  gtk_tooltips_set_tip (tooltips, speed, _("Speed of effect (1 .. 8)"), NULL);

  curve_combo = gtk_combo_new ();
  gtk_widget_set_name (curve_combo, "curve_combo");
  gtk_widget_ref (curve_combo);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "curve_combo", curve_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (curve_combo);
  gtk_table_attach (GTK_TABLE (table134), curve_combo, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (curve_combo, 50, -2);
  fill_combo (curve_combo, 1, 5);

  curve_entry = GTK_COMBO (curve_combo)->entry;
  gtk_widget_set_name (curve_entry, "curve_entry");
  gtk_widget_ref (curve_entry);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "curve_entry", curve_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (curve_entry);
  gtk_tooltips_set_tip (tooltips, curve_entry, _("Perturbation intensity"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (curve_entry), FALSE);

  wind_combo = gtk_combo_new ();
  gtk_widget_set_name (wind_combo, "wind_combo");
  gtk_widget_ref (wind_combo);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "wind_combo", wind_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wind_combo);
  gtk_table_attach (GTK_TABLE (table134), wind_combo, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (wind_combo, 50, -2);
  fill_combo (wind_combo, 0, 20);

  wind_entry = GTK_COMBO (wind_combo)->entry;
  gtk_widget_set_name (wind_entry, "wind_entry");
  gtk_widget_ref (wind_entry);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "wind_entry", wind_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wind_entry);
  gtk_tooltips_set_tip (tooltips, wind_entry, _("meteorologic situation (0=no waving .. 20=hurricane)"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (wind_entry), FALSE);

  label565 = gtk_label_new (_("Wind"));
  gtk_widget_set_name (label565, "label565");
  gtk_widget_ref (label565);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "label565", label565,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label565);
  gtk_table_attach (GTK_TABLE (table134), label565, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label565), 0, 0.5);

  hbox311 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox311, "hbox311");
  gtk_widget_ref (hbox311);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "hbox311", hbox311,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox311);
  gtk_table_attach (GTK_TABLE (table134), hbox311, 2, 3, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  label569 = gtk_label_new (_("Pixdensity"));
  gtk_widget_set_name (label569, "label569");
  gtk_widget_ref (label569);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "label569", label569,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label569);
  gtk_box_pack_start (GTK_BOX (hbox311), label569, FALSE, FALSE, 0);

  pix_combo = gtk_combo_new ();
  gtk_widget_set_name (pix_combo, "pix_combo");
  gtk_widget_ref (pix_combo);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "pix_combo", pix_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_combo);
  gtk_box_pack_end (GTK_BOX (hbox311), pix_combo, FALSE, TRUE, 0);
  gtk_widget_set_usize (pix_combo, 50, -2);
  fill_combo (pix_combo, 1, 20);

  pix_entry = GTK_COMBO (pix_combo)->entry;
  gtk_widget_set_name (pix_entry, "pix_entry");
  gtk_widget_ref (pix_entry);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "pix_entry", pix_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_entry);
  gtk_tooltips_set_tip (tooltips, pix_entry, _("Distance between plotted points"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (pix_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (pix_entry), _("1"));

  textscroll = gtk_check_button_new_with_label (_("Enable textscroll"));
  gtk_widget_set_name (textscroll, "textscroll");
  gtk_widget_ref (textscroll);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "textscroll", textscroll,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (textscroll);
  gtk_table_attach (GTK_TABLE (table134), textscroll, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  hbox315 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox315, "hbox315");
  gtk_widget_ref (hbox315);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "hbox315", hbox315,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox315);
  gtk_table_attach (GTK_TABLE (table134), hbox315, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  back_color = gtk_button_new_with_label (_("Back. color..."));
  gtk_widget_set_name (back_color, "back_color");
  gtk_widget_ref (back_color);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "back_color", back_color,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_color);
  gtk_box_pack_start (GTK_BOX (hbox315), back_color, FALSE, FALSE, 0);
  gtk_widget_set_usize (back_color, 90, -2);

  color_pixmap = set_color_pixmap ((GtkWidget*)NULL, 0, 0, 0);
  gtk_widget_set_name (color_pixmap, "color_pixmap");
  gtk_widget_ref (color_pixmap);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "color_pixmap", color_pixmap,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (color_pixmap);
  gtk_box_pack_end (GTK_BOX (hbox315), color_pixmap, FALSE, FALSE, 0);

  vbox0204 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox0204, "vbox0204");
  gtk_widget_ref (vbox0204);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "vbox0204", vbox0204,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox0204);
  gtk_box_pack_end (GTK_BOX (hbox308), vbox0204, FALSE, TRUE, 0);

  frame137 = gtk_frame_new (_("Size"));
  gtk_widget_set_name (frame137, "frame137");
  gtk_widget_ref (frame137);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "frame137", frame137,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame137);
  gtk_box_pack_start (GTK_BOX (vbox0204), frame137, FALSE, TRUE, 0);

  table135 = gtk_table_new (3, 2, FALSE);
  gtk_widget_set_name (table135, "table135");
  gtk_widget_ref (table135);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "table135", table135,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table135);
  gtk_container_add (GTK_CONTAINER (frame137), table135);
  gtk_container_set_border_width (GTK_CONTAINER (table135), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table135), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table135), 5);

  label566 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label566, "label566");
  gtk_widget_ref (label566);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "label566", label566,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label566);
  gtk_table_attach (GTK_TABLE (table135), label566, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label566), 0, 0.5);

  label567 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label567, "label567");
  gtk_widget_ref (label567);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "label567", label567,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label567);
  gtk_table_attach (GTK_TABLE (table135), label567, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label567), 0, 0.5);

  width = gtk_entry_new ();
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table135), width, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);

  height = gtk_entry_new ();
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table135), height, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);

  label568 = gtk_label_new (_("Resolution"));
  gtk_widget_set_name (label568, "label568");
  gtk_widget_ref (label568);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "label568", label568,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label568);
  gtk_table_attach (GTK_TABLE (table135), label568, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label568), 0, 0.5);

  resolution_combo = gtk_combo_new ();
  gtk_widget_set_name (resolution_combo, "resolution_combo");
  gtk_widget_ref (resolution_combo);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "resolution_combo", resolution_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_combo);
  gtk_table_attach (GTK_TABLE (table135), resolution_combo, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (resolution_combo, 50, -2);
  fill_combo (resolution_combo, 1, 8);

  resolution_entry = GTK_COMBO (resolution_combo)->entry;
  gtk_widget_set_name (resolution_entry, "resolution_entry");
  gtk_widget_ref (resolution_entry);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "resolution_entry", resolution_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_entry);
  gtk_entry_set_editable (GTK_ENTRY (resolution_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (resolution_entry), _("1"));

  hbox314 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox314, "hbox314");
  gtk_widget_ref (hbox314);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "hbox314", hbox314,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox314);
  gtk_box_pack_start (GTK_BOX (vbox204), hbox314, TRUE, TRUE, 0);

  back_image_check = gtk_check_button_new_with_label (_("Back image"));
  gtk_widget_set_name (back_image_check, "back_image_check");
  gtk_widget_ref (back_image_check);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "back_image_check", back_image_check,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_image_check);
  gtk_box_pack_start (GTK_BOX (hbox314), back_image_check, FALSE, FALSE, 0);

  back_image_browse = gtk_button_new_with_label (_("Background image..."));
  gtk_widget_set_name (back_image_browse, "back_image_browse");
  gtk_widget_ref (back_image_browse);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "back_image_browse", back_image_browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_image_browse);
  gtk_box_pack_end (GTK_BOX (hbox314), back_image_browse, FALSE, FALSE, 0);
  gtk_widget_set_usize (back_image_browse, 120, -2);
  gtk_tooltips_set_tip (tooltips, back_image_browse, _("Browse for background image"), NULL);

  back_image = gtk_entry_new ();
  gtk_widget_set_name (back_image, "back_image");
  gtk_widget_ref (back_image);
  gtk_object_set_data_full (GTK_OBJECT (flagload), "back_image", back_image,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_image);
  gtk_box_pack_start (GTK_BOX (vbox204), back_image, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, back_image, _("Background image path"), NULL);

  finish_dialog (flagload, vbox203, accel_group);

  gtk_widget_set_sensitive (back_image, FALSE);
  gtk_widget_set_sensitive (back_image_browse, FALSE);

  //  gtk_signal_connect (GTK_OBJECT (resolution_entry), "changed",
  //                      GTK_SIGNAL_FUNC (on_resolution_changed), NULL);
  gtk_signal_connect (GTK_OBJECT (textscroll), "toggled",
                      GTK_SIGNAL_FUNC (on_textscroll), NULL);
  gtk_signal_connect (GTK_OBJECT (back_color), "clicked",
                      GTK_SIGNAL_FUNC (on_back_color), NULL);
  gtk_signal_connect (GTK_OBJECT (back_image_check), "toggled",
                      GTK_SIGNAL_FUNC (on_back_image_toggle), NULL);
  gtk_signal_connect (GTK_OBJECT (back_image_browse), "clicked",
                      GTK_SIGNAL_FUNC (on_back_image_browse), NULL);
  gtk_signal_connect (GTK_OBJECT (image_browse), "clicked",
                      GTK_SIGNAL_FUNC (on_image_browse), NULL);

  gtk_window_add_accel_group (GTK_WINDOW (flagload), accel_group);
  gtk_object_set_data (GTK_OBJECT (flagload), "tooltips", tooltips);

  return flagload;
}

GtkWidget* create_plasma ()
{
  GtkWidget *plasma;
  GtkWidget *vbox205;
  GtkWidget *hbox322;
  GtkWidget *vbox211;
  GtkWidget *hbox324;
  GtkWidget *frame143;
  GtkWidget *table138;
  GtkWidget *height;
  GtkWidget *width;
  GtkWidget *label580;
  GtkWidget *label581;
  GtkWidget *table139;
  GtkWidget *resolution_combo;
  GtkWidget *resolution_entry;
  GtkWidget *speed_combo;
  GtkWidget *speed_entry;
  GtkWidget *label582;
  GtkWidget *label583;
  GtkWidget *frame142;
  GtkWidget *table137;
  GtkWidget *gen1;
  GtkWidget *gen2;
  GtkWidget *label577;
  GtkWidget *label578;
  GtkWidget *label579;
  GtkWidget *gen3;
  GtkWidget *vbox207;
  GtkWidget *frame138;
  GtkWidget *hbox323;
  GtkWidget *frame139;
  GtkWidget *vbox208;
  GtkWidget *r0;
  GtkWidget *r1;
  GtkWidget *red_combo;
  GtkWidget *red_entry;
  GtkWidget *frame140;
  GtkWidget *vbox209;
  GtkWidget *g0;
  GtkWidget *g1;
  GtkWidget *green_combo;
  GtkWidget *green_entry;
  GtkWidget *frame141;
  GtkWidget *vbox210;
  GtkWidget *b0;
  GtkWidget *b1;
  GtkWidget *blue_combo;
  GtkWidget *blue_entry;
  GtkWidget *textscroll;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;

  plasma = init_dialog (&accel_group, &tooltips, &vbox205);

  hbox322 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox322, "hbox322");
  gtk_widget_ref (hbox322);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "hbox322", hbox322,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox322);
  gtk_box_pack_start (GTK_BOX (vbox205), hbox322, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox322), 5);

  vbox211 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox211, "vbox211");
  gtk_widget_ref (vbox211);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "vbox211", vbox211,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox211);
  gtk_box_pack_start (GTK_BOX (hbox322), vbox211, FALSE, TRUE, 0);

  hbox324 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox324, "hbox324");
  gtk_widget_ref (hbox324);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "hbox324", hbox324,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox324);
  gtk_box_pack_start (GTK_BOX (vbox211), hbox324, FALSE, TRUE, 0);

  frame143 = gtk_frame_new (_("Size"));
  gtk_widget_set_name (frame143, "frame143");
  gtk_widget_ref (frame143);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "frame143", frame143,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame143);
  gtk_box_pack_start (GTK_BOX (hbox324), frame143, FALSE, TRUE, 0);

  table138 = gtk_table_new (2, 2, TRUE);
  gtk_widget_set_name (table138, "table138");
  gtk_widget_ref (table138);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "table138", table138,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table138);
  gtk_container_add (GTK_CONTAINER (frame143), table138);
  gtk_container_set_border_width (GTK_CONTAINER (table138), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table138), 5);

  height = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table138), height, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);

  width = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table138), width, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);

  label580 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label580, "label580");
  gtk_widget_ref (label580);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "label580", label580,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label580);
  gtk_table_attach (GTK_TABLE (table138), label580, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label580), 0, 0.5);

  label581 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label581, "label581");
  gtk_widget_ref (label581);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "label581", label581,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label581);
  gtk_table_attach (GTK_TABLE (table138), label581, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label581), 0, 0.5);

  table139 = gtk_table_new (2, 2, FALSE);
  gtk_widget_set_name (table139, "table139");
  gtk_widget_ref (table139);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "table139", table139,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table139);
  gtk_box_pack_start (GTK_BOX (hbox324), table139, TRUE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table139), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table139), 5);

  resolution_combo = gtk_combo_new ();
  gtk_widget_set_name (resolution_combo, "resolution_combo");
  gtk_widget_ref (resolution_combo);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "resolution_combo", resolution_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_combo);
  gtk_table_attach (GTK_TABLE (table139), resolution_combo, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (resolution_combo, 50, -2);
  fill_combo (resolution_combo, 1, 8);

  resolution_entry = GTK_COMBO (resolution_combo)->entry;
  gtk_widget_set_name (resolution_entry, "resolution_entry");
  gtk_widget_ref (resolution_entry);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "resolution_entry", resolution_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resolution_entry);
  gtk_tooltips_set_tip (tooltips, resolution_entry, _("Applet resolution"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (resolution_entry), FALSE);

  speed_combo = gtk_combo_new ();
  gtk_widget_set_name (speed_combo, "speed_combo");
  gtk_widget_ref (speed_combo);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "speed_combo", speed_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (speed_combo);
  gtk_table_attach (GTK_TABLE (table139), speed_combo, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (speed_combo, 50, -2);
  fill_combo (speed_combo, 1, 8);

  speed_entry = GTK_COMBO (speed_combo)->entry;
  gtk_widget_set_name (speed_entry, "speed_entry");
  gtk_widget_ref (speed_entry);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "speed_entry", speed_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (speed_entry);
  gtk_entry_set_editable (GTK_ENTRY (speed_entry), FALSE);

  label582 = gtk_label_new (_("Res."));
  gtk_widget_set_name (label582, "label582");
  gtk_widget_ref (label582);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "label582", label582,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label582);
  gtk_table_attach (GTK_TABLE (table139), label582, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label582), 0, 0.5);

  label583 = gtk_label_new (_("Speed"));
  gtk_widget_set_name (label583, "label583");
  gtk_widget_ref (label583);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "label583", label583,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label583);
  gtk_table_attach (GTK_TABLE (table139), label583, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label583), 0, 0.5);

  frame142 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame142, "frame142");
  gtk_widget_ref (frame142);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "frame142", frame142,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame142);
  gtk_box_pack_start (GTK_BOX (vbox211), frame142, FALSE, TRUE, 0);

  table137 = gtk_table_new (2, 3, FALSE);
  gtk_widget_set_name (table137, "table137");
  gtk_widget_ref (table137);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "table137", table137,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table137);
  gtk_container_add (GTK_CONTAINER (frame142), table137);
  gtk_container_set_border_width (GTK_CONTAINER (table137), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table137), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table137), 5);

  gen1 = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (gen1, "gen1");
  gtk_widget_ref (gen1);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "gen1", gen1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (gen1);
  gtk_table_attach (GTK_TABLE (table137), gen1, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (gen1, 50, -2);
  gtk_tooltips_set_tip (tooltips, gen1, _("Smooth value (8 .. 2000)"), NULL);

  gen2 = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (gen2, "gen2");
  gtk_widget_ref (gen2);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "gen2", gen2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (gen2);
  gtk_table_attach (GTK_TABLE (table137), gen2, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (gen2, 50, -2);
  gtk_tooltips_set_tip (tooltips, gen2, _("X stretching (3 .. 256)"), NULL);

  label577 = gtk_label_new (_("Gen 1"));
  gtk_widget_set_name (label577, "label577");
  gtk_widget_ref (label577);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "label577", label577,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label577);
  gtk_table_attach (GTK_TABLE (table137), label577, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label577), 0, 0.5);

  label578 = gtk_label_new (_("Gen 2"));
  gtk_widget_set_name (label578, "label578");
  gtk_widget_ref (label578);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "label578", label578,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label578);
  gtk_table_attach (GTK_TABLE (table137), label578, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label578), 0, 0.5);

  label579 = gtk_label_new (_("Gen 3"));
  gtk_widget_set_name (label579, "label579");
  gtk_widget_ref (label579);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "label579", label579,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label579);
  gtk_table_attach (GTK_TABLE (table137), label579, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label579), 0, 0.5);

  gen3 = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (gen3, "gen3");
  gtk_widget_ref (gen3);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "gen3", gen3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (gen3);
  gtk_table_attach (GTK_TABLE (table137), gen3, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (gen3, 50, -2);
  gtk_tooltips_set_tip (tooltips, gen3, _("Y stretching (3 .. 256)"), NULL);

  vbox207 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox207, "vbox207");
  gtk_widget_ref (vbox207);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "vbox207", vbox207,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox207);
  gtk_box_pack_end (GTK_BOX (hbox322), vbox207, FALSE, TRUE, 0);

  frame138 = gtk_frame_new (_("Palette"));
  gtk_widget_set_name (frame138, "frame138");
  gtk_widget_ref (frame138);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "frame138", frame138,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame138);
  gtk_box_pack_start (GTK_BOX (vbox207), frame138, FALSE, TRUE, 0);

  hbox323 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox323, "hbox323");
  gtk_widget_ref (hbox323);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "hbox323", hbox323,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox323);
  gtk_container_add (GTK_CONTAINER (frame138), hbox323);
  gtk_container_set_border_width (GTK_CONTAINER (hbox323), 5);

  frame139 = gtk_frame_new (_("Red"));
  gtk_widget_set_name (frame139, "frame139");
  gtk_widget_ref (frame139);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "frame139", frame139,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame139);
  gtk_box_pack_start (GTK_BOX (hbox323), frame139, FALSE, TRUE, 0);

  vbox208 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox208, "vbox208");
  gtk_widget_ref (vbox208);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "vbox208", vbox208,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox208);
  gtk_container_add (GTK_CONTAINER (frame139), vbox208);
  gtk_container_set_border_width (GTK_CONTAINER (vbox208), 5);

  r0 = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (r0, "r0");
  gtk_widget_ref (r0);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "r0", r0,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (r0);
  gtk_box_pack_start (GTK_BOX (vbox208), r0, FALSE, FALSE, 0);
  gtk_widget_set_usize (r0, 50, -2);
  gtk_tooltips_set_tip (tooltips, r0, _("Multipliers of tonality (0 .. 255)"), NULL);

  r1 = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (r1, "r1");
  gtk_widget_ref (r1);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "r1", r1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (r1);
  gtk_box_pack_start (GTK_BOX (vbox208), r1, FALSE, FALSE, 0);
  gtk_widget_set_usize (r1, 50, -2);
  gtk_tooltips_set_tip (tooltips, r1, _("Value added to tonality (0 .. 255)"), NULL);

  red_combo = gtk_combo_new ();
  gtk_widget_set_name (red_combo, "red_combo");
  gtk_widget_ref (red_combo);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "red_combo", red_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (red_combo);
  gtk_box_pack_start (GTK_BOX (vbox208), red_combo, FALSE, FALSE, 0);
  gtk_widget_set_usize (red_combo, 50, -2);
  fill_combo (red_combo, 1, 8);

  red_entry = GTK_COMBO (red_combo)->entry;
  gtk_widget_set_name (red_entry, "red_entry");
  gtk_widget_ref (red_entry);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "red_entry", red_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (red_entry);
  gtk_tooltips_set_tip (tooltips, red_entry, _("Smoothing value of tonality"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (red_entry), FALSE);

  frame140 = gtk_frame_new (_("Green"));
  gtk_widget_set_name (frame140, "frame140");
  gtk_widget_ref (frame140);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "frame140", frame140,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame140);
  gtk_box_pack_start (GTK_BOX (hbox323), frame140, FALSE, TRUE, 0);

  vbox209 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox209, "vbox209");
  gtk_widget_ref (vbox209);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "vbox209", vbox209,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox209);
  gtk_container_add (GTK_CONTAINER (frame140), vbox209);
  gtk_container_set_border_width (GTK_CONTAINER (vbox209), 5);

  g0 = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (g0, "g0");
  gtk_widget_ref (g0);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "g0", g0,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (g0);
  gtk_box_pack_start (GTK_BOX (vbox209), g0, FALSE, FALSE, 0);
  gtk_widget_set_usize (g0, 50, -2);
  gtk_tooltips_set_tip (tooltips, g0, _("Multipliers of tonality (0 .. 255)"), NULL);

  g1 = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (g1, "g1");
  gtk_widget_ref (g1);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "g1", g1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (g1);
  gtk_box_pack_start (GTK_BOX (vbox209), g1, FALSE, FALSE, 0);
  gtk_widget_set_usize (g1, 50, -2);
  gtk_tooltips_set_tip (tooltips, g1, _("Value added to tonality (0 .. 255)"), NULL);

  green_combo = gtk_combo_new ();
  gtk_widget_set_name (green_combo, "green_combo");
  gtk_widget_ref (green_combo);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "green_combo", green_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (green_combo);
  gtk_box_pack_start (GTK_BOX (vbox209), green_combo, FALSE, FALSE, 0);
  gtk_widget_set_usize (green_combo, 50, -2);
  fill_combo (green_combo, 1, 8);

  green_entry = GTK_COMBO (green_combo)->entry;
  gtk_widget_set_name (green_entry, "green_entry");
  gtk_widget_ref (green_entry);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "green_entry", green_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (green_entry);
  gtk_tooltips_set_tip (tooltips, green_entry, _("Smoothing value of tonality"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (green_entry), FALSE);

  frame141 = gtk_frame_new (_("Blue"));
  gtk_widget_set_name (frame141, "frame141");
  gtk_widget_ref (frame141);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "frame141", frame141,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame141);
  gtk_box_pack_start (GTK_BOX (hbox323), frame141, FALSE, TRUE, 0);

  vbox210 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox210, "vbox210");
  gtk_widget_ref (vbox210);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "vbox210", vbox210,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox210);
  gtk_container_add (GTK_CONTAINER (frame141), vbox210);
  gtk_container_set_border_width (GTK_CONTAINER (vbox210), 5);

  b0 = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (b0, "b0");
  gtk_widget_ref (b0);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "b0", b0,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (b0);
  gtk_box_pack_start (GTK_BOX (vbox210), b0, FALSE, FALSE, 0);
  gtk_widget_set_usize (b0, 50, -2);
  gtk_tooltips_set_tip (tooltips, b0, _("Multipliers of tonality (0 .. 255)"), NULL);

  b1 = gtk_entry_new_with_max_length (3);
  gtk_widget_set_name (b1, "b1");
  gtk_widget_ref (b1);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "b1", b1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (b1);
  gtk_box_pack_start (GTK_BOX (vbox210), b1, FALSE, FALSE, 0);
  gtk_widget_set_usize (b1, 50, -2);
  gtk_tooltips_set_tip (tooltips, b1, _("Value added to tonality (0 .. 255)"), NULL);

  blue_combo = gtk_combo_new ();
  gtk_widget_set_name (blue_combo, "blue_combo");
  gtk_widget_ref (blue_combo);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "blue_combo", blue_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (blue_combo);
  gtk_box_pack_start (GTK_BOX (vbox210), blue_combo, FALSE, FALSE, 0);
  gtk_widget_set_usize (blue_combo, 50, -2);
  fill_combo (blue_combo, 1, 8);

  blue_entry = GTK_COMBO (blue_combo)->entry;
  gtk_widget_set_name (blue_entry, "blue_entry");
  gtk_widget_ref (blue_entry);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "blue_entry", blue_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (blue_entry);
  gtk_tooltips_set_tip (tooltips, blue_entry, _("Smoothing value of tonality"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (blue_entry), FALSE);

  textscroll = gtk_check_button_new_with_label (_("Enable textscroll"));
  gtk_widget_set_name (textscroll, "textscroll");
  gtk_widget_ref (textscroll);
  gtk_object_set_data_full (GTK_OBJECT (plasma), "textscroll", textscroll,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (textscroll);
  gtk_box_pack_start (GTK_BOX (vbox207), textscroll, FALSE, FALSE, 0);

  finish_dialog (plasma, vbox205, accel_group);

  gtk_signal_connect (GTK_OBJECT (textscroll), "toggled",
                      GTK_SIGNAL_FUNC (on_textscroll), NULL);

  gtk_window_add_accel_group (GTK_WINDOW (plasma), accel_group);
  gtk_object_set_data (GTK_OBJECT (plasma), "tooltips", tooltips);

  return plasma;
}

GtkWidget* create_solidscroller ()
{
  GtkWidget *solidscroller;
  GtkWidget *vbox212;
  GtkWidget *hbox325;
  GtkWidget *vbox213;
  GtkWidget *frame144;
  GtkWidget *table140;
  GtkWidget *height;
  GtkWidget *label585;
  GtkWidget *width;
  GtkWidget *label584;
  GtkWidget *table142;
  GtkWidget *v_spac;
  GtkWidget *speed;
  GtkWidget *y_offset;
  GtkWidget *label590;
  GtkWidget *label589;
  GtkWidget *label588;
  GtkWidget *hbox329;
  GtkWidget *back_color;
  GtkWidget *vbox214;
  GtkWidget *hbox330;
  GtkWidget *label594;
  GtkWidget *type_combo;
  GList *type_combo_items = NULL;
  GtkWidget *type_entry;
  GtkWidget *frame149;
  GtkWidget *table143;
  GtkWidget *reverse;
  GtkWidget *wave_speed;
  GtkWidget *wave_mode_combo;
  GList *wave_mode_combo_items = NULL;
  GtkWidget *wave_mode_entry;
  GtkWidget *wave_type_combo;
  GList *wave_type_combo_items = NULL;
  GtkWidget *wave_type_entry;
  GtkWidget *label591;
  GtkWidget *label592;
  GtkWidget *label593;
  GtkWidget *hbox331;
  GtkWidget *frame150;
  GtkWidget *table144;
  GtkWidget *label595;
  GtkWidget *label596;
  GtkWidget *jump_amp;
  GtkWidget *jump_speed;
  GtkWidget *frame151;
  GtkWidget *table145;
  GtkWidget *label598;
  GtkWidget *label597;
  GtkWidget *mirror_height;
  GtkWidget *mirror_mode_combo;
  GList *mirror_mode_combo_items = NULL;
  GtkWidget *mirror_mode_entry;
  GtkWidget *color_pixmap;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;

  solidscroller = init_dialog (&accel_group, &tooltips, &vbox212);

  hbox325 = gtk_hbox_new (FALSE, 20);
  gtk_widget_set_name (hbox325, "hbox325");
  gtk_widget_ref (hbox325);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "hbox325", hbox325,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox325);
  gtk_box_pack_start (GTK_BOX (vbox212), hbox325, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox325), 5);

  vbox213 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox213, "vbox213");
  gtk_widget_ref (vbox213);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "vbox213", vbox213,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox213);
  gtk_box_pack_start (GTK_BOX (hbox325), vbox213, FALSE, TRUE, 5);

  frame144 = gtk_frame_new (_("Size"));
  gtk_widget_set_name (frame144, "frame144");
  gtk_widget_ref (frame144);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "frame144", frame144,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame144);
  gtk_box_pack_start (GTK_BOX (vbox213), frame144, FALSE, TRUE, 0);

  table140 = gtk_table_new (2, 2, TRUE);
  gtk_widget_set_name (table140, "table140");
  gtk_widget_ref (table140);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "table140", table140,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table140);
  gtk_container_add (GTK_CONTAINER (frame144), table140);
  gtk_container_set_border_width (GTK_CONTAINER (table140), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table140), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table140), 5);

  height = gtk_entry_new ();
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table140), height, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);

  label585 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label585, "label585");
  gtk_widget_ref (label585);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label585", label585,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label585);
  gtk_table_attach (GTK_TABLE (table140), label585, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label585), 0, 0.5);

  width = gtk_entry_new ();
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table140), width, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);

  label584 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label584, "label584");
  gtk_widget_ref (label584);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label584", label584,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label584);
  gtk_table_attach (GTK_TABLE (table140), label584, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label584), 0, 0.5);

  table142 = gtk_table_new (3, 2, FALSE);
  gtk_widget_set_name (table142, "table142");
  gtk_widget_ref (table142);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "table142", table142,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table142);
  gtk_box_pack_start (GTK_BOX (vbox213), table142, FALSE, TRUE, 0);
  gtk_table_set_row_spacings (GTK_TABLE (table142), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table142), 5);

  v_spac = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (v_spac, "v_spac");
  gtk_widget_ref (v_spac);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "v_spac", v_spac,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (v_spac);
  gtk_table_attach (GTK_TABLE (table142), v_spac, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (v_spac, 50, -2);
  gtk_tooltips_set_tip (tooltips, v_spac, _("Vertical spacing in \"vertical\" mode"), NULL);

  speed = gtk_entry_new_with_max_length (2);
  gtk_widget_set_name (speed, "speed");
  gtk_widget_ref (speed);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "speed", speed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (speed);
  gtk_table_attach (GTK_TABLE (table142), speed, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (speed, 50, -2);
  gtk_tooltips_set_tip (tooltips, speed, _("Scroll text speed"), NULL);

  y_offset = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (y_offset, "y_offset");
  gtk_widget_ref (y_offset);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "y_offset", y_offset,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (y_offset);
  gtk_table_attach (GTK_TABLE (table142), y_offset, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (y_offset, 50, -2);
  gtk_tooltips_set_tip (tooltips, y_offset, _("Y offset of scroll text"), NULL);

  label590 = gtk_label_new (_("Y offset"));
  gtk_widget_set_name (label590, "label590");
  gtk_widget_ref (label590);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label590", label590,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label590);
  gtk_table_attach (GTK_TABLE (table142), label590, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label590), 0, 0.5);

  label589 = gtk_label_new (_("Speed"));
  gtk_widget_set_name (label589, "label589");
  gtk_widget_ref (label589);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label589", label589,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label589);
  gtk_table_attach (GTK_TABLE (table142), label589, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label589), 0, 0.5);

  label588 = gtk_label_new (_("V. Spac."));
  gtk_widget_set_name (label588, "label588");
  gtk_widget_ref (label588);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label588", label588,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label588);
  gtk_table_attach (GTK_TABLE (table142), label588, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label588), 0, 0.5);

  hbox329 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox329, "hbox329");
  gtk_widget_ref (hbox329);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "hbox329", hbox329,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox329);
  gtk_box_pack_start (GTK_BOX (vbox213), hbox329, TRUE, TRUE, 0);

  back_color = gtk_button_new_with_label (_("Back. color..."));
  gtk_widget_set_name (back_color, "back_color");
  gtk_widget_ref (back_color);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "back_color", back_color,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_color);
  gtk_box_pack_start (GTK_BOX (hbox329), back_color, FALSE, FALSE, 0);
  gtk_widget_set_usize (back_color, 90, -2);
  gtk_tooltips_set_tip (tooltips, back_color, _("Background color"), NULL);

  color_pixmap = set_color_pixmap ((GtkWidget*)NULL, 0, 0, 0);
  gtk_widget_set_name (color_pixmap, "color_pixmap");
  gtk_widget_ref (color_pixmap);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "color_pixmap", color_pixmap,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (color_pixmap);
  gtk_box_pack_end (GTK_BOX (hbox329), color_pixmap, FALSE, FALSE, 0);

  vbox214 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox214, "vbox214");
  gtk_widget_ref (vbox214);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "vbox214", vbox214,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox214);
  gtk_box_pack_end (GTK_BOX (hbox325), vbox214, FALSE, TRUE, 5);

  hbox330 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox330, "hbox330");
  gtk_widget_ref (hbox330);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "hbox330", hbox330,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox330);
  gtk_box_pack_start (GTK_BOX (vbox214), hbox330, FALSE, TRUE, 0);

  label594 = gtk_label_new (_("Type"));
  gtk_widget_set_name (label594, "label594");
  gtk_widget_ref (label594);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label594", label594,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label594);
  gtk_box_pack_start (GTK_BOX (hbox330), label594, FALSE, FALSE, 0);

  type_combo = gtk_combo_new ();
  gtk_widget_set_name (type_combo, "type_combo");
  gtk_widget_ref (type_combo);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "type_combo", type_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (type_combo);
  gtk_box_pack_start (GTK_BOX (hbox330), type_combo, TRUE, TRUE, 0);
  type_combo_items = g_list_append (type_combo_items, _("horizontal"));
  type_combo_items = g_list_append (type_combo_items, _("vertical"));
  type_combo_items = g_list_append (type_combo_items, _("waving"));
  type_combo_items = g_list_append (type_combo_items, _("jumping"));
  gtk_combo_set_popdown_strings (GTK_COMBO (type_combo), type_combo_items);
  g_list_free (type_combo_items);

  type_entry = GTK_COMBO (type_combo)->entry;
  gtk_widget_set_name (type_entry, "type_entry");
  gtk_widget_ref (type_entry);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "type_entry", type_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (type_entry);
  gtk_tooltips_set_tip (tooltips, type_entry, _("Text effect mode"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (type_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (type_entry), _("horizontal"));

  frame149 = gtk_frame_new (_("Wave"));
  gtk_widget_set_name (frame149, "frame149");
  gtk_widget_ref (frame149);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "frame149", frame149,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame149);
  gtk_box_pack_start (GTK_BOX (vbox214), frame149, FALSE, FALSE, 0);

  table143 = gtk_table_new (2, 4, FALSE);
  gtk_widget_set_name (table143, "table143");
  gtk_widget_ref (table143);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "table143", table143,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table143);
  gtk_container_add (GTK_CONTAINER (frame149), table143);
  gtk_container_set_border_width (GTK_CONTAINER (table143), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table143), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table143), 15);

  reverse = gtk_check_button_new_with_label (_("Reverse"));
  gtk_widget_set_name (reverse, "reverse");
  gtk_widget_ref (reverse);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "reverse", reverse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reverse);
  gtk_table_attach (GTK_TABLE (table143), reverse, 2, 4, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  wave_speed = gtk_entry_new_with_max_length (2);
  gtk_widget_set_name (wave_speed, "wave_speed");
  gtk_widget_ref (wave_speed);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "wave_speed", wave_speed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wave_speed);
  gtk_table_attach (GTK_TABLE (table143), wave_speed, 3, 4, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (wave_speed, 50, -2);
  gtk_tooltips_set_tip (tooltips, wave_speed, _("Wave speed"), NULL);

  wave_mode_combo = gtk_combo_new ();
  gtk_widget_set_name (wave_mode_combo, "wave_mode_combo");
  gtk_widget_ref (wave_mode_combo);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "wave_mode_combo", wave_mode_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wave_mode_combo);
  gtk_table_attach (GTK_TABLE (table143), wave_mode_combo, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (wave_mode_combo, 100, -2);
  wave_mode_combo_items = g_list_append (wave_mode_combo_items, _("horizontal"));
  wave_mode_combo_items = g_list_append (wave_mode_combo_items, _("vertical"));
  gtk_combo_set_popdown_strings (GTK_COMBO (wave_mode_combo), wave_mode_combo_items);
  g_list_free (wave_mode_combo_items);

  wave_mode_entry = GTK_COMBO (wave_mode_combo)->entry;
  gtk_widget_set_name (wave_mode_entry, "wave_mode_entry");
  gtk_widget_ref (wave_mode_entry);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "wave_mode_entry", wave_mode_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wave_mode_entry);
  gtk_tooltips_set_tip (tooltips, wave_mode_entry, _("Waving mode (horizontal, vertical)"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (wave_mode_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (wave_mode_entry), _("horizontal"));

  wave_type_combo = gtk_combo_new ();
  gtk_widget_set_name (wave_type_combo, "wave_type_combo");
  gtk_widget_ref (wave_type_combo);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "wave_type_combo", wave_type_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wave_type_combo);
  gtk_table_attach (GTK_TABLE (table143), wave_type_combo, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (wave_type_combo, 100, -2);
  wave_type_combo_items = g_list_append (wave_type_combo_items, _("swing"));
  wave_type_combo_items = g_list_append (wave_type_combo_items, _("short"));
  wave_type_combo_items = g_list_append (wave_type_combo_items, _("long"));
  wave_type_combo_items = g_list_append (wave_type_combo_items, _("classic"));
  wave_type_combo_items = g_list_append (wave_type_combo_items, _("smooth"));
  wave_type_combo_items = g_list_append (wave_type_combo_items, _("halfsmooth"));
  gtk_combo_set_popdown_strings (GTK_COMBO (wave_type_combo), wave_type_combo_items);
  g_list_free (wave_type_combo_items);

  wave_type_entry = GTK_COMBO (wave_type_combo)->entry;
  gtk_widget_set_name (wave_type_entry, "wave_type_entry");
  gtk_widget_ref (wave_type_entry);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "wave_type_entry", wave_type_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wave_type_entry);
  gtk_tooltips_set_tip (tooltips, wave_type_entry, _("Wave type (swing, short, long, classic, smooth, halfsmooth)"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (wave_type_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (wave_type_entry), _("swing"));

  label591 = gtk_label_new (_("Mode"));
  gtk_widget_set_name (label591, "label591");
  gtk_widget_ref (label591);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label591", label591,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label591);
  gtk_table_attach (GTK_TABLE (table143), label591, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label591), 0, 0.5);

  label592 = gtk_label_new (_("Speed"));
  gtk_widget_set_name (label592, "label592");
  gtk_widget_ref (label592);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label592", label592,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label592);
  gtk_table_attach (GTK_TABLE (table143), label592, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label592), 0, 0.5);

  label593 = gtk_label_new (_("Type"));
  gtk_widget_set_name (label593, "label593");
  gtk_widget_ref (label593);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label593", label593,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label593);
  gtk_table_attach (GTK_TABLE (table143), label593, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label593), 0, 0.5);

  hbox331 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox331, "hbox331");
  gtk_widget_ref (hbox331);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "hbox331", hbox331,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox331);
  gtk_box_pack_start (GTK_BOX (vbox214), hbox331, TRUE, TRUE, 0);

  frame150 = gtk_frame_new (_("Jump"));
  gtk_widget_set_name (frame150, "frame150");
  gtk_widget_ref (frame150);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "frame150", frame150,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame150);
  gtk_box_pack_start (GTK_BOX (hbox331), frame150, TRUE, TRUE, 0);

  table144 = gtk_table_new (2, 2, FALSE);
  gtk_widget_set_name (table144, "table144");
  gtk_widget_ref (table144);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "table144", table144,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table144);
  gtk_container_add (GTK_CONTAINER (frame150), table144);
  gtk_container_set_border_width (GTK_CONTAINER (table144), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table144), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table144), 5);

  label595 = gtk_label_new (_("Amplitude"));
  gtk_widget_set_name (label595, "label595");
  gtk_widget_ref (label595);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label595", label595,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label595);
  gtk_table_attach (GTK_TABLE (table144), label595, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label595), 0, 0.5);

  label596 = gtk_label_new (_("Speed"));
  gtk_widget_set_name (label596, "label596");
  gtk_widget_ref (label596);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label596", label596,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label596);
  gtk_table_attach (GTK_TABLE (table144), label596, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label596), 0, 0.5);

  jump_amp = gtk_entry_new_with_max_length (2);
  gtk_widget_set_name (jump_amp, "jump_amp");
  gtk_widget_ref (jump_amp);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "jump_amp", jump_amp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (jump_amp);
  gtk_table_attach (GTK_TABLE (table144), jump_amp, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (jump_amp, 50, -2);
  gtk_tooltips_set_tip (tooltips, jump_amp, _("Jump amplitude"), NULL);

  jump_speed = gtk_entry_new_with_max_length (5);
  gtk_widget_set_name (jump_speed, "jump_speed");
  gtk_widget_ref (jump_speed);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "jump_speed", jump_speed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (jump_speed);
  gtk_table_attach (GTK_TABLE (table144), jump_speed, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (jump_speed, 50, -2);
  gtk_tooltips_set_tip (tooltips, jump_speed, _("Jump speed"), NULL);

  frame151 = gtk_frame_new (_("Mirror"));
  gtk_widget_set_name (frame151, "frame151");
  gtk_widget_ref (frame151);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "frame151", frame151,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame151);
  gtk_box_pack_start (GTK_BOX (hbox331), frame151, TRUE, TRUE, 0);

  table145 = gtk_table_new (2, 2, FALSE);
  gtk_widget_set_name (table145, "table145");
  gtk_widget_ref (table145);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "table145", table145,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table145);
  gtk_container_add (GTK_CONTAINER (frame151), table145);
  gtk_container_set_border_width (GTK_CONTAINER (table145), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table145), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table145), 5);

  label598 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label598, "label598");
  gtk_widget_ref (label598);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label598", label598,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label598);
  gtk_table_attach (GTK_TABLE (table145), label598, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label598), 0, 0.5);

  label597 = gtk_label_new (_("Mode"));
  gtk_widget_set_name (label597, "label597");
  gtk_widget_ref (label597);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "label597", label597,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label597);
  gtk_table_attach (GTK_TABLE (table145), label597, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label597), 0, 0.5);

  mirror_height = gtk_entry_new ();
  gtk_widget_set_name (mirror_height, "mirror_height");
  gtk_widget_ref (mirror_height);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "mirror_height", mirror_height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mirror_height);
  gtk_table_attach (GTK_TABLE (table145), mirror_height, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (mirror_height, 50, -2);
  gtk_tooltips_set_tip (tooltips, mirror_height, _("Mirror height from the bottom"), NULL);

  mirror_mode_combo = gtk_combo_new ();
  gtk_widget_set_name (mirror_mode_combo, "mirror_mode_combo");
  gtk_widget_ref (mirror_mode_combo);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "mirror_mode_combo", mirror_mode_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mirror_mode_combo);
  gtk_table_attach (GTK_TABLE (table145), mirror_mode_combo, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (mirror_mode_combo, 50, -2);
  mirror_mode_combo_items = g_list_append (mirror_mode_combo_items, _("disabled"));
  mirror_mode_combo_items = g_list_append (mirror_mode_combo_items, _("normal"));
  mirror_mode_combo_items = g_list_append (mirror_mode_combo_items, _("perspective"));
  gtk_combo_set_popdown_strings (GTK_COMBO (mirror_mode_combo), mirror_mode_combo_items);
  g_list_free (mirror_mode_combo_items);

  mirror_mode_entry = GTK_COMBO (mirror_mode_combo)->entry;
  gtk_widget_set_name (mirror_mode_entry, "mirror_mode_entry");
  gtk_widget_ref (mirror_mode_entry);
  gtk_object_set_data_full (GTK_OBJECT (solidscroller), "mirror_mode_entry", mirror_mode_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mirror_mode_entry);
  gtk_tooltips_set_tip (tooltips, mirror_mode_entry, _("Change mirror mode (disabled, normal, perspective)"), NULL);
  gtk_entry_set_editable (GTK_ENTRY (mirror_mode_entry), FALSE);
  gtk_entry_set_text (GTK_ENTRY (mirror_mode_entry), _("disabled"));

  finish_dialog (solidscroller, vbox212, accel_group);

  gtk_signal_connect (GTK_OBJECT (back_color), "clicked",
                      GTK_SIGNAL_FUNC (on_back_color), NULL);
  gtk_signal_connect (GTK_OBJECT (type_entry), "changed",
                      GTK_SIGNAL_FUNC (OnSelchangeText_Type), NULL);
  gtk_signal_connect (GTK_OBJECT (mirror_mode_entry), "changed",
                      GTK_SIGNAL_FUNC (OnSelchangeMirrormode), NULL);

  gtk_window_add_accel_group (GTK_WINDOW (solidscroller), accel_group);
  gtk_object_set_data (GTK_OBJECT (solidscroller), "tooltips", tooltips);

  return solidscroller;
}

GtkWidget* create_textscroller ()
{
  GtkWidget *textscroller;
  GtkWidget *vbox217;
  GtkWidget *vbox219;
  GtkWidget *hbox332;
  GtkWidget *frame152;
  GtkWidget *table146;
  GtkWidget *height;
  GtkWidget *label599;
  GtkWidget *width;
  GtkWidget *label600;
  GtkWidget *frame155;
  GtkWidget *vbox220;
  GtkWidget *charset_combo;
  GtkWidget *charset_entry;
  GtkWidget *charset;
  GtkWidget *vbox0219;
  GtkWidget *hbox333;
  GtkWidget *back_color;
  GtkWidget *back_image_check;
  GtkWidget *hbox337;
  GtkWidget *back_image;
  GtkWidget *back_image_browse;
  GtkWidget *color_pixmap;
  GtkTooltips *tooltips;
  GtkAccelGroup *accel_group;

  textscroller = init_dialog (&accel_group, &tooltips, &vbox217);

  vbox219 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox219, "vbox219");
  gtk_widget_ref (vbox219);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "vbox219", vbox219,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox219);
  gtk_box_pack_start (GTK_BOX (vbox217), vbox219, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox219), 5);

  hbox332 = gtk_hbox_new (FALSE, 20);
  gtk_widget_set_name (hbox332, "hbox332");
  gtk_widget_ref (hbox332);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "hbox332", hbox332,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox332);
  gtk_box_pack_start (GTK_BOX (vbox219), hbox332, FALSE, TRUE, 0);

  frame152 = gtk_frame_new (_("Size"));
  gtk_widget_set_name (frame152, "frame152");
  gtk_widget_ref (frame152);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "frame152", frame152,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame152);
  gtk_box_pack_start (GTK_BOX (hbox332), frame152, FALSE, TRUE, 0);

  table146 = gtk_table_new (2, 2, TRUE);
  gtk_widget_set_name (table146, "table146");
  gtk_widget_ref (table146);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "table146", table146,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table146);
  gtk_container_add (GTK_CONTAINER (frame152), table146);
  gtk_container_set_border_width (GTK_CONTAINER (table146), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table146), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table146), 5);

  height = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (height, "height");
  gtk_widget_ref (height);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "height", height,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (height);
  gtk_table_attach (GTK_TABLE (table146), height, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (height, 50, -2);
  gtk_tooltips_set_tip (tooltips, height, _("Applet's y size"), NULL);

  label599 = gtk_label_new (_("Width"));
  gtk_widget_set_name (label599, "label599");
  gtk_widget_ref (label599);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "label599", label599,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label599);
  gtk_table_attach (GTK_TABLE (table146), label599, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label599), 0, 0.5);

  width = gtk_entry_new_with_max_length (4);
  gtk_widget_set_name (width, "width");
  gtk_widget_ref (width);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "width", width,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (width);
  gtk_table_attach (GTK_TABLE (table146), width, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (width, 50, -2);
  gtk_tooltips_set_tip (tooltips, width, _("Applet's x size"), NULL);

  label600 = gtk_label_new (_("Height"));
  gtk_widget_set_name (label600, "label600");
  gtk_widget_ref (label600);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "label600", label600,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label600);
  gtk_table_attach (GTK_TABLE (table146), label600, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label600), 0, 0.5);

  frame155 = gtk_frame_new (_("Character set"));
  gtk_widget_set_name (frame155, "frame155");
  gtk_widget_ref (frame155);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "frame155", frame155,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame155);
  gtk_box_pack_start (GTK_BOX (hbox332), frame155, TRUE, TRUE, 0);

  vbox220 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox220, "vbox220");
  gtk_widget_ref (vbox220);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "vbox220", vbox220,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox220);
  gtk_container_add (GTK_CONTAINER (frame155), vbox220);
  gtk_container_set_border_width (GTK_CONTAINER (vbox220), 5);

  charset_combo = gtk_combo_new ();
  gtk_widget_set_name (charset_combo, "charset_combo");
  gtk_widget_ref (charset_combo);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "charset_combo", charset_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (charset_combo);
  gtk_box_pack_start (GTK_BOX (vbox220), charset_combo, FALSE, FALSE, 0);

  charset_entry = GTK_COMBO (charset_combo)->entry;
  gtk_widget_set_name (charset_entry, "charset_entry");
  gtk_widget_ref (charset_entry);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "charset_entry", charset_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (charset_entry);

  charset = gtk_entry_new ();
  gtk_widget_set_name (charset, "charset");
  gtk_widget_ref (charset);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "charset", charset,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (charset);
  gtk_box_pack_start (GTK_BOX (vbox220), charset, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (charset, FALSE);

  vbox0219 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox0219, "vbox0219");
  gtk_widget_ref (vbox0219);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "vbox0219", vbox0219,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox0219);
  gtk_box_pack_end (GTK_BOX (hbox332), vbox0219, FALSE, TRUE, 0);

  hbox333 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox333, "hbox333");
  gtk_widget_ref (hbox333);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "hbox333", hbox333,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox333);
  gtk_box_pack_end (GTK_BOX (vbox0219), hbox333, FALSE, TRUE, 0);

  back_color = gtk_button_new_with_label (_("Back. color..."));
  gtk_widget_set_name (back_color, "back_color");
  gtk_widget_ref (back_color);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "back_color", back_color,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_color);
  gtk_box_pack_start (GTK_BOX (hbox333), back_color, FALSE, FALSE, 0);
  gtk_widget_set_usize (back_color, 90, -2);
  gtk_tooltips_set_tip (tooltips, back_color, _("Background color"), NULL);

  color_pixmap = set_color_pixmap ((GtkWidget*)NULL, 0, 0, 0);
  gtk_widget_set_name (color_pixmap, "color_pixmap");
  gtk_widget_ref (color_pixmap);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "color_pixmap", color_pixmap,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (color_pixmap);
  gtk_box_pack_end (GTK_BOX (hbox333), color_pixmap, FALSE, FALSE, 0);

  back_image_check = gtk_check_button_new_with_label (_("Back image"));
  gtk_widget_set_name (back_image_check, "back_image_check");
  gtk_widget_ref (back_image_check);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "back_image_check", back_image_check,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_image_check);
  gtk_box_pack_start (GTK_BOX (vbox219), back_image_check, FALSE, FALSE, 0);

  hbox337 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox337, "hbox337");
  gtk_widget_ref (hbox337);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "hbox337", hbox337,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox337);
  gtk_box_pack_start (GTK_BOX (vbox219), hbox337, FALSE, TRUE, 0);

  back_image = gtk_entry_new ();
  gtk_widget_set_name (back_image, "back_image");
  gtk_widget_ref (back_image);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "back_image", back_image,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_image);
  gtk_box_pack_start (GTK_BOX (hbox337), back_image, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, back_image, _("Background image path"), NULL);

  back_image_browse = gtk_button_new_with_label (_("..."));
  gtk_widget_set_name (back_image_browse, "back_image_browse");
  gtk_widget_ref (back_image_browse);
  gtk_object_set_data_full (GTK_OBJECT (textscroller), "back_image_browse", back_image_browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_image_browse);
  gtk_box_pack_start (GTK_BOX (hbox337), back_image_browse, FALSE, FALSE, 0);
  gtk_widget_set_usize (back_image_browse, 20, -2);
  gtk_tooltips_set_tip (tooltips, back_image_browse, _("Browse for background image"), NULL);

  gtk_widget_set_sensitive (back_image, FALSE);
  gtk_widget_set_sensitive (back_image_browse, FALSE);
  gtk_entry_set_editable (GTK_ENTRY (charset_entry), FALSE);

  gtk_signal_connect (GTK_OBJECT (back_color), "clicked",
                      GTK_SIGNAL_FUNC (on_back_color), NULL);
  gtk_signal_connect (GTK_OBJECT (back_image_browse), "clicked",
                      GTK_SIGNAL_FUNC (on_back_image_browse), NULL);
  gtk_signal_connect (GTK_OBJECT (back_image_check), "toggled",
                      GTK_SIGNAL_FUNC (on_back_image_toggle), NULL);
  gtk_signal_connect (GTK_OBJECT (charset_entry), "changed",
                      GTK_SIGNAL_FUNC (OnSelchangeCharsetSel), NULL);

  finish_dialog (textscroller, vbox217, accel_group);

  gtk_window_add_accel_group (GTK_WINDOW (textscroller), accel_group);
  gtk_object_set_data (GTK_OBJECT (textscroller), "tooltips", tooltips);

  return textscroller;
}
